(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: VtrBez.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 19:17:54 $
# $Revision: 1.3 $
# Bemerkungen:
*)
(******************************************************************************)
              
IMPLEMENTATION MODULE VtrBez; 

(* FM VertragsBeziehungen *)

  IMPORT Vtre;
  IMPORT HKe;
  IMPORT Ksten;
  FROM Datum IMPORT TDatum;


(********* An das Teilsystem Vertraege TS_Vtre durchgereichte Operationen ****)

PROCEDURE FirstVtrZuHK (inPersID : TPersID; VAR outVtr : TVtr) : BOOLEAN;
   (* Ersten Vertrag einer Hilfskraft ausgeben *)
BEGIN
   RETURN Vtre.FirstVtrZuHK (inPersID, outVtr); 
END FirstVtrZuHK;

PROCEDURE NextVtrZuHK  (inPersID : TPersID; inoutVtr : TVtr) : BOOLEAN;
   (* Naechsten Vertrag einer Hilfskraft ausgeben *)  
BEGIN
   RETURN Vtre. NextVtrZuHK  (inPersID, inoutVtr); 
END NextVtrZuHK;
  
PROCEDURE  FirstVtrZuKst (inKstID : TKstID; VAR outVtr : TVtr) : BOOLEAN;
    (* Ersten Vertrag einer Kostenstelle ausgeben *)  
BEGIN
   RETURN Vtre.FirstVtrZuKst (inKstID, outVtr);
END FirstVtrZuKst;

PROCEDURE  NextVtrZuKst  (inKstID : TKstID; inoutVtr : TVtr) : BOOLEAN;
    (* Naechsten Vertrag einer Kostenstelle ausgeben *)  
BEGIN
   RETURN Vtre.NextVtrZuKst  (inKstID, inoutVtr);
END NextVtrZuKst;

PROCEDURE  FirstVtrZuHKinZeitraum (inPersID : TPersID; inAnfang,inEnde :TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtre.FirstVtrZuHKinZeitraum (inPersID, inAnfang, inEnde, outVtr);
END FirstVtrZuHKinZeitraum;

PROCEDURE  NextVtrZuHKinZeitraum  (inPersID : TPersID; inAnfang,inEnde : TDatum; inoutVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtre.NextVtrZuHKinZeitraum  (inPersID, inAnfang, inEnde,inoutVtr);
END NextVtrZuHKinZeitraum;

PROCEDURE  FirstVtrZuKstinZeitraum (inKstID : TKstID; inAnfang,inEnde : TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtre.FirstVtrZuKstinZeitraum (inKstID, inAnfang, inEnde, outVtr);
END FirstVtrZuKstinZeitraum;

PROCEDURE  NextVtrZuKstinZeitraum  (inKstID : TKstID; inAnfang,inEnde : TDatum; inoutVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtre.NextVtrZuKstinZeitraum  (inKstID, inAnfang, inEnde, inoutVtr);
END NextVtrZuKstinZeitraum;

PROCEDURE  FirstVtrZuHKinZeitpunkt (inPersID : TPersID; inDatum : TDatum; VAR outVTR : TVtr ) : BOOLEAN;
BEGIN
   RETURN FirstVtrZuHKinZeitpunkt (inPersID, inDatum, outVTR);
END FirstVtrZuHKinZeitpunkt;

PROCEDURE  NextVtrZuHKinZeitpunkt (inPersID : TPersID; inDatum : TDatum; inoutVTR : TVtr ) : BOOLEAN;
BEGIN
   RETURN Vtre.NextVtrZuHKinZeitpunkt (inPersID, inDatum, inoutVTR);
END NextVtrZuHKinZeitpunkt;

PROCEDURE BerMaxStdZahlDerHK(inVtr: TVtr): INTEGER;
(* Gabi
S. 45: ab (*HK nach VKond prefn *)
bis .. Stunden := Max()... (=Rckgabe)
    END (*FOR*)
AnzahlMonate wird nicht benoetigt !!!!
*)                                                                                         
BEGIN
   RETURN Vtre.BerMaxStdZahlDerHK(inVtr);
END BerMaxStdZahlDerHK;

PROCEDURE BerMaxBeschZeitDerHK (inHKID : TPersID;
                                VAR outVonDatum, outBisDatum : TDatum) : BOOLEAN;
BEGIN
   RETURN Vtre.BerMaxBeschZeitDerHK (inHKID, outVonDatum, outBisDatum);
END BerMaxBeschZeitDerHK;

PROCEDURE  ExistVtrZuHK (inHKID:TPersID):BOOLEAN;
(* Prueft, ob zu der HK inHKID jemals ein Vertrag existiert hat. Dabei ist es voellig egal, ob der Vertrag storniert ist usw. Dies Voraussetzung fr Loesche HK *)
BEGIN
   RETURN Vtre. ExistVtrZuHK (inHKID); 
END ExistVtrZuHK;

PROCEDURE FirstValidVtrZuHK (inPersID : TPersID; VAR outVtr : TVtr) : BOOLEAN; 
   (* Ersten gueltigter Vertrag (nicht storniert) einer Hilfskraft ausgeben *)
BEGIN
   RETURN Vtre.FirstValidVtrZuHK (inPersID, outVtr);
END FirstValidVtrZuHK;
 
PROCEDURE NextValidVtrZuHK  (inPersID : TPersID; inoutVtr : TVtr) : BOOLEAN; 
   (* Naechsten gueltiger Vertrag (nicht storniert) einer Hilfskraft ausgeben *)
BEGIN
   RETURN Vtre.NextValidVtrZuHK  (inPersID, inoutVtr);
END NextValidVtrZuHK;
 
PROCEDURE FirstVldVtrZuHKinZtraum (inPersID : TPersID; inAnfang,inEnde :TDatum; VAR outVtr : TVtr) : BOOLEAN; 
BEGIN
   RETURN Vtre. FirstVldVtrZuHKinZtraum (inPersID, inAnfang, inEnde, outVtr);
END FirstVldVtrZuHKinZtraum;
 
PROCEDURE NextVldVtrZuHKinZtraum  (inPersID : TPersID; inAnfang,inEnde : TDatum; inoutVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtre. NextVldVtrZuHKinZtraum  (inPersID, inAnfang, inEnde, inoutVtr);  
END NextVldVtrZuHKinZtraum;
 
PROCEDURE FirstVldVtrZuHKinZtpunkt (inPersID : TPersID; inDatum : TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtre. FirstVldVtrZuHKinZtpunkt (inPersID, inDatum, outVtr);
END FirstVldVtrZuHKinZtpunkt;
 
PROCEDURE NextVldVtrZuHKinZtpunkt  (inPersID : TPersID; inDatum : TDatum; inoutVtr : TVtr): BOOLEAN;
BEGIN
   RETURN Vtre.NextVldVtrZuHKinZtpunkt (inPersID, inDatum, inoutVtr);
END NextVldVtrZuHKinZtpunkt; 
(********* Ende der Durchreichungen an das Teilsystem Vertraege TS_Vtre  ****)


END VtrBez.

