(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: AdmIMPORTE.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:47:51 $
# $Revision: 1.1.1.1 $
# Bemerkungen: Funktionen der Administratorfunktion.
        hgw, 13.1.2001 19:15 
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE AdmIMPORTE;

(* Modul zur Bndelung der Importe des TS_Adm *)

FROM Datum 		IMPORT 	TDatum;
FROM VDat 		IMPORT 	OpenInVDat, CloseInVDat ;
FROM VDat 		IMPORT 	EofInVDat, SetWriteInVDat, SetReadInVDat;
FROM SysDat		IMPORT 	SaveInSysDat, NeuesBackupInSysDat, TVersion,
				LiesBackupVersionInSysDat, LoadInSysDat, 
				VersionAlsString, IsZeroVersionInSysDat;
FROM String 		IMPORT 	TString;
FROM Konden		IMPORT 	(* CreateKonditionsOrdner,*) LoadInKonden, 
				SaveInKonden;
FROM Vtre		IMPORT 	(* CreateVertragsOrdner, *) LoadinVtre, 
				SaveinVtre;
FROM Buen		IMPORT 	(* CreateBuchungsOrdner, *) LoadinBuen, 
				SaveinBuen;
FROM Ksten		IMPORT 	(* CreateKostenstellenOrdner, *) LoadinKsten,
				 SaveinKsten;
FROM HKe		IMPORT 	(* CreateHilfskraftOrdner, *) LoadinHKe, 
				SaveinHKe;
FROM VDruck		IMPORT  initDrucker;
FROM HIDVerwaltung 	IMPORT 	(* CreateIDVerwaltung, *) LoadInHID,
				SaveInHID;


PROCEDURE Open(VAR inoutH:THandle; inN: TString; inM:TModus):BOOLEAN;
BEGIN
	RETURN OpenInVDat(inoutH, inN, inM);
END Open;

PROCEDURE Close(inH:THandle):BOOLEAN;
BEGIN
	RETURN CloseInVDat(inH);
END Close;

PROCEDURE Eof(inH:THandle):BOOLEAN;
BEGIN
	RETURN EofInVDat(inH);
END Eof;

PROCEDURE CreateKondenOrdner();
BEGIN
	(* CreateKonditionsOrdner(); *)
END  CreateKondenOrdner;

PROCEDURE LoadKonditionen(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN LoadInKonden(inH,inoutM);
END LoadKonditionen;

PROCEDURE SaveKonditionen(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN SaveInKonden(inH,inoutM);
END SaveKonditionen;

PROCEDURE CreateVtreOrdner();
BEGIN

	(* CreateVertragsOrdner(); *)
END CreateVtreOrdner ;

PROCEDURE LoadVertraege(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN LoadinVtre(inH,inoutM);
END LoadVertraege;

PROCEDURE SaveVertraege(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN SaveinVtre(inH,inoutM);
END SaveVertraege;

PROCEDURE CreateBuenOrdner();
BEGIN
	(* CreateBuchungsOrdner(); *)
END CreateBuenOrdner;

PROCEDURE LoadBuchungen(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN LoadinBuen(inH,inoutM);
END LoadBuchungen;

PROCEDURE SaveBuchungen(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN SaveinBuen(inH,inoutM);
END SaveBuchungen;

PROCEDURE CreateKstenOrdner();
BEGIN
	(* CreateKostenstellenOrdner(); *)
END CreateKstenOrdner;

PROCEDURE LoadKostenstellen(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN LoadinKsten(inH,inoutM);
END LoadKostenstellen;

PROCEDURE SaveKostenstellen(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN SaveinKsten(inH,inoutM);
END SaveKostenstellen;

PROCEDURE CreateHKeOrdner();
BEGIN
	(* CreateHilfskraftOrdner(); *)
END CreateHKeOrdner;

PROCEDURE LoadHilfskraefte(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN LoadinHKe(inH,inoutM);
END LoadHilfskraefte;

PROCEDURE SaveHilfskraefte(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN SaveinHKe(inH,inoutM);
END SaveHilfskraefte;

PROCEDURE LoadBackupTable(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN LoadInSysDat(inH, inoutM) ;
END LoadBackupTable;

PROCEDURE SaveBackupTable(inH:THandle; VAR inoutM: TString):BOOLEAN;
BEGIN
	RETURN SaveInSysDat(inH, inoutM) ;
END SaveBackupTable;

PROCEDURE NeuesBackup();
BEGIN
	NeuesBackupInSysDat();
END NeuesBackup;

PROCEDURE LiesBackupVersion():TVersion;
BEGIN
	RETURN LiesBackupVersionInSysDat() ;
END LiesBackupVersion;

PROCEDURE IsZeroVersion(inV:TVersion):BOOLEAN;
BEGIN
	RETURN IsZeroVersionInSysDat(inV) ;
END IsZeroVersion;

PROCEDURE Version2String(inV : TVersion):TString;
BEGIN
	RETURN VersionAlsString(inV);
END Version2String;

PROCEDURE SetRead():TModus;
BEGIN
	RETURN SetReadInVDat() ;
END SetRead;

PROCEDURE SetWrite():TModus;
BEGIN
	RETURN SetWriteInVDat();
END SetWrite;

PROCEDURE DruckerInit(outM:TString):BOOLEAN;
BEGIN
	RETURN initDrucker(outM);
END DruckerInit;

PROCEDURE CreateIDVerwalt();
BEGIN
	(* CreateIDVerwaltung(); *)
END CreateIDVerwalt;

PROCEDURE LoadHIDVerwaltung(inH:THandle;outM:TString):BOOLEAN;
BEGIN
	RETURN LoadInHID(inH,outM);
END LoadHIDVerwaltung;

PROCEDURE SaveHIDVerwaltung(inH:THandle;outM:TString):BOOLEAN;
BEGIN
	RETURN SaveInHID(inH,outM);
END SaveHIDVerwaltung;

END AdmIMPORTE.


