MODULE AdmTest;

   FROM InOut IMPORT ReadCard, WriteCard, WriteString, WriteLn;
   FROM InOut IMPORT ReadLn, ReadString;
   FROM SYSTEM  IMPORT TSIZE;
   IMPORT String;

   IMPORT Adm;
   IMPORT SysDat;

    
   VAR Befehl          	: CARDINAL;
       TestProcs       	: ARRAY[0..20] OF PROC;
       MaxProcNr       	: CARDINAL;

  PROCEDURE ReadIni();
  VAR message	: String.TString;
  BEGIN
    WriteString("Operation: Adm.ReadIni");
    IF Adm.ReadIniDatei(message) THEN
	WriteString("HiKS.ini Datei wurde gelesen!");
    	WriteLn;
    ELSE
	StringAusgeben(message);
	String.Dispose(message);
    END (* IF *);
    WriteLn;
  END ReadIni;

  PROCEDURE WriteIni();
  VAR message: String.TString;
  BEGIN
    WriteString("Operation: Adm.WriteIni");
    IF Adm.WriteIniDatei(message) THEN
	WriteString("HiKS.ini Datei wurde geschrieben!");
        WriteLn;
    ELSE
        StringAusgeben(message);
        String.Dispose(message);
    END (* IF *);
    WriteLn;
  END WriteIni;

  PROCEDURE InitSystem();
  VAR V		: Adm.TVersion;
      str	: String.TString;
      message	: String.TString;
  BEGIN
    WriteString("Operation: Adm.InitSystem");
    WriteLn;
    str:=String.Create();
    StringEingeben("Welche Version soll geladen werden : ", str);
    IF SysDat.VersionVonString(str,V,message) THEN
      IF Adm.InitSystemInAdm(V,message) THEN
	WriteString("System ist erfolgreich initialisiert!");
	WriteLn;
      ELSE
	WriteString(
	"Beim Initialisieren des Systems ist ein Fehler aufgetreten!");
	WriteLn;
	StringAusgeben(message);
        String.Dispose(message); 
      END (* IF *);
      SysDat.DisposeVersionInSysDat(V);
    ELSE
      StringAusgeben(message);
      String.Dispose(message);
    END (* IF *); 
    String.Dispose(str);
    WriteLn;
  END InitSystem;

  PROCEDURE BackupSystem();
  VAR message	: String.TString;
  BEGIN
    WriteString("Operation: Adm.BackupSystem");
    WriteLn;
    IF Adm.BackupSystemInAdm(message) THEN
    	WriteString("Neues Backup wurde erfolgreich angelegt!");
	WriteLn;
    ELSE
	StringAusgeben(message);
	String.Dispose(message);
    END (* IF *);
    WriteLn;
  END BackupSystem;

  PROCEDURE RestoreSystem();
  VAR	V	: Adm.TVersion;
	message	: String.TString; 
	str	: String.TString;
  BEGIN
    WriteString("Operation: Adm.RestoreSystem");
    WriteLn;
    str:=String.Create();
    StringEingeben("Welche Version soll geladen werden : ", str);
    IF SysDat.VersionVonString(str,V,message) THEN
      IF Adm.InitSystemInAdm(V,message) THEN
        WriteString("System ist erfolgreich geladen worden");
	WriteLn;
      ELSE
        WriteString(
        "Beim Restore des Systems ist ein Fehler aufgetreten!");
	WriteLn;
        StringAusgeben(message);
        String.Dispose(message);
      END (* IF *);
      SysDat.DisposeVersionInSysDat(V);
    ELSE
      StringAusgeben(message);
      String.Dispose(message);
    END (* IF *);
    String.Dispose(str); 
    WriteLn;
  END RestoreSystem;


  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("Adm.ReadIni");
    MenueItem ("Adm.WriteIni");
    MenueItem ("Adm.InitSystem");
    MenueItem ("Adm.BackupSystem");
    MenueItem ("Adm.RestoreSystem");
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (ReadIni);
    ProcEintragen (WriteIni);
    ProcEintragen (InitSystem);
    ProcEintragen (BackupSystem);
    ProcEintragen (RestoreSystem);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN

    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;

PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..50] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; inoutStr : String.TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
END StringEingeben;

BEGIN
  InitTestProcs;
  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;
END AdmTest.
