DEFINITION MODULE Auto; (* Version 2.0 *)
  FROM Datum    IMPORT TDatum, TJahr, TMonat, TTag, IsEqualDatum, LiesMonat, LiesTag, LiesJahr, AnzahlMonate,
                       ErsteWocheInMonat, NaechsteWocheInMonat,LetztesJahr, IsEqualJahr, PruefeObMonatsErster,
                       PruefeObMonatJanuar;
  FROM Konden   IMPORT TKond, HoleGueltigeWKond, LiesSTagInWKond, HoleGueltigeTKond, LiesSTagInWKond;
  FROM HKe      IMPORT THK, IsEmptyHK, FirstHK, NextHK, LiesPersID;
  FROM VtrBez   IMPORT FirstVtrZuHKInZeitpunkt, NextVtrZuHKInZeitpunkt, FirstVtrZuHKInZeitraum, NextVtrZuHKInZeitpunkt
		       FirstVtrZuHK, NextVtrZuHK;
  FROM Vtre     IMPORT LiesGueltigVonInVtr, LiesGueltigBisInVtr, LiesStdzahlInVtr, VtrIDAlsString, LiesVtrIDInVtr,
                       LiesKstIDInVtr;
  FROM Buen     IMPORT TBu, CreateBu, SetzeKstIDinBu, SetzeVtrIDInBu, SetzeBetragInBu, SetzeGebuchtAmInBu, SetzeBuchungsArtInBu,
		       InsertBu;
  FROM Ksten    IMPORT TKst, LiesJahrInKst  ;

  EXPORT

  (* gehoert in ein FM innerhalb des TS-Auto *)
  PROCEDURE WeihnachtsgeldErmitteln (inStichtag: TDatum);
  	    (* Buchen der Weihnachtsgelder z. Stichtag; Prozess D2.2.1*)
  	    (* --> Prozess D 2.2.2 (Weihnachtsgeld buchen) --> D 2.5 (Druckprozess) )*
  	

	     (*	PROZESS-SPEZIFIKATION betroffene Hilfskrfte ermitteln (D2.2.1)
		Eingaben: 	Datum von Proze D2.1
		Ausgaben:	Hilfskraft + Datum + Weihnachtsgeldkondition an Proze D2.2.2

		Vorbedingungen: ...
		Nachbedingungen:...    *)

		BEGIN
		  Ermittle die am Datum gltige Weihnachtsgeldkondition WK;
		  IF (WK.Stichtag.Tag = Datum.Tag) and (WK.Stichtag.Monat = Datum.Monat)
                   (* HoleGueltigeWKond( inD: TDatum, VAR outWKond):BOOLEAN;
		   Stichtag := LiesSTaginWKond( inKondition: TKond): TDatum )
                   (LiesMonat(Stichtag)=LiesMonat(Datum)) and (LiesTag(Stichtag)=LiesTag(Datum)) *)

                  THEN
		    FOR alle Hilfskrfte H DO    (*IsEmptyHK, FirstHK, NextHK*)
		     IF es existiert ein Vertrag V mit (V.PersonenID = H.PersonenID) and
		(* LiesPersID,
		   FirstVtrZuHKinZeitpunkt(inPersID: TPersID, inDatum: TDatum, VAR outVtr:TVtr):BOOLEAN;
		   NextVtrZuHKinZeitpunkt(inPersID: TPersID, inDatum: TDatum, VAR outVtr:TVtr):BOOLEAN;	*)
		      (WK.Stichtag IN [V.GltigVon, V.GltigBis]) THEN
 		       WeihnachtsgeldBuchen (H, WK, Datum)
		     END (*IF*)
		    END (*FOR*)
	         END (*IF*)
		END *)


  PROCEDURE WeihnachtsgeldBuchen (H, WK, Datum)
	(* Eingaben:	Hilfskraft H, Weihnachtsgeldkondition WK, Datum (*von D2.2.1)
	   Ausgaben:	Druckauftrag (* an D2.8

	   Vorbedingungen: 	...
	   Nachbedingungen:	...   *)

    BEGIN
	Monate := Anzahl Monate, die die Hilfskraft in Datum.Jahr beschaeftigt war,
		angefangene Monate werden voll gezaehlt;
        (* GetJahr(Datum); FirstVtrzuHKinZeitraum,  NextVtrzuHKinZeitpunkt
	   LiesGueltigVoninVtr (inVtr: TVtr) : TDatum;
	   LiesGueltigBisinVtr (inVtr : TVtr) : TDatum;
           AnzahlMonate( vonD,bisD:TDatum ): CARDINAL   *)
	IF Monate > 5 THEN
		(* Geleistete Stunden im Bemessungsmonat ermitteln*)
		GeleisteteStunden := 0;
		FOR alle Wochen W IN WK.Bemessungsmonat DO
			FOR alle Vertraege V mit V.PersonenID = H.PersonenID DO
				IF W IN [V.GueltigVon, V.GueltigBis] THEN
					GeleisteteStunden+ := V.Stundenzahl;
                (* ErsteWocheInMonat, NaechsteWocheInMonat
		   FirstVtrzuHKinZeitraum(Woche),  NextVtrzuHKinZeitpunkt(Woche),
		   LiesStdzahlinVtr (inVtr: TVtr) : CARDINAL;   *)

		TK := Tarifkonditionen.get (Datum); (* Am Berechnungstag geltende Tarifkondition *)
		(* HoleGueltigeTKond( inD: TDatum, VAR outTKond):BOOLEAN; *)

		Betrag := TK.Stundensatz*GeleisteteStunden; (*Monatsgehalt*)
		(* LiesStdSinTKond( inKondition: TKond):CARDINAL; *)

		Betrag := Betrag * Monate / 12; (*Weihnachtsgeld*)
		Stunden := Summe Stundenzahl aller am Stichtag geltenden Vertraege der Hilfskraft ;
 		(* FirstVtrzuHKinZeitpunkt(Stichtag), LiesStdzahlinVtr    *)
		FOR alle Vertraege V mit V.PersonenID = H.PersonenID DO
			(* LiesSTaginWKond( inKondition: TKond): TDatum ;  *)
			(* FirstVtrZuHKinZeitpunkt(inPersID: TPersID, inDatum: TDatum, VAR outVtr:TVtr):BOOLEAN;
		   	   NextVtrZuHKinZeitpunkt(inPersID: TPersID, inDatum: TDatum, VAR outVtr:TVtr):BOOLEAN;	*)
			(* Alle Kostenstellen der am Stichtag laufenden Vertraege anteilig belasten*)
        		IF WK.Stichtag IN [V.GueltigVon, V.GueltigBis] THEN
				(* Vertrag laeuft am Stichtag*)
				Anteil := Betrag * V.Stundenzahl / Stunden;
				(* LiesStdzahlinVtr *)

				B := Buchung.create (V.KostenstellenID, V.VertragsID, Anteil, Datum, "WG");
                                Buchungen.add (B);
				(* CreateBu(...), LiesVtrIDInVtr, LiesKstIDInVtr,
				   SetzeKstIDinBu, SetzeVtrIDInBu, SetzeBetragInBu, SetzeGebuchtAminBu, SetzeBuchungsArtInBu,
				   InsertBu *)
			
				Druckauftrag (V.VertragsID, V.KostenstellenID, Anteil, Datum, "WG")
				(* Print(...)..., VtrIDAlsString, KstIDAlsString, DatumAlsString *)
		END (*IF*)
    END
	



  PROCEDURE Jahresabschluss (inStichtag: TDatum);
  	   (* Abschlu d. Kostenstellen z. Jahres- bzw. Semesterende; Prozess D2.3.1*)
           (* --> Prozess D 2.3.2 (Lehrgebiet liquidieren) --> D 2.5 (Druckprozess)

	   (*	PROZESS-SPEZIFIKATION betroffene Kostenstellen ermitteln (D2.3.1)
		Eingaben: 	Datum (*von Proze D2.1*)
		Ausgaben:	Kostenstelle + Datum (*an Proze D2.3.2*)

		Vorbedingungen: 	...
		Nachbedingungen:	...

		BEGIN
		   IF (Datum.Tag = 01) and (Datum.Monat = 01) THEN
			(* PruefeObMonatsErster, PruefeObMonatJanuar *)
		    FOR alle Kostenstellen K DO
			(* FirstKst, NextKst *)

			IF K.Jahr = Datum.Jahr - 1 THEN
			(* Ksten.LiesJahrInKst, Datum.LiesJahrInDatum, LetztesJahrInDatum, IsEqualJahrInDatum *)
 				Kostenstelle liquidieren (K, Datum)
			END (*IF*)
		    END (*FOR*)
	          END (*IF*)
               END   *)

	
  PROCEDURE LiquidierenKstInAuto

	(* PROZESS-SPEZIFIKATION Kostenstelle liquidieren (D2.3.2)
	Eingaben: 	Kostenstelle + Datum (*von Proze D2.3.1)
	Ausgaben:	Druckauftrag (*an Proze D2.5)

	Vorbedingungen: 	Kostenstelle nicht liquidiert
	Nachbedingungen:	...  *)     	

    BEGIN
	Betrag := Kostenstelle.Kontingente * Kostenstelle.quivalent;
	(* BerechneEtatKst (inKstID: TKstID): Integer  *)
	FOR alle Buchungen B mit B.KostenstellenID = Kostenstelle.KostenstellenID DO
	(* FirstBuMitKstID, NextBuMitKstID *)
		IF B ist nicht storniert THEN
		(* IstStorniertBuinBu *)
			Betrag := Betrag - B.Betrag
			(* LiesBetragInBu *)
		END; (*IF*)
	END; (*FOR*)
	IF Betrag <> 0 THEN
		B := Buchung.create (Kostenstelle.KostenstellenID, UNDEF, -Betrag, Datum, Abschluss);
		Buchungen.add (B)
	END; (*IF*)
	Kostenstelle.LiquidiertAm := Datum;
	automatische Druckaufbereitung (Kostenstelle, Betrag)
    END

PROCEDURE NachziehenAutoBuchungen(VAR inoutLAD:TDatum, inAktDat:TDatum);
	(*
	vb: inLAD< AktDatum - 1
	Rufe fr jeden Tag in der Differenz inAktDatum-inLAD die Procedures
	betroffeneHilfsKraefteErmitteln und betroffeneLehrgebieteErmitteln
	nb: automatischer Betrieb fr die Tage im Zeitinterval [inLAD,AktDatum]
	sind durchgefhrt
	Prozess D 2.1 Datumsverwaltung
	*)
       (*
       PROZESS-SPEZIFIKATION Datumsverwaltung (D2.1)
       Eingaben: 	Datum Uhr
	        	Erlaubnis zum automatischen Betrieb(*vom Proze D1
       Ausgaben:	Datum (* an die Prozesse D2.2 - D2.4
	        	Ende des automatischen Betriebs (*an Proze D1

       Vorbedingungen: 	...
       Nachbedingungen:	...*)

       BEGIN
	
		Vergleich des Systemdatums mit dem aktuellen Datum ;
		(* IsEqualDatum *)
	        WHILE Systemdatum < aktuelles Datum DO
		       (* SmallerDatum *)
		       Systemdatum := Systemdatum + 1;
			(* IncDatum *)
		       rufe die Prozesse 2.2 - 2.4 auf
	        END (*WHILE*)
       END *)
  	     	
END Auto;  	


