(*345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50         60       70        80
*)

MODULE HiKSBuen;

   FROM  InOut      IMPORT ReadCard, ReadLn, ReadString,
                           WriteCard, WriteString, WriteLn;
   FROM  Ascii      IMPORT lf;
   FROM  LogDatei   IMPORT OpenLog, CloseLog, WriteLogString, WriteLogChar;
   FROM  TestOpBuen IMPORT OpInsertBuen, OpUpdateBuen, OpGebGelderKst, 
                           OpStorniereBuZuVtr, OpShowListBuen,
                           OpShowBuenKst, OpShowBuenVtr, OpShowBuenBuArtVtr,
                           OpShowBuenAlsStringliste, OpShowAllesAlsStringliste,
                           OpSaveBuen, OpLoadBuen;
   FROM  WholeStr   IMPORT ConvResults, StrToCard, CardToStr;
   FROM  Ascii      IMPORT nul;
   FROM  SysClock   IMPORT DateTime, GetClock;  (* fuer Betriebssystemdatum *)
   FROM  Strings     IMPORT Append;
   FROM  Datum      IMPORT TDatum, DatumVonString, DisposeDatum;
   FROM  SysDat     IMPORT SetzeSystemDatumInSysDat;

   IMPORT String;


   VAR Befehl          : CARDINAL;
       TestProcs       : ARRAY[0..20] OF PROC;
       MaxProcNr       : CARDINAL;
       (* Fuer Systemdatum setzen (auf Betriebssystemdatum *)
       rc : BOOLEAN;
       heute : TDatum;
       outMessage : String.TString;
       structTime : DateTime;
       stringDatum : String.TString;
       strtag   : ARRAY [1..2] OF CHAR;
       strmonat : ARRAY [1..2] OF CHAR;
       strjahr  : ARRAY [1..4] OF CHAR;
       arrayDatum : ARRAY [1..11] OF CHAR;

  PROCEDURE OperationInsert;
  BEGIN
    WriteString("Operation: Insert");
    WriteLn;
    WriteLogString("============== Begin Operation: Buchungen Insert");
    WriteLogChar(lf);
    OpInsertBuen ();
    WriteLogString("============== Ende Operation: Buchungen Insert");
    WriteLogChar(lf);
    WriteLn
  END OperationInsert;


  PROCEDURE OperationUpdate;
  BEGIN
    WriteString("Operation: Update");
    WriteLn;
    WriteLogString("============== Begin Operation: Buchungen Update");
    WriteLogChar(lf);
    OpUpdateBuen ();
    WriteLogString("============== Ende Operation: Buchungen Update");
    WriteLogChar(lf);
  END OperationUpdate;


  PROCEDURE OperationGebGelderKst;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("Operation: Gebuchte Gelder");
    WriteLn;
    WriteLogString("============== Begin Operation: Gebuchte Gelder zu Kst");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpGebGelderKst (Zahl);
    WriteLogString("============== Ende Operation: Gebuchte Gelder zu Kst");
    WriteLogChar(lf);
  END OperationGebGelderKst;


  PROCEDURE OperationStorniereBuZuVtr;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("Operation: Storniere Buchungen zu Vertrag");
    WriteLn;
    WriteLogString
      ("============== Begin Operation: Storniere Buchungen zu Vertrag");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpStorniereBuZuVtr (Zahl);
    WriteLogString
       ("============== Ende Operation: Storniere Buchungen zu Vertrag");
    WriteLogChar(lf);
  END OperationStorniereBuZuVtr;


  PROCEDURE OperationShowList;
  BEGIN
    WriteString("Operation: Ordnerinhalt anzeigen");
    WriteLn;
    WriteLogString
            ("============== Begin Operation: Buchungen Ordnerinhalt anzeigen");
    WriteLogChar(lf);
    OpShowListBuen ();
    WriteLogString
            ("============== Ende Operation: Buchungen Ordnerinhalt anzeigen");
    WriteLogChar(lf);
  END OperationShowList;


  PROCEDURE OperationShowListKst;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("Operation: Alle Buchungen zu einer Kostenstelle");
    WriteLn;
    WriteLogString
      ("============== Begin Operation: Alle Buchungen zu einer Kostenstelle");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpShowBuenKst (Zahl);
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende Operation: Alle Buchungen zu einer Kostenstelle");
    WriteLogChar(lf);
  END OperationShowListKst;


  PROCEDURE OperationShowListVtr;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("Operation: Alle Buchungen zu einem Vertrag");
    WriteLn;
    WriteLogString
      ("============== Begin Operation: Alle Buchungen zu einem Vertrag");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpShowBuenVtr (Zahl);
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende Operation: Alle Buchungen zu einem Vertrag");
    WriteLogChar(lf);
  END OperationShowListVtr;


  PROCEDURE OperationShowListBuArtVtr;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("Operation: Alle Buchungen zu einem Vertrag");
    WriteLn;
    WriteLogString
      ("============== Begin Operation: Alle Buchungen einer BuArt zu einem Vertrag");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpShowBuenBuArtVtr (Zahl);
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende Operation: Alle Buchungen einer BuArt zu einem Vertrag");
    WriteLogChar(lf);
  END OperationShowListBuArtVtr;


  PROCEDURE OperationShowBuenAlsStringliste;
  BEGIN
    WriteString("Operation: Nicht stornierte Buchungen als Stringliste");
    WriteLn;
    WriteLogString
      ("============== Begin Operation: Nicht stornierte Buchungen als Stringliste");
    WriteLogChar(lf);
    OpShowBuenAlsStringliste ();
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende Operation: Nicht stornierte Buchungen als Stringliste");
    WriteLogChar(lf);
  END OperationShowBuenAlsStringliste;


  PROCEDURE OperationShowAllesAlsStringliste;
  BEGIN
    WriteString("Operation: Alle Buchungen als Stringliste");
    WriteLn;
    WriteLogString
      ("============== Begin Operation: Alle Buchungen als Stringliste");
    WriteLogChar(lf);
    OpShowAllesAlsStringliste ();
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende Operation: Alle Buchungen als Stringliste");
    WriteLogChar(lf);
  END OperationShowAllesAlsStringliste;


  PROCEDURE OperationSave;
  BEGIN
    WriteString("Operation: Save");
    WriteLn;
    WriteLogString
           ("============== Begin Operation: Save auf HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
    OpSaveBuen ();
    WriteLogString
          ("============== Ende Operation: Save auf HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
  END OperationSave;

  PROCEDURE OperationLoad;
  BEGIN
    WriteString("Operation: Load");
    WriteLn;
    WriteLogString
           ("============== Begin Operation: Load von HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
    OpLoadBuen();
    WriteLogString
          ("============== Ende Operation: Load von HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
  END OperationLoad;



  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("Operation Insert");
    MenueItem ("Operation Update");
    MenueItem ("Operation Gebuchte Gelder zu einer Kst");
    MenueItem ("Operation Storniere Buchungen zu einem Vertrag");
    MenueItem ("Operation OrdnerInhalt ausgeben");
    MenueItem ("Operation Alle Buchungen zu einer Kostenstelle ausgeben");
    MenueItem ("Operation Alle Buchungen zu einem Vertrag ausgeben");
    MenueItem
             ("Operation Alle Buchungen einer BuArt zu einem Vertrag ausgeben");
    MenueItem
     ("Operation Nicht stornierte Buchungen als Stringliste ausgeben");
    MenueItem ("Operation Alle Buchungen als Stringliste ausgeben");
    MenueItem ("Operation Save auf HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    MenueItem ("Operation Load von HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (OperationInsert);
    ProcEintragen (OperationUpdate);
    ProcEintragen (OperationGebGelderKst);
    ProcEintragen (OperationStorniereBuZuVtr);
    ProcEintragen (OperationShowList);
    ProcEintragen (OperationShowListKst);
    ProcEintragen (OperationShowListVtr);
    ProcEintragen (OperationShowListBuArtVtr);
    ProcEintragen (OperationShowBuenAlsStringliste);
    ProcEintragen (OperationShowAllesAlsStringliste);
    ProcEintragen (OperationSave);
    ProcEintragen (OperationLoad);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN
    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;


PROCEDURE IDEingeben () : CARDINAL;
VAR Wert : ARRAY [0..50] OF CHAR;
    Zahl : CARDINAL;
    KonvResult : ConvResults;
    EingabeKorrekt : BOOLEAN;
BEGIN
   EingabeKorrekt := FALSE;
   WHILE NOT EingabeKorrekt DO
     WriteString("ID Eingeben: ");
     ReadString(Wert);
     WriteLn;
     StrToCard(Wert,Zahl,KonvResult);
     IF KonvResult = strAllRight  THEN
        EingabeKorrekt := TRUE;
     ELSE
        WriteString("Eingabe ist keine Zahl "); WriteLn;
     END; (* IF *)
   END; (* WHILE *)
   RETURN Zahl;
END IDEingeben;


(*----------------------- Hauptprogramm -------------------------------------*)

BEGIN

   WriteString(" Testen Teilsystem Buchungen");
   WriteLn;
   (* SystemDatum setzen, auf Betriebssystemdatum*)
   GetClock(structTime); (* aktuelles Betriebssystemdatum *)
   (* Betriebssystem-Datum in String wandeln, denn vorerst kann man
   nur mit DatumVonString ein Datum setzen *)
   CardToStr(structTime.day, strtag);
   CardToStr(structTime.month, strmonat);
   CardToStr(structTime.year, strjahr);
   arrayDatum[1] := nul;            (*Leerstring*)
   Append (strtag, arrayDatum);
   Append (".",arrayDatum);
   Append (strmonat, arrayDatum);
   Append (".",arrayDatum);
   Append (strjahr,arrayDatum);
   stringDatum := String.Create();
   String.Schreibe(stringDatum, arrayDatum);
   (* String.Schreibe(stringDatum, "21.11.2001"); *)
   rc := DatumVonString(stringDatum, heute, outMessage);
   SetzeSystemDatumInSysDat(heute);
   String.Dispose(stringDatum);
   DisposeDatum(heute);

  InitTestProcs;

   (* Alle Meldungen und Inhalte auf Logdatei *)

  OpenLog;

  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;

  CloseLog;


END HiKSBuen.
