MODULE DatumTest;

   FROM InOut IMPORT ReadCard, WriteCard, WriteString, WriteLn;

   FROM InOut IMPORT ReadLn, ReadString;

   FROM SYSTEM  IMPORT TSIZE;

   IMPORT Datum;
   IMPORT String;
    
   VAR Befehl          	: CARDINAL;
       TestTag		: Datum.TTag;
       TestMonat	: Datum.TMonat;
       TestJahr		: Datum.TJahr;
       TestStag		: Datum.TStag;
       TestDatum       	: Datum.TDatum;
       TestProcs       	: ARRAY[0..20] OF PROC;
       MaxProcNr       	: CARDINAL;
       TDexistiert      : BOOLEAN;
       STexistiert      : BOOLEAN;
       Mexistiert       : BOOLEAN;
       Jexistiert       : BOOLEAN;

  PROCEDURE CreateDatum();
  VAR str1:String.TString;
      message:String.TString;
      outD: Datum.TDatum;
  BEGIN
    WriteString("Operation: Datum.CreateDatum");
    WriteLn;
    IF TestDatum<>NIL THEN
      WriteString ("Es existiert bereits ein Testdatum");
      WriteLn;
    ELSE 
      TestDatum  := Datum.CreateDatum ();
      str1 := String.Create ();
      StringEingeben ("Testdatum eingeben :",str1); 
      IF Datum.DatumVonString(str1,outD,message)THEN
	Datum.EqualizeDatum(TestDatum,outD);
	WriteString("TestDatum ist auf ");
	StringAusgeben(Datum.DatumAlsString(TestDatum));
	WriteString("gesetzt.");
	WriteLn;
	Datum.DisposeDatum(outD);
        TDexistiert:=TRUE;
      ELSE
	StringAusgeben(message);
	String.Dispose(message);
	Datum.DisposeDatum(TestDatum);
      END (* IF *);
      String.Dispose(str1);
    END; (* IF *)
    WriteLn;
  END CreateDatum;

  PROCEDURE CreateStag();
  VAR str1:String.TString;
      message:String.TString;
      outStag: Datum.TStag;  
  BEGIN
    WriteString("Operation: Datum.CreateStag");
    WriteLn;
    IF STexistiert THEN
      WriteString ("Es existiert bereits ein TestStichtag");
      WriteLn;
    ELSE 
      TestStag  := Datum.CreateStag ();
      str1 := String.Create ();
      StringEingeben ("TestStichtag eingeben :",str1);
      IF Datum.StagVonString(str1,outStag,message) THEN
        Datum.EqualizeStag(TestStag,outStag);
        WriteString("TestStichtag ist auf ");
        StringAusgeben(Datum.StagAlsString(TestStag));
        WriteString("gesetzt.");
	WriteLn;
        Datum.DisposeStag(outStag);
	STexistiert:=TRUE;
      ELSE
        StringAusgeben(message);
        String.Dispose(message);
	Datum.DisposeStag(TestStag);
      END (* IF *);
    END; (* IF *)
    WriteLn;
  END CreateStag;

  PROCEDURE CreateMonat();
  VAR str1:String.TString;
      message:String.TString;
      outMonat: Datum.TMonat;  
  BEGIN
    WriteString("Operation: Datum.CreateMonat");
    WriteLn;
    IF Mexistiert THEN
      WriteString ("Es existiert bereits ein TestMonat");
      WriteLn;
    ELSE 
      TestMonat  := Datum.CreateMonat ();
      str1 := String.Create ();
      StringEingeben ("TestMonat eingeben :",str1);
      IF Datum.MonatVonString(str1,outMonat,message) THEN
        Datum.EqualizeMonat(TestMonat,outMonat);
        WriteString("TestMonat ist auf ");
        StringAusgeben(Datum.MonatAlsString(TestMonat));
        WriteString("gesetzt.");
	WriteLn;
        Datum.DisposeMonat(outMonat);
	Mexistiert:=TRUE;
      ELSE
        StringAusgeben(message);
        String.Dispose(message);
	Datum.DisposeMonat(TestMonat);
      END (* IF *);
    END; (* IF *)
    WriteLn;
  END CreateMonat;

  PROCEDURE CreateJahr();
  VAR str1:String.TString;
      message:String.TString;
      outJahr: Datum.TJahr;  
  BEGIN
    WriteString("Operation: Datum.CreateJahr");
    WriteLn;
    IF Jexistiert THEN
      WriteString ("Es existiert bereits ein TestJahr");
      WriteLn;
    ELSE 
      TestJahr  := Datum.CreateJahr ();
      str1 := String.Create ();
      StringEingeben ("TestJahr eingeben :",str1);
      IF Datum.JahrVonString(str1,outJahr,message) THEN
        Datum.EqualizeJahr(TestJahr,outJahr);
        WriteString("TestJahr ist auf ");
        StringAusgeben(Datum.JahrAlsString(TestJahr));
        WriteString("gesetzt.");
	WriteLn;
        Datum.DisposeJahr(outJahr);
	Mexistiert:=TRUE;
      ELSE
        StringAusgeben(message);
        String.Dispose(message);
	Datum.DisposeJahr(TestJahr);
      END (* IF *);
    END; (* IF *)
    WriteLn;
  END CreateJahr;

  PROCEDURE DisposeDatum();
  BEGIN
    WriteString("Operation: Datum.DisposeDatum");
    WriteLn;
    IF TDexistiert THEN
	Datum.DisposeDatum (TestDatum);
	TDexistiert:=FALSE;
    ELSE
	WriteString("Vorbedingung ist verletzt!");
    	WriteLn;
    END (* IF *);
    WriteLn;
  END DisposeDatum;

  PROCEDURE DisposeStag();
  BEGIN
    WriteString("Operation: Datum.DisposeStag");
    WriteLn;
    IF STexistiert THEN
    	Datum.DisposeStag (TestStag);
	STexistiert:=FALSE;
    ELSE
        WriteString("Vorbedingung ist verletzt!"); 
    	WriteLn;
    END (* IF *);
    WriteLn;
  END DisposeStag;

  PROCEDURE DisposeJahr();
  BEGIN
    WriteString("Operation: Datum.DisposeJahr");
    WriteLn;
    IF Jexistiert THEN
    	Datum.DisposeJahr (TestJahr);
	Jexistiert:=FALSE;
    ELSE
        WriteString("Vorbedingung ist verletzt!"); 
    	WriteLn;
    END (* IF *);
    WriteLn;
  END DisposeJahr;

  PROCEDURE DisposeMonat();
  BEGIN
    WriteString("Operation: Datum.DisposeMonat");
    WriteLn;
    IF Mexistiert THEN
    	Datum.DisposeMonat (TestMonat);
	Mexistiert:=FALSE;
    ELSE
        WriteString("Vorbedingung ist verletzt!"); 
    	WriteLn;
    END (* IF *);
    WriteLn;
  END DisposeMonat;

  PROCEDURE IstDatumEternity ();
  BEGIN
    WriteString("Operation: Datum.IstDatumEternity");
    WriteLn;
    IF TDexistiert THEN
	IF Datum.IstDatumEternity(TestDatum) THEN
	      WriteString("  TRUE ");
    	ELSE 
      		WriteString("   FALSE ");
    	END; (* IF *)
    	WriteLn;
    ELSE
	WriteString("Vorbedingung verletzt!");
	WriteLn;
    END (* IF *);
    WriteLn;
  END IstDatumEternity;

  PROCEDURE SetzeDatumEternity  ();
  BEGIN
    WriteString("Operation: Datum.SetzeDatumEternity");
    WriteLn;
    IF TDexistiert THEN
    	Datum.SetzeDatumEternity(TestDatum);
    	WriteString("  UNDEF gesetzt ");
    	WriteLn;
    ELSE
        WriteString("Vorbedingung verletzt!");
        WriteLn;
    END (* IF *); 
    WriteLn;
  END  SetzeDatumEternity;


  PROCEDURE DatumInZeitraum();
  VAR
    str1,str2:String.TString;
    vonD,bisD:Datum.TDatum;
    message:String.TString; 

  BEGIN
    WriteString("Operation: Datum.DatumInZeitraum");
    WriteLn;
    IF TDexistiert THEN 
      str1 := String.Create ();
      StringEingeben ("Datum von: ",str1);
      IF Datum.DatumVonString(str1,vonD,message)THEN
  	  str2 := String.Create();
	  StringEingeben("Datum bis: ",str2);
	  IF Datum.DatumVonString(str2,bisD,message) THEN	
 		IF Datum.DatumInZeitraum(TestDatum,vonD,bisD) THEN
      			WriteString(" TRUE");
    		ELSE 
      			WriteString(" FALSE");
    		END; (* IF *)
	        WriteLn;
  		Datum.DisposeDatum(bisD);
	  ELSE 
		StringAusgeben(message);
    	  END; (* IF *)
          Datum.DisposeDatum(vonD); 
      ELSE
	  StringAusgeben(message);
	  String.Dispose(message);
      END; (* IF *)
    ELSE
        WriteString("Testdatum ist nicht gesetzt!");
        WriteLn;
    END (* IF *);
    WriteLn;
  END DatumInZeitraum;

  PROCEDURE DecDatum();
  BEGIN
    WriteString("Operation: Datum.DecDatum");
    WriteLn;
    IF TDexistiert THEN
      Datum.DecDatum(TestDatum);
      WriteLn;
      WriteString("Neues TestDatum ist: ");
      WriteLn;
      StringAusgeben(Datum.DatumAlsString(TestDatum));
    ELSE 
      WriteString(" Vorbedingung verletzt!");
      WriteLn;
    END; (* IF *)
    WriteLn;
  END DecDatum;

  PROCEDURE IncDatum();
  BEGIN
    WriteString("Operation: Datum.IncDatum");
    WriteLn;
    IF TDexistiert THEN
      Datum.IncDatum(TestDatum);
      WriteString("Neues Datum ist: ");
      StringAusgeben(Datum.DatumAlsString(TestDatum));
    ELSE 
      WriteString(" Vorbedingung verletzt!");
      WriteLn;
    END; (* IF *)
    WriteLn;
  END IncDatum;

  PROCEDURE Wochentag();
  VAR T : CARDINAL;
  BEGIN
    WriteString("Operation: Datum.Wochentag");
    WriteLn;
    IF TDexistiert THEN
      T:=Datum.Wochentag(TestDatum);
      CASE T OF
	0	: WriteString("Datum ist undef!");
	|1	: WriteString("Montag");
	|2	: WriteString("Dienstag");
	|3	: WriteString("Mittwoch");
	|4	: WriteString("Donnerstag");
	|5	: WriteString("Freitag");
	|6	: WriteString("Samstag");
	|7	: WriteString("Sonntag");
      END (* CASE *);
      WriteLn;
    ELSE 
      WriteString(" Vorbedingung verletzt!");
      WriteLn;
    END; (* IF *)
    WriteLn;
  END Wochentag;

  PROCEDURE AnzahlMonate;
  VAR  str1	: String.TString;
       bisD     : Datum.TDatum;
       message  : String.TString; 
  BEGIN
    WriteString("Operation: Datum.AnzahlMonate");
    WriteLn;
    IF TDexistiert THEN 
      str1 := String.Create ();
      StringEingeben ("Ende des Zeitraumes: ",str1);
      IF Datum.DatumVonString(str1,bisD,message) THEN
	IF Datum.SmallerDatum(TestDatum,bisD) OR 
		Datum.IsEqualDatum(TestDatum,bisD) THEN
		WriteString("Die Anzahl der Monate von ");
		StringAusgeben(Datum.DatumAlsString(TestDatum));
		WriteString(" bis ");
		StringAusgeben(Datum.DatumAlsString(bisD)); 
		WriteLn;
		WriteString("betrgt: ");
		WriteCard(Datum.AnzahlMonate(TestDatum,bisD),4);
		WriteLn;
      		Datum.DisposeDatum(bisD);    
	ELSE
		WriteString("Vorbedingung ist verletzt!");
		WriteLn;
    	END (* IF *); 
      ELSE
	StringAusgeben(message);
	String.Dispose(message);
      END (* IF *); 
      String.Dispose(str1);
    ELSE
      WriteString(" TestDatum ist nicht gesetzt");
      WriteLn;
    END; (* IF *)
    WriteLn;
  END AnzahlMonate;

  PROCEDURE AnzahlWochen;
  VAR  str1	: String.TString;
       bisD     : Datum.TDatum;
       message  : String.TString; 
  BEGIN
    WriteString("Operation: Datum.AnzahlWochen");
    WriteLn;
    IF TDexistiert THEN
      str1 := String.Create ();
      StringEingeben ("Ende des Zeitraumes: ",str1);
      IF Datum.DatumVonString(str1,bisD,message) THEN
	IF Datum.SmallerDatum(TestDatum,bisD) OR 
		Datum.IsEqualDatum(TestDatum,bisD) THEN
		WriteString("Die Anzahl der Wochen von ");
		StringAusgeben(Datum.DatumAlsString(TestDatum));
		WriteString(" bis ");
		StringAusgeben(Datum.DatumAlsString(bisD)); 
		WriteLn;
		WriteString("betrgt: ");
		WriteCard(Datum.AnzahlWochen(TestDatum,bisD),4);
      		Datum.DisposeDatum(bisD);    
	ELSE
		WriteString("Vorbedingung ist verletzt!");
		WriteLn;
    	END (* IF *); 
      ELSE
	StringAusgeben(message);
	String.Dispose(message);
      END (* IF *); 
      String.Dispose(str1);
    ELSE
      WriteString(" TestDatum ist nicht gesetzt");
      WriteLn;
    END; (* IF *)  
    WriteLn;
  END AnzahlWochen;

  PROCEDURE AnfEndDatumKWZuDatum();
  VAR AnfD,EndD:Datum.TDatum;

  BEGIN
    WriteString("Operation: Datum.AnfEndDatumKWZuDatum");
    WriteLn;   
    IF TDexistiert THEN 
      Datum.AnfEndDatumKWZuDatum(TestDatum,AnfD,EndD); 
      WriteString("Die Woche in der der ");
      StringAusgeben(Datum.DatumAlsString(TestDatum));
      WriteString("liegt, beginnt am ");
      StringAusgeben(Datum.DatumAlsString(AnfD));
      WriteString("und endet am ");
      StringAusgeben(Datum.DatumAlsString(EndD));
    ELSE
      WriteString(" TestDatum ist nicht gesetzt");
      WriteLn;
    END; (* IF *) 
    WriteLn;
  END AnfEndDatumKWZuDatum; 
    
  PROCEDURE AnfEndDatumKWZuMonat();
  VAR AnfD,EndD:Datum.TDatum;

  BEGIN
    WriteString("Operation: Datum.AnfEndDatumKWZuMonat");
    WriteLn;   
    IF TDexistiert THEN 
      Datum.AnfEndDatumKWZuMonat(TestDatum,AnfD,EndD); 
      WriteString("Die Woche in der der Monat");
      WriteCard(Datum.MonatAlsCard(Datum.LiesMonatInDatum(TestDatum)),2); 
      WriteString(" beginnt, beginnt am ");
      StringAusgeben(Datum.DatumAlsString(AnfD));
      WriteString("Die letzte Woche des Monats endet am ");
      StringAusgeben(Datum.DatumAlsString(EndD));
      Datum.DisposeDatum(AnfD);
      Datum.DisposeDatum(EndD);
    ELSE
      WriteString(" TestDatum ist nicht gesetzt");
      WriteLn;
    END; (* IF *) 
    WriteLn;
  END AnfEndDatumKWZuMonat; 
    
  PROCEDURE ErsteWocheInMonat();
  VAR   AnfD,EndD	: Datum.TDatum; 

  BEGIN
    WriteString("Operation: Datum.ErsteWocheInMonat");
    WriteLn;
    IF TDexistiert THEN 
      Datum.ErsteWocheInMonat(TestDatum,AnfD,EndD);
      WriteString("Die Woche in der der Monat ");
      WriteCard(Datum.MonatAlsCard(Datum.LiesMonatInDatum(TestDatum)),2);
      WriteString(" beginnt, beginnt am ");
      StringAusgeben(Datum.DatumAlsString(AnfD));
      WriteString("und endet am ");
      StringAusgeben(Datum.DatumAlsString(EndD));
      WriteLn;
      NaechsteWocheImMonat(AnfD,EndD);
    ELSE
      WriteString(" TestDatum ist nicht gesetzt");
      WriteLn;
    END; (* IF *)
    WriteLn;
  END ErsteWocheInMonat;

  PROCEDURE NaechsteWocheImMonat(VAR AnfD,EndD : Datum.TDatum);

  BEGIN
    WriteString("Operation: Datum.NaechsteWocheInMonat");
    WriteLn;
    IF TDexistiert THEN 
      WHILE Datum.NaechsteWocheInMonat(TestDatum,AnfD,EndD) DO 
        WriteString("Die naechste Woche im Monat ");
        WriteCard(Datum.MonatAlsCard(Datum.LiesMonatInDatum(TestDatum)),2);
        WriteString(" beginnt am ");
        StringAusgeben(Datum.DatumAlsString(AnfD));
        WriteString("und endet am ");
        StringAusgeben(Datum.DatumAlsString(EndD));
	WriteLn;
      END (* WHILE *);
    ELSE
      WriteString(" TestDatum ist nicht gesetzt");
      WriteLn;
    END; (* IF *)
    WriteLn;
    Datum.DisposeDatum(AnfD);
    Datum.DisposeDatum(EndD);     
  END NaechsteWocheImMonat;


  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("Datum.CreateStag");
    MenueItem ("Datum.DisposeStag");
    MenueItem ("Datum.CreateMonat");
    MenueItem ("Datum.DisposeMonat");
    MenueItem ("Datum.CreateJahr");
    MenueItem ("Datum.DisposeJahr");
    MenueItem ("Datum.CreateDatum");
    MenueItem ("Datum.DisposeDatum");
    MenueItem ("Datum.IstDatumEternity");
    MenueItem ("Datum.SetzeDatumEternity");
    MenueItem ("Datum.DatumInZeitraum");
    MenueItem ("Datum.DecDatum");
    MenueItem ("Datum.IncDatum");
    MenueItem ("Datum.Wochentag");
    MenueItem ("Datum.AnzahlMonate");
    MenueItem ("Datum.AnzahlWochen");
    MenueItem ("Datum.AnfEndDatumKWZuDatum");
    MenueItem ("Datum.AnfEndDatumKWZuMonat");
    MenueItem ("Datum.ErsteWocheInMonat");
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (CreateStag);
    ProcEintragen (DisposeStag);
    ProcEintragen (CreateMonat);
    ProcEintragen (DisposeMonat);
    ProcEintragen (CreateJahr);
    ProcEintragen (DisposeJahr);
    ProcEintragen (CreateDatum);
    ProcEintragen (DisposeDatum);
    ProcEintragen (IstDatumEternity);
    ProcEintragen (SetzeDatumEternity);
    ProcEintragen (DatumInZeitraum);
    ProcEintragen (DecDatum);
    ProcEintragen (IncDatum);
    ProcEintragen (Wochentag);
    ProcEintragen (AnzahlMonate);
    ProcEintragen (AnzahlWochen);
    ProcEintragen (AnfEndDatumKWZuDatum);
    ProcEintragen (AnfEndDatumKWZuMonat);
    ProcEintragen (ErsteWocheInMonat);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN

    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;

PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..72] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; inoutStr : String.TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
END StringEingeben;

BEGIN
  InitTestProcs;
  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;
END DatumTest.
