(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HKBIMPORTE.mod,v $
# $Author: Sopra $ Gabi
# $Date: 2001/03/14 18:23:24 $
# $Revision: 1.9 $
Bemerkungen: 
*)
(******************************************************************************)
 

IMPLEMENTATION MODULE HKBIMPORTE;

(* Modul zur Bndelung der Importe des TS_HKB *)

IMPORT Auto;
IMPORT SysDat;
IMPORT HKe;
IMPORT Vtre;
IMPORT Ksten;
IMPORT Konden;
IMPORT Buen;
IMPORT HatBuBez;
IMPORT VtrBez;
IMPORT Datum;

(*
FROM Auto     IMPORT AnzahlMonateImJahr,BerechneWGDerHK;
FROM SysDat   IMPORT LiesSystemDatumInSysDat;
FROM HKe      IMPORT THK, SearchHK, InsertHK, UpdateHK, DeleteHK, LiesPersIDHK, ExistiertPersIDHK;
FROM Vtre     IMPORT TVtr, LiesKstIDinVtr, IstAbgelaufenVtr, BeginntNotImLfdJahrVtr, LiesStdzahlinVtr,
			InsertVtr, LiesVtrIDinVtr, LiesGueltigVoninVtr, LiesGueltigBisinVtr,
			SetzeStornoAminVtr, SetzeGueltigBisinVtr, InsertVtr, DuplicateVtr,
			IstNochNichtLfdVtr, IstLfdVtr, ExistVtr;
FROM Ksten    IMPORT TKstID, TKst, SearchKstZuKID, IstLiquidiertAminKst, IstGesperrtAminKst BerechneEtatKst;
FROM Datum   IMPORT TDatum, MaxDatum, MinDatum, DatumInZeitraum, SamllerDatum, CreateDatum, LiesTaginStag,
			LiesMonatinStag, SetzeTagInDatum, SetzeMonatInDatum, SetzeJahrInDatum,
			LiefereDatumEternity, IstDatumEternity;
FROM Konden   IMPORT TKond, LiesSTaginWKond, FirstTKondImZeitraum, NextTKondImZeitraum,
			PruefeVKondInZeitr,BerechneBrutto, HoleGueltigeWKonk;
FROM Buen     IMPORT TBu, CreateBu, InsertBu, SetzeKstIDinBu, LiesKstIDinBu, SetzeVtrIDinBu,
			SetzeBetraginBu, SetzeBuchungsArtinBu, StorniereGehaBu,InsertBu,
			BerGebGelderDerKst;
FROM HatBuBez IMPORT StorniereBuZuVtr;
FROM VtrBez   IMPORT ExistVtrZuHK, BerMaxStdzahlDerHK;

*)

(****************************************************
        IMPORTE aus TS Auto
*****************************************************)
PROCEDURE AnzMonateImJahr(inHKID : TPersID; inDatum : TDatum) : CARDINAL;
BEGIN
    RETURN Auto.AnzahlMonateImJahr(inHKID, inDatum)
END AnzMonateImJahr;


PROCEDURE BerWGDerHK (inHK : THK; VAR outWKond : TKond; dat : TDatum) : CARDINAL;
BEGIN
    RETURN Auto.BerechneWGDerHK(inHK, outWKond,  dat)
END  BerWGDerHK;


PROCEDURE HKWGBerechtigt ( inHKID : TPersID; inDatum : TDatum) : BOOLEAN;
BEGIN
    RETURN Auto.HKWGBerechtigt (inHKID, inDatum)
END HKWGBerechtigt;


PROCEDURE WGAnteilDerKst (inVtr : TVtr; inStagDat : TDatum; inWG : CARDINAL) : CARDINAL;
BEGIN
    RETURN Auto.WGAnteilDerKst (inVtr, inStagDat, inWG)
END WGAnteilDerKst;

(****************************************************
        IMPORTE aus TS SysDat
*****************************************************)

PROCEDURE LSysDatumInSysDat(): TDatum;
BEGIN
     RETURN SysDat.LiesSystemDatumInSysDat()	
END LSysDatumInSysDat;

(****************************************************
        IMPORTE aus TS HKe
*****************************************************)

PROCEDURE DispHK (VAR inoutHK : THK);
BEGIN
	HKe.DisposeHK (inoutHK)
END DispHK;


PROCEDURE SucheHK(HKID : TPersID; VAR outHK : THK) : BOOLEAN;
BEGIN
	RETURN HKe.SearchHK(HKID, outHK);
END SucheHK;


PROCEDURE EinfHK(inHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
      RETURN HKe.InsertHK(inHK,outMessage);
END EinfHK ;


PROCEDURE HUpdateHK(inHK : THK; VAR outMsg : TString) : BOOLEAN;
BEGIN
    RETURN HKe.UpdateHK(inHK, outMsg)
END  HUpdateHK;


PROCEDURE HDeleteHK(inHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
      RETURN HKe.DeleteHK(inHK,outMessage);
END HDeleteHK;


PROCEDURE LHKID (inHK : THK) : TPersID;
BEGIN
      RETURN HKe.LiesPersIDHK(inHK)
END LHKID;


PROCEDURE ExistiertHKID (inHK : THK) : BOOLEAN;
BEGIN
      RETURN HKe.ExistiertPersIDHK(inHK);
END ExistiertHKID;


PROCEDURE FirstHK ( VAR outHK : THK) : BOOLEAN;
BEGIN
      RETURN HKe.FirstHK (outHK)
END FirstHK;


PROCEDURE NextHK ( inoutHK : THK) : BOOLEAN;
BEGIN
      RETURN HKe.NextHK (inoutHK)
END NextHK;
 
(****************************************************
        IMPORTE aus TS Vtre
*****************************************************)


PROCEDURE DispVtr (VAR inoutVtr : TVtr);
BEGIN
	Vtre.DisposeVtr (inoutVtr)
END DispVtr;


PROCEDURE DeleteVtr (inVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN Vtre.DeleteVtr (inVtr)
END DeleteVtr;


PROCEDURE UpdateVtr (inVtr : TVtr; VAR outMsg : TString) : BOOLEAN;
BEGIN
      RETURN Vtre.AendernVtr (inVtr, outMsg)
END UpdateVtr;


PROCEDURE LKstIDinVtr (inVtr : TVtr ) : TKstID;
BEGIN
      RETURN Vtre.LiesKstIDinVtr(inVtr);
END LKstIDinVtr;


PROCEDURE IstVtrAbgelaufen(inVtr : TVtr): BOOLEAN;
BEGIN
      RETURN Vtre.IstAbgelaufenVtr(inVtr);
END IstVtrAbgelaufen;


PROCEDURE VBeginntNotImLfdJahr(inVtr : TVtr) : BOOLEAN;
BEGIN
      RETURN Vtre.BeginntNotImLfdJahr(inVtr);
END VBeginntNotImLfdJahr;


PROCEDURE LStdzahlInVtr (inVtr : TVtr) : CARDINAL;
BEGIN
      RETURN Vtre.LiesStdzahlinVtr(inVtr);
END LStdzahlInVtr;


PROCEDURE  EinfVtr( inVtr : TVtr; VAR outMessage : TString) : BOOLEAN;
BEGIN
      RETURN Vtre.InsertVtr(inVtr, outMessage);
END EinfVtr;


PROCEDURE LVtrIDinVtr (inVtr : TVtr) : TVtrID;
BEGIN
      RETURN Vtre.LiesVtrIDinVtr(inVtr);
END LVtrIDinVtr;


PROCEDURE LHKIDinVtr (inVtr : TVtr) : TPersID;
BEGIN
      RETURN Vtre.LiesPersIDinVtr (inVtr)
END LHKIDinVtr;


PROCEDURE  LGueltigVonInVtr (inVtr: TVtr) : TDatum;
BEGIN
      RETURN Vtre.LiesGueltigVoninVtr(inVtr);
END LGueltigVonInVtr;


PROCEDURE LGueltigBisInVtr (inVtr : TVtr) : TDatum;
BEGIN
      RETURN Vtre.LiesGueltigBisinVtr(inVtr);
END LGueltigBisInVtr;


PROCEDURE  LStornoAmInVtr (inVtr : TVtr) : TDatum;
BEGIN
      RETURN Vtre.LiesStornoAminVtr(inVtr);
END  LStornoAmInVtr;


PROCEDURE  SetStornoAmInVtr (inoutVtr : TVtr; inDatum : TDatum) : BOOLEAN;
BEGIN
      RETURN Vtre.SetzeStornoAminVtr(inoutVtr,   inDatum);
END  SetStornoAmInVtr;


PROCEDURE SetGueltigBisInVtr (inoutVtr : TVtr; inDatum : TDatum);
BEGIN
    Vtre.SetzeGueltigBisinVtr(inoutVtr, inDatum);
END SetGueltigBisInVtr;


PROCEDURE SucheVtr (inVtrID : TVtrID; outVtr : TVtr): BOOLEAN;
BEGIN
    RETURN Vtre.SearchVtr(inVtrID, outVtr);
END SucheVtr;


PROCEDURE  DupVtr (inQuellVtr : TVtr) : TVtr;
BEGIN
      RETURN Vtre.DuplicateVtr(inQuellVtr);
END  DupVtr;


PROCEDURE VIstNochNichtLfdVtr(inVtr : TVtr) : BOOLEAN;
BEGIN
    RETURN 	Vtre.IstNochNichtLfdVtr(inVtr);
END VIstNochNichtLfdVtr;


PROCEDURE VIstLfdVtr(inVtr : TVtr; inEndeNeu : TDatum) : BOOLEAN;
BEGIN
      RETURN Vtre.IstLfdVtr(inVtr,inEndeNeu);
END VIstLfdVtr;


PROCEDURE VExistVtr(inVtr : TVtr; VAR outMessage : TString): BOOLEAN;
BEGIN
      RETURN Vtre.ExistVtr(inVtr, outMessage);
END VExistVtr;


PROCEDURE FirstValVtrZuHK (inHKID : TPersID; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
     RETURN Vtre.FirstValidVtrZuHK (inHKID, outVtr)
END FirstValVtrZuHK;


PROCEDURE NextValVtrZuHK (inHKID : TPersID; inoutVtr : TVtr) : BOOLEAN;
BEGIN
     RETURN Vtre.NextValidVtrZuHK (inHKID, inoutVtr)
END NextValVtrZuHK;


PROCEDURE IsEqualVtrDaten (inV1, inV2 : TVtr) : BOOLEAN;
BEGIN
    RETURN Vtre.IsEqualVtrDaten (inV1, inV2)
END IsEqualVtrDaten;


PROCEDURE EqualizeVtr (inoutVZiel, inVQuell : TVtr);
BEGIN
    Vtre.EqualizeVtr (inoutVZiel, inVQuell)
END EqualizeVtr;

(****************************************************
        IMPORTE aus TS Ksten
*****************************************************)

PROCEDURE DispKst (VAR inoutKst : TKst);
BEGIN
     Ksten.DisposeKst (inoutKst)
END DispKst;


PROCEDURE DispKstID(VAR inoutKstID : TKstID);
BEGIN
	Ksten.DisposeKstID (inoutKstID);
END DispKstID;


PROCEDURE IsEqualKstID (inKID1, inKID2 : TKstID) : BOOLEAN;
BEGIN
     RETURN Ksten.IsEqualKstID (inKID1, inKID2)
END IsEqualKstID;


PROCEDURE SucheKstZuKID( inKID : TKstID; VAR outKst : TKst) : BOOLEAN;
BEGIN
     RETURN  Ksten.SearchKstZuKID(inKID, outKst);
END SucheKstZuKID;


PROCEDURE IstLiquidiertKst(inKst : TKst) : BOOLEAN;
BEGIN
     RETURN  Ksten.IstLiquidiertAminKst(inKst);
END IstLiquidiertKst;


PROCEDURE IstGesperrtKst(inKst : TKst):BOOLEAN;
BEGIN
     RETURN  Ksten.IstGesperrtAminKst(inKst);
END IstGesperrtKst;


PROCEDURE EtatDerKst (inKstID : TKstID) : INTEGER;
BEGIN
     RETURN  Ksten.BerechneEtatKst(inKstID);
END EtatDerKst;


PROCEDURE ErsteAktKst (VAR outKst : TKst) : BOOLEAN;
BEGIN
     RETURN Ksten.FirstAktKst (outKst)
END ErsteAktKst;


PROCEDURE NaechsteAktKst (inoutKst : TKst) : BOOLEAN;
BEGIN
     RETURN Ksten.NextAktKst (inoutKst)
END NaechsteAktKst;


PROCEDURE LKstIDinKst (inKst : TKst) : TKstID;
BEGIN
     RETURN Ksten.LiesKIDinKst (inKst)
END LKstIDinKst;

(****************************************************
        IMPORTE aus TS Konden
*****************************************************)

PROCEDURE DispKond (VAR inoutKond : TKond);
BEGIN
	Konden.DisposeKond (inoutKond)
END DispKond;


PROCEDURE  LSTagInWKond( inKondition : TKond) : TStag;
BEGIN
	RETURN Konden.LiesSTaginWKond(inKondition);
END LSTagInWKond;


PROCEDURE ErsteTKondImZeitraum( inGueltigVon, inGueltigBis : TDatum; VAR outKond: TKond) : BOOLEAN;
BEGIN
    (* Konden.ErsteTKondImZeitraumHolen, *)
      RETURN Konden.FirstTKondImZeitraum(inGueltigVon, inGueltigBis, outKond);
END  ErsteTKondImZeitraum;


PROCEDURE  KNextTKondImZeitraum( inGueltigVon,inGueltigBis : TDatum; inoutTKond : TKond) : BOOLEAN;
BEGIN
   (*  Konden.NaechsteTKondImZeitraumHolen,*)
      RETURN Konden.NextTKondImZeitraum( inGueltigVon, inGueltigBis, inoutTKond);
END KNextTKondImZeitraum;


PROCEDURE  KPruefeVKondInZeitr(inGueltigVon, inGueltigBis : TDatum;
                               Std : CARDINAL; Monate : CARDINAL; VAR outMsg: TString) : BOOLEAN;
BEGIN
    RETURN Konden.PruefeVKondInZeitr(inGueltigVon, inGueltigBis, Std, Monate, outMsg)
END  KPruefeVKondInZeitr;


PROCEDURE KBerechneBrutto( inGueltigVon, inGueltigBis : TDatum; inStundenzahl: INTEGER): INTEGER;
BEGIN
     RETURN  Konden.BerechneBrutto(inGueltigVon, inGueltigBis, inStundenzahl);
END KBerechneBrutto;


PROCEDURE GetGueltigeWKond( inD : TDatum; VAR outVKond : TKond) : BOOLEAN;
BEGIN
     RETURN  Konden.HoleGueltigeWKond(inD, outVKond);
END GetGueltigeWKond;



(****************************************************
        IMPORTE aus TS Buen
*****************************************************)

PROCEDURE BCreateBu () : TBu;
BEGIN
     RETURN  Buen.CreateBu();
END  BCreateBu;


PROCEDURE LBetragInBu ( inBu : TBu) : INTEGER;
BEGIN
	RETURN Buen.LiesBetraginBu (inBu)
END LBetragInBu;


PROCEDURE ErsteGehaltBuZuVtr (inVtrID : TVtrID; inBuArt : TBuArt; VAR outBu : TBu) : BOOLEAN;
BEGIN
	RETURN Buen.FirstBuMitBuArtZuVtr (inVtrID, inBuArt, outBu)
END ErsteGehaltBuZuVtr;


PROCEDURE NextGehaltBuZuVtr (inVtrID : TVtrID; inBuArt : TBuArt; inoutBu : TBu) : BOOLEAN;
BEGIN
	RETURN Buen.NextBuMitBuArtZuVtr (inVtrID, inBuArt, inoutBu)
END NextGehaltBuZuVtr;


PROCEDURE UpdateBu (outBu : TBu; VAR outMsg : TString) : BOOLEAN;
BEGIN
	RETURN Buen.UpdateBu (outBu, outMsg);
END UpdateBu;


PROCEDURE DispBu (VAR inoutBu : TBu);
BEGIN
     Buen.DisposeBu (inoutBu)
END DispBu;


PROCEDURE EinfBu(inBu : TBu;  VAR outMessage : TString) : BOOLEAN;
BEGIN
     RETURN  Buen.InsertBu(inBu, outMessage);
END EinfBu;


PROCEDURE SetBuDatInBu         (outBu   : TBu; SysDat : TDatum);
BEGIN
	Buen.SetzeGebuchtAminBu (outBu, SysDat);
END SetBuDatInBu;

PROCEDURE SetKstIDinBu (inoutBu : TBu; inKstID : TKstID);
BEGIN
    Buen.SetzeKstIDinBu(inoutBu, inKstID);
END  SetKstIDinBu;


PROCEDURE LKstIDinBu (inBu : TBu) : TKstID;
BEGIN
     RETURN  Buen.LiesKstIDinBu (inBu);
END  LKstIDinBu ;


PROCEDURE SetVtrIDinBu (inoutBu : TBu; inVtrID : TVtrID);
BEGIN
    Buen.SetzeVtrIDinBu(inoutBu, inVtrID);
END SetVtrIDinBu;


PROCEDURE SetBetragInBu (inoutBu : TBu; inBetrag : INTEGER);
BEGIN
    Buen.SetzeBetraginBu(inoutBu, inBetrag);
END  SetBetragInBu;


PROCEDURE SetStornoDatInBu (inoutBu : TBu; inSysDat : TDatum);
BEGIN
	Buen.SetzeStorniertAminBu (inoutBu, inSysDat);
END SetStornoDatInBu;


PROCEDURE SetBuchungsArtInBu (inoutBu : TBu; inBuchungsArt : TBuArt);
BEGIN
    Buen.SetzeBuchungsArtinBu(inoutBu, inBuchungsArt)
END  SetBuchungsArtInBu ;


PROCEDURE AbgebuGelderDerKst(inKSTID : TKstID) : INTEGER;
BEGIN
     RETURN  Buen.BerGebGelderDerKst(inKSTID);
END AbgebuGelderDerKst;



(****************************************************
        IMPORTE aus FM HatBuBez
*****************************************************)


PROCEDURE StornoGehaltBu(inVtrID : TVtrID; VAR outMessage : TString) : BOOLEAN;
BEGIN
    RETURN   HatBuBez.StorniereBuZuVtr(inVtrID, outMessage);
END StornoGehaltBu;


(****************************************************
        IMPORTE aus FM BelBez
*****************************************************)

(****************************************************
        IMPORTE aus FM VtrBez
*****************************************************)
              
                     
PROCEDURE VBExistVtrZuHK (inHKID : TPersID) : BOOLEAN;
BEGIN
     RETURN  VtrBez.ExistVtrZuHK(inHKID);
END VBExistVtrZuHK;


PROCEDURE VBBerMaxStdzahlDerHK (inVtr : TVtr): INTEGER;
BEGIN
     RETURN 	VtrBez.BerMaxStdZahlDerHK(inVtr)
END VBBerMaxStdzahlDerHK;


PROCEDURE BerMaxBZeitDerHK     ( inHKID : TPersID; VAR outVDatum : TDatum;
                                                   VAR outBDatum : TDatum)
				: BOOLEAN;
BEGIN
	RETURN VtrBez.BerMaxBeschZeitDerHK (inHKID, outVDatum, outBDatum)
END BerMaxBZeitDerHK;


PROCEDURE FirstValVtrZuHKmitZpunkt ( inHKID : TPersID; inDatum : TDatum;
                                     VAR outVtr : TVtr) : BOOLEAN;
BEGIN
     RETURN VtrBez.FirstVldVtrZuHKinZtpunkt (inHKID, inDatum, outVtr)
END FirstValVtrZuHKmitZpunkt;


PROCEDURE NextValVtrZuHKmitZpunkt ( inHKID : TPersID; inDatum : TDatum;
                                     inoutVtr : TVtr) : BOOLEAN;
BEGIN
     RETURN VtrBez.NextVldVtrZuHKinZtpunkt (inHKID, inDatum, inoutVtr)
END NextValVtrZuHKmitZpunkt;


END HKBIMPORTE.

