(*
	Autor 			:	Reini
	letzte Aenderung	: 	05.03.2001

*)



IMPLEMENTATION MODULE VtrVerw;

(* -- Importe *)


FROM Vtre IMPORT VtrIDAlsString;
FROM Ksten IMPORT KstIDAlsString;


FROM SYSTEM IMPORT CAST;
FROM InOut IMPORT WriteCard, WriteString, WriteInt, WriteLn;

FROM HKBIMPORTE IMPORT TVtr, TVtrID,
                       TDatum, TStag, TTag, TMonat, TJahr,
                       THK,
                       TKstID, TKst,
                       TBu, TBuID, TBuArt,
                       TKond,

                       AnzMonateImJahr, AbgebuGelderDerKst,

                       BCreateBu, BerWGDerHK, BerMaxBZeitDerHK,

                       DispBu, DispHK, DispKst, DispKond, DispVtr,
                       DupVtr, DeleteVtr, DispKstID,

                       EinfBu, EinfVtr, ErsteAktKst, EqualizeVtr,
                       EtatDerKst, ErsteGehaltBuZuVtr,

                       FirstHK, FirstValVtrZuHK, FirstValVtrZuHKmitZpunkt,

                       GetGueltigeWKond,

                       HKWGBerechtigt,

                       IsEqualKstID, IsEqualVtrDaten,
                       IstGesperrtKst, IstLiquidiertKst, IstVtrAbgelaufen,

                       KBerechneBrutto, KPruefeVKondInZeitr,

                       LGueltigBisInVtr, LGueltigVonInVtr, LHKID,
                       LHKIDinVtr, LKstIDinKst, LStdzahlInVtr,
                       LKstIDinVtr, LSysDatumInSysDat, LSTagInWKond,
                       LVtrIDinVtr,LBetragInBu,

                       NaechsteAktKst, NextHK, NextValVtrZuHK,
                       NextValVtrZuHKmitZpunkt, NextGehaltBuZuVtr,

                       SetBetragInBu, SetBuchungsArtInBu,
                       SetKstIDinBu, SetVtrIDinBu, SetStornoAmInVtr,
                       StornoGehaltBu, SucheKstZuKID, SetGueltigBisInVtr,
		       SucheVtr, SetStornoDatInBu, SetBuDatInBu,

                       UpdateVtr, UpdateBu,

                       VBBerMaxStdzahlDerHK, VBeginntNotImLfdJahr, VExistVtr,

                       WGAnteilDerKst;


FROM Datum IMPORT      DisposeDatum, DisposeStag, DuplicateDatum,
		       DatumAlsString, DisposeJahr,

                       JahrAlsCard,
                       LiesTagInStag, LiesMonatInStag, LiesJahrInDatum,

                       SetzeJahr, SetzeJahrInDatum,
                       SetzeTagInDatum, SetzeMonatInDatum, SmallerDatum;

IMPORT String;
FROM WholeStr IMPORT IntToStr;

(* wohl ueberfluessig
IMPORT Vtre;
IMPORT Ksten;
TYPE	THK	= HKe.THK; TString = String.TString; TDatum = Datum.TDatum;
	TKstID	= Ksten.TKstID*)


PROCEDURE BearbeitenNeuVtr ( inVtr : TVtr; VAR outMsg : TString) : BOOLEAN;
(* -- bekommt Vertragsdaten uebergeben, d.h. ohne VtrID!
   -- zuerst werden einfache Bedingungen ueberprueft, falls diese erfuellt sind
   -- wird der Vertrag eingefuegt.
   -- Dies muss geschehen, damit bei spaeterer Restetatsberechnung der
   -- Zeitraum und die Stundenzahl des NeuVtr mitberuecksichtigt werden,
   -- noch keine Buchung erfolgt!
   -- Nun wird getestet, ob Etats von Kostenstellen ueberschritten werden:
   -- * Berechnen des Restetats der direkt betroffenen Kostenstelle
        Etat - bereits abgebuchte Gelder
             - Betrag, der durch NeuVtr entstehen wuerde
             - geschaetzter WG-Anteil (enthaelt auch NeuVtr)
      * Berechnen des Restetats aller Kostenstellen, die einen gueltigen
        Vertrag mit der HK haben, da durch den NeuVtr sich evtl. die Hoehe
        des WG der HK und damit der WG-Anteil, den die einzelnen Kostenstellen
        zu zahlen haben, aendern koennte.
        Etat - bereits abgebuchte Gelder
             - geschaetzter WG-Anteil (enthaelt auch NeuVtr)

   -- Falls der Etat einer betroffenen Kostenstellen ueberschritten wird,
   -- wird der NeuVtr wieder storniert. Hierdurch entstehen zwar
   -- "Vertragsleichen", was aber zumutbar ist, da diese Faelle eher selten
   -- auftreten. "Vertragsleichen" koennten vermieden werden, indem man
   -- ausnahmsweise Vertragsloeschungen zulassen wuerde.
   -- Zum Stornieren des NeuVtr muessen alle gueltigen Vtrs der HK auf
   -- Gleichheit mit den VtrDaten geprueft werden, um die VtrID zu bestimmen,
   -- danach kann NeuVtr storniert werden.

*)
VAR	outKstID	: TKstID;
	outAktKstID	: TKstID;
	outKstZuID	: TKst;
	outKst		: TKst;
	RestEtat	: INTEGER;
	maxStdzahl	: CARDINAL;
	maxMonateDerHK	: CARDINAL;  (* -- wieviele Monate ist die HK
                                        -- schon beschaeftigt *)
	OK		: BOOLEAN;
	result		: BOOLEAN;
	Vtrgefunden	: BOOLEAN;
   	outMsg2		: TString;
	IntStr		: TString;
	KstIDStr	: TString;
	neuVtrBetrag	: INTEGER;
	outV1		: TVtr;
	arrayofchar	: ARRAY [0..250] OF CHAR;
	
BEGIN
  outKstID    := LKstIDinVtr ( inVtr );
  OK          := SucheKstZuKID ( outKstID , outKstZuID );
  (* -- muss erfolgreich sein, da in aufrufender Prozedur ueberprueft *)
  outMsg      := String.Create();

	(* -- outMsg wird zu Beginn erzeugt und im Fehlerfall die
           -- Fehlermeldung zugewiesen. Falls kein Fehler auftritt,
           -- muss outMsg wieder freigegeben werden *)

  Vtrgefunden := FALSE;
  neuVtrBetrag:= 0;

  IF IstVtrAbgelaufen ( inVtr ) THEN
      OK := FALSE;
      String.Schreibe (outMsg, "Vertrag ist bereits abgelaufen")
  ELSIF VBeginntNotImLfdJahr ( inVtr ) THEN  	
      OK := FALSE;
      String.Schreibe (outMsg, "Vertrag beginnt nicht im laufenden Jahr")
  ELSIF ( IstGesperrtKst ( outKstZuID ) OR IstLiquidiertKst ( outKstZuID ) )
      THEN
      OK := FALSE;
      String.Schreibe (outMsg, "Kostenstelle ist liquidiert oder gesperrt")
  ELSE
  	(* -- einfache Bedingungen erfuellt, Vertrag wird nun eingefuegt
  	   -- danach wird ueberprueft, ob Etats der Ksten ausreichen *)
      IF EinfVtr ( inVtr, outMsg2 ) THEN

        (* -- falls HK incl. NeuVtr WGBerechtigt ist, muessen alle Etats der
           -- Ksten, welche einen gueltigen Vtr mit HK besitzen, auf
           -- Etatueberschreitung ueberprueft werden, ansonsten nur die Kst
           -- im NeuVtr *)

        IF HKWGBerechtigt ( LHKIDinVtr (inVtr), LSysDatumInSysDat () ) THEN

             (* -- Restetat aller Ksten ueberpruefen, die einen gueltigen Vtr
                -- mit HK haben. Hierfuer werden zunaechst alle nicht
                -- liquidierten Ksten durchlaufen *)

            IF ErsteAktKst ( outKst ) THEN
               REPEAT
		    outAktKstID := LKstIDinKst (outKst);
                    (* -- Test ob es einen gueltigen Vtr zw. HK und outKst
                       -- gibt *)

                   IF ExistValVtrZwHKUndKst ( LHKIDinVtr(inVtr), outKst) THEN
		       RestEtat :=  BerRestEtatDerKst ( outAktKstID ) ;
                       IF  RestEtat < 0 THEN
                           OK := FALSE;
			   KstIDStr := KstIDAlsString ( outAktKstID );
			   IntToStr (RestEtat, arrayofchar);
			   IntStr := String.Create();
                           String.Schreibe (IntStr, arrayofchar);
                           String.Schreibe (outMsg, "Etatueberschreitung bei Kostenstelle ");
			   String.Anhaengen(KstIDStr, outMsg);
			   String.Schreibe (KstIDStr, " um Pf ");
			   String.Anhaengen(KstIDStr, outMsg);
			   String.Anhaengen(IntStr, outMsg);
			   String.Dispose (KstIDStr);
	                   String.Dispose (IntStr);
                       END;
                   END;
		   DispKstID (outAktKstID);
               UNTIL (NOT NaechsteAktKst ( outKst )) OR (NOT OK);
               DispKst (outKst)
            END; (* IF ErsteAktKst *)

        END;      (* IF HKWGBerechtigt *)
             (* -- nur den Restetat der Kst in NeuVtr ueberpruefen
                -- zuerst den Betrag berechnen, der durch NeuVtr verursacht
                -- werden wuerde *)

	     neuVtrBetrag := KBerechneBrutto ( LGueltigVonInVtr (inVtr),
                                   LGueltigBisInVtr (inVtr),
                                   LStdzahlInVtr (inVtr) );	
             IF (BerRestEtatDerKst ( outKstID ) -  neuVtrBetrag)  < 0 THEN
                 (* -- Etatueberschreitung *)
                 OK := FALSE;
                 String.Schreibe (outMsg, "Etatueberschreitung !")
             END; (* IF *)
        (*END;  IF HKWGBerechtigt *)

        (* -- hier ist die Etatueberschreitung bereits geklaert.
           -- Falls Etat OK, muss nun die Vertragskondition getestet werden *)

           IF OK THEN
               (* -- Vertragskondition pruefen *)

               maxStdzahl := CAST (CARDINAL, ABS(VBBerMaxStdzahlDerHK(inVtr)));
	       maxMonateDerHK := AnzBMonateDerHK ( LHKIDinVtr(inVtr) );

               IF NOT KPruefeVKondInZeitr ( LGueltigVonInVtr (inVtr),
                                           LGueltigBisInVtr (inVtr),
                                           maxStdzahl,
                                           maxMonateDerHK ,outMsg ) THEN
                    	OK := FALSE;                    
               END;
            END; (* IF OK *)


           (* -- es muss die ID des Vtr bestimmt werden, um entweder diesen
              -- Vtr wieder stornieren zu koennen oder fuer diesen Vtr die
              -- Buchung vornehmen zu koennen. An dieser Stelle ist NeuVtr
              -- noch im Ordner eingefuegt *)

           IF FirstValVtrZuHK ( LHKIDinVtr ( inVtr ) , outV1) THEN
           	REPEAT
                   Vtrgefunden := IsEqualVtrDaten (inVtr, outV1);
                   IF Vtrgefunden THEN
                       EqualizeVtr (inVtr, outV1);  (* -- erforderlich, um
                                                  -- inVtr mit ID zu versehen *)
                   END ;
            	UNTIL (NOT NextValVtrZuHK ( LHKIDinVtr ( inVtr ), outV1)) OR
                         Vtrgefunden;
             	DispVtr (outV1)
           END; (* FirstValVtrZuHK *)

           (* -- VtrID ist bestimmt *)

           IF NOT OK THEN
               (* -- NeuVtr stornieren *)

               (*result := SetStornoAmInVtr (inVtr, LSysDatumInSysDat ());
               result := UpdateVtr (inVtr, outMsg2);*)

               result := DeleteVtr(inVtr);

               (* -- outMsg2 wird nicht gebraucht
               IF NOT result THEN String.Dispose (outMsg2) END;
                EqualizeVtr (inVtr, outV1);   -- erforderlich, da
                                                  -- inVtr keine ID enthaelt *)
           ELSE    (* NOT OK *)
           	(* -- kein Fehler aufgetreten,
                   -- NeuVtr buchen und outMsg disposen *)
           	WriteString ("NeuVtr buchen :");WriteInt (neuVtrBetrag,10); WriteLn;
           	String.Dispose (outMsg);   (* da nicht benoetigt *)
           	NeuVtrBuchen (inVtr, neuVtrBetrag)
           	
           END; (* NOT OK *)
      ELSE      (* EinfVtr *)
      	   OK := FALSE;
	   String.Equalize (outMsg, outMsg2);
           String.Dispose (outMsg2);
      END; (* EinfVtr *)

  END; (* IF Bedingungen *)
       (* -- outMsg ist im Fehlerfall gesetzt, ansonsten disposed *)
  RETURN OK

END BearbeitenNeuVtr;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE  AnzBMonateDerHK ( inHKID : TPersID ) : CARDINAL;
VAR  	anz 	  : CARDINAL;
	outVDatum : TDatum;
	outBDatum : TDatum;
	outVJahr  : TJahr;
	outBJahr  : TJahr;
	vonJahr   : CARDINAL;
	bisJahr	  : CARDINAL;
	laufJahr  : CARDINAL;
	outlaufDat: TDatum;

starr : ARRAY [0..250] OF CHAR;
BEGIN
	anz := 0;
	outlaufDat := LSysDatumInSysDat ();

	IF BerMaxBZeitDerHK( inHKID, outVDatum, outBDatum) THEN
String.Lies (DatumAlsString(outVDatum), starr);
WriteString (starr); WriteLn;
String.Lies (DatumAlsString(outBDatum), starr);
WriteString (starr);
		outVJahr := LiesJahrInDatum (outVDatum);
		outBJahr := LiesJahrInDatum (outBDatum);
		vonJahr  := JahrAlsCard (outVJahr);
		bisJahr  := JahrAlsCard (outBJahr);
WriteString("Jahre:"); WriteCard(vonJahr,5); WriteCard(bisJahr,5);WriteLn;		
		FOR laufJahr := vonJahr TO bisJahr DO
			SetzeJahr (outVJahr, laufJahr);
			SetzeJahrInDatum (outlaufDat, outVJahr);
			anz := anz + AnzMonateImJahr ( inHKID, outlaufDat);
WriteString ("Anz. Monate"); WriteCard (anz,3); WriteLn;
		END;
		DisposeDatum (outVDatum);
		DisposeDatum (outBDatum);
		DisposeDatum (outlaufDat);
		DisposeJahr  (outVJahr);
		DisposeJahr  (outBJahr);
	END;

	RETURN	anz
END AnzBMonateDerHK;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE ExistValVtrZwHKUndKst ( inHKID : TPersID; inKst : TKst ): BOOLEAN;
(* -- ermitteln, ob zw. der HK und der Kst ein gueltiger Vtr existiert *)
VAR   VtrZwHKundKst : BOOLEAN;
      outVtr        : TVtr;
BEGIN

    VtrZwHKundKst := FALSE;
    IF FirstValVtrZuHK ( inHKID, outVtr ) THEN
         REPEAT
             IF IsEqualKstID ( LKstIDinKst (inKst), LKstIDinVtr(outVtr) ) THEN
                  VtrZwHKundKst := TRUE END;
         UNTIL (NOT NextValVtrZuHK ( inHKID, outVtr )) OR VtrZwHKundKst;
         DispVtr (outVtr);
    END;

    RETURN VtrZwHKundKst

END ExistValVtrZwHKUndKst;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE NeuVtrBuchen ( inVtr : TVtr; Betrag : CARDINAL );
(* -- wird nur in Verbindung mit BearbeitenNeuVtr verwendet *)
VAR outBu	: TBu;
    result	: BOOLEAN;
    outMsg	: TString;
    SysDat	: TDatum;
BEGIN
	outBu := BCreateBu();
	SysDat := LSysDatumInSysDat ();
	SetBuDatInBu 	   (outBu, SysDat);
	DisposeDatum 	   (SysDat);
	SetBetragInBu      (outBu, Betrag);
	SetKstIDinBu       (outBu, LKstIDinVtr (inVtr));
	SetVtrIDinBu       (outBu, LVtrIDinVtr (inVtr));
	SetBuchungsArtInBu (outBu, Gehalt);
	result := EinfBu (outBu, outMsg );
	DispBu (outBu);
	IF NOT result THEN String.Dispose (outMsg) END ;
END NeuVtrBuchen;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE AendernVtr ( inoutVtr : TVtr; inEndeNeu: TDatum;
                       VAR outMsg : TString) : BOOLEAN;
(* -- setzt GueltigBis in inoutVtr auf inEndeNeu, fall inEndeNeu zw.
   -- GueltigVon und GueltigBis *)
VAR  	outBu  : TBu;
	SysDat : TDatum;

BEGIN

     IF NOT VExistVtr (inoutVtr, outMsg) THEN
          RETURN FALSE
     ELSIF SmallerDatum (inEndeNeu, LSysDatumInSysDat() ) THEN
	  outMsg := String.Create();
	  String.Schreibe (outMsg, "neues Ende < heutiges Datum");
	  RETURN FALSE;
     ELSIF SmallerDatum (inEndeNeu, LGueltigVonInVtr (inoutVtr) ) THEN
          outMsg := String.Create();
          String.Schreibe (outMsg, "neues Ende < Gueltig von");
          RETURN FALSE
     ELSIF SmallerDatum ( LGueltigBisInVtr (inoutVtr), inEndeNeu) THEN
          outMsg := String.Create();
          String.Schreibe (outMsg, "neues Ende > altes Ende");
          RETURN FALSE
(*     ELSIF NOT StornierenVtr (inoutVtr, outMsg) THEN
           -- Fehler beim Stornieren
          RETURN FALSE *)
     ELSE
          (* -- Stornierung war erfolgreich =>
             -- Neuen Vertrag einfuegen und buchen
             -- falls beim Einfuegen eines Vtr eine evtl. vorhandene VtrID
             -- ueberschrieben wird, kann inoutVtr weiter verwendet werden *)
	     IF NOT StornoGehaltBu ( LVtrIDinVtr (inoutVtr), outMsg) THEN
		 RETURN FALSE;
	     END;

             SetGueltigBisInVtr (inoutVtr, inEndeNeu);
             IF UpdateVtr (inoutVtr, outMsg) THEN
                 outBu := BCreateBu ();
		 SysDat := LSysDatumInSysDat ();
		 SetBuDatInBu (outBu, SysDat);
                 SetKstIDinBu (outBu, LKstIDinVtr (inoutVtr) );
                 SetVtrIDinBu (outBu, LVtrIDinVtr (inoutVtr) ); (* neue ID! *)
                 SetBetragInBu(outBu,
                               KBerechneBrutto ( LGueltigVonInVtr (inoutVtr),
                                                 inEndeNeu,
                                                 LStdzahlInVtr (inoutVtr) ));
                 SetBuchungsArtInBu (outBu, Gehalt);
		 IF EinfBu (outBu, outMsg) THEN WriteString ("Bu storniert") END;
		 DispBu (outBu);

                 RETURN TRUE
             ELSE
                 RETURN FALSE
             END; (* IF EinfVtr *)

     END; (* IF *)

END AendernVtr;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE StornierenVtr (inVtr : TVtr; VAR outMsg : TString) : BOOLEAN;
(* -- ein Vtr kann storniert werden, wenn er existiert, er noch
   -- nicht abgelaufen und die beteiligte Kst weder liquidiert noch
   -- gesperrt ist *)

VAR outKst : TKst;
	SysDat : TDatum;
	res	: BOOLEAN;
BEGIN

    IF NOT VExistVtr (inVtr, outMsg) THEN
         RETURN FALSE
    ELSIF IstVtrAbgelaufen (inVtr) THEN
         outMsg := String.Create();
         String.Schreibe (outMsg, "Vertrag abgelaufen");
         RETURN FALSE
    ELSIF NOT SucheKstZuKID ( LKstIDinVtr (inVtr), outKst) THEN
         (* -- falls Kst nicht existiert, warum auch immer *)
         outMsg := String.Create();
         String.Schreibe (outMsg, "Fehler in Kostenstelle");
         RETURN FALSE
    ELSIF ( IstGesperrtKst (outKst) OR IstLiquidiertKst (outKst) ) THEN
         (* -- hier ist outKst schon belegt, da alle drei vorherigen Bed.
            -- FALSE sind *)
         DispKst (outKst);
         outMsg := String.Create();
         String.Schreibe (outMsg, "Kostenstelle liquidiert oder gesperrt");
         RETURN FALSE
    ELSE
         (* -- Vertrag stornieren *)
         DispKst (outKst);
         SysDat := LSysDatumInSysDat ();
         res := SetStornoAmInVtr (inVtr, SysDat);
         IF NOT UpdateVtr (inVtr, outMsg) THEN
         	String.Dispose (outMsg);
         END;
         DisposeDatum (SysDat);
         (* RETURN GehaltBuZurueck ( inVtr, outMsg)*)
	RETURN StornoGehaltBu ( LVtrIDinVtr (inVtr), outMsg);
    END; (* SucheKstZuKID *)

END StornierenVtr;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE GehaltBuZurueck ( inVtr : TVtr; VAR outMsg : TString) : BOOLEAN;
VAR outBu : TBu;
    neuBu : TBu;

	Betrag	: INTEGER;
	res, wahr: BOOLEAN;
	SysDat	: TDatum;

	outKstID : TKstID;
	outVtrID : TVtrID;
BEGIN

	Betrag := 0;
        outVtrID := LVtrIDinVtr (inVtr);
	SysDat := LSysDatumInSysDat ();

	IF ErsteGehaltBuZuVtr ( outVtrID , Gehalt, outBu) THEN
             	REPEAT
			SetStornoDatInBu (outBu, SysDat);
			IF NOT UpdateBu (outBu, outMsg) THEN
				String.Dispose (outMsg);
			END;
                      	neuBu := BCreateBu();
			WriteString ("Gegenbuchung erzeugt"); WriteLn;
			outKstID := LKstIDinVtr (inVtr);

			SetKstIDinBu (neuBu, outKstID);

			WriteString ("Gegenbu KstID gesetzt"); WriteLn;
                 	SetVtrIDinBu (neuBu, outVtrID );
                        SetBuDatInBu (neuBu, SysDat);
			Betrag := - LBetragInBu (outBu);
                 	SetBetragInBu(neuBu, Betrag);
                 	SetBuchungsArtInBu (neuBu, Sonst);
			res := EinfBu (neuBu, outMsg);
			DispBu (neuBu);

		UNTIL NOT NextGehaltBuZuVtr (outVtrID, Gehalt, outBu);
		DispBu(outBu);
	ELSE
		res := FALSE;
		WriteString ("Fehler der Gegenbuchung"); WriteLn;
	END;
        DisposeDatum (SysDat);
	WriteString ("Gegenbuchung Ende"); WriteLn;
	RETURN res
END GehaltBuZurueck;


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE  BerRestEtatDerKst(inKstID : TKstID): INTEGER;
(* -- Restetat := EtatDerKst ( inKstID );
   -- Restetat := Restetat - AbgebuGelderDerKst ( inKstID );

   -- Berechnung des geschaetzten WG-Anteils (probWGAnteil) :
   -- Alg.:
   -- alle gueltigen Vertraege aller HKs durchgehen, die den Stichtag, der am
   -- akt. Datum gueltigen WKond, enthalten.
   -- falls KstID im Vtr = inKstID und HK im Vtr WG-berechtigt ist
   --           probWGAnteil += WGAnteilDerKst (Vtr,STagDatum, WG)

   -- Fuer WG und WG-Anteilberechnung ist ein Datum notwendig,
   -- aus welchem man die gueltigen Konditionen bestimmen muss,
   -- Hierfuer kann das aktuelle Datum verwendet werden
   -- ( LSysDatumInSysDat ())

   -- RETURN Restetat - probWGAnteil
*)

VAR   Restetat		: INTEGER;
      probWGAnteil	: INTEGER;   (* geschaetzter WG-Anteil der Kst *)
      Anteil		: INTEGER;
      WGDerHK		: CARDINAL;
      outSysDat		: TDatum;
      STag		: TStag;
      STagDatum		: TDatum;     (* enthaelt den Stichtag der am akt.
                                         Datum gueltigen WKond *)
      outHK		: THK;
      outVtr		: TVtr;
      outWKond		: TKond;
BEGIN
      Restetat     := 0;
      probWGAnteil := 0;
      outSysDat    := LSysDatumInSysDat ();
      STagDatum    := DuplicateDatum (outSysDat);

      (* -- falls es eine HK und eine gueltige WKond gibt *)

  IF GetGueltigeWKond (outSysDat, outWKond) THEN

	STag := LSTagInWKond (outWKond);
        SetzeTagInDatum (STagDatum, LiesTagInStag (STag) );
        SetzeMonatInDatum (STagDatum, LiesMonatInStag (STag) );
        DisposeStag (STag);

      IF (FirstHK (outHK) AND SmallerDatum (outSysDat, STagDatum)) THEN

          REPEAT
	    (* -- alle gueltigen Vertraege, die den Stichtag enthalten
	       -- testen, ob sie die inKstID beinhalten, wenn ja,
	       -- testen, ob die dazugehoerige HK WG-berechtigt ist *)
	
            IF FirstValVtrZuHKmitZpunkt (LHKID (outHK), STagDatum, outVtr) THEN

                  REPEAT
                       IF IsEqualKstID ( inKstID, LKstIDinVtr(outVtr) ) THEN
	                   IF HKWGBerechtigt ( LHKID (outHK), outSysDat ) THEN
	                      WGDerHK := BerWGDerHK (outHK, outWKond, outSysDat);
	                      Anteil :=  WGAnteilDerKst (outVtr, STagDatum,
                                                         WGDerHK);
                              probWGAnteil := probWGAnteil + Anteil;
                           END; (* HKWGBerechtigt *)
                       END; (* IsEqualKstID *)

                  UNTIL NOT NextValVtrZuHKmitZpunkt ( LHKID (outHK),
                                                      STagDatum, outVtr );
                  DispVtr (outVtr);

            END; (* FirstValVtrZuHKmitZpunkt *)

          UNTIL NOT NextHK(outHK);
          DispHK (outHK)

      END; (* FirstHK *)
      DispKond (outWKond);
      DisposeDatum (STagDatum);
  END; (* GetWKond *)

  DisposeDatum (outSysDat);

  Restetat := EtatDerKst ( inKstID ) -
                           AbgebuGelderDerKst ( inKstID ) - probWGAnteil;
WriteString ("Restetat d. Kst:");WriteInt (Restetat, 10); WriteLn;

  RETURN Restetat

END BerRestEtatDerKst;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

END VtrVerw.
