(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HKeIMPORTE.mod,v $
# $Author: lurk $
# $Date: 2001/03/10 15:47:25 $
# $Revision: 1.2 $
# Bemerkungen:    

IMPLEMENTATION MODULE HKeIMPORT   TS-Import-Schnittstelle Hilfskraefte

Sigrid Preuss

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE HKeIMPORTE;

(* TS Hilfskrfte *)

FROM String IMPORT TString;

IMPORT VDat, HIDVerwaltung;


(* --------------------------------------------------------------------------
   -- Durchreichen der importierten Operationen
   -- Teilsystem HIDVerwaltung
   --------------------------------------------------------------------------
*)


PROCEDURE	DisposePersID (VAR inoutPersID : TPersID);
BEGIN
  HIDVerwaltung.DisposeHID(inoutPersID);
END DisposePersID;

PROCEDURE	DuplicatePersID (inPersID : TPersID)  : TPersID;
BEGIN
  RETURN HIDVerwaltung.DuplicateHID(inPersID);
END DuplicatePersID;

PROCEDURE	IsEqualPersID (inPersID1,inPersID2 : TPersID) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.IsEqualHID(inPersID1, inPersID2);
END IsEqualPersID;

PROCEDURE	EqualizePersID (inoutZielPersID : TPersID;
                                inQuellePersID : TPersID);
BEGIN
  HIDVerwaltung.EqualizeHID(inoutZielPersID, inQuellePersID);
END EqualizePersID;

PROCEDURE	SamePersID (inPersID1 : TPersID ;
                            inPersID2 : TPersID) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.SameSeqNrHID(inPersID1, inPersID2);
END SamePersID;

PROCEDURE	SmallerPersID (inPersID1 : TPersID;
                               inPersID2 : TPersID) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.SmallerSeqNrHID(inPersID1, inPersID2);
END SmallerPersID;

PROCEDURE	HoleNeuePersID () : TPersID;
BEGIN
  RETURN HIDVerwaltung.HoleNeueID();
END HoleNeuePersID;

PROCEDURE	UeberlasseAltePersID (inPersID : TPersID);
BEGIN
  HIDVerwaltung.UeberlasseAlteID(inPersID);
END UeberlasseAltePersID;



PROCEDURE       PruefePersID (inString : TString; VAR outMessage : TString
                             ) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.PruefeHID(inString, outMessage);
END PruefePersID;


PROCEDURE       PersIDAlsString (inPersID   : TPersID;
                                 inIDLaenge : CARDINAL) : TString;
BEGIN
  (* ID mit fuehrenden Nullen ausgeben *)
  RETURN HIDVerwaltung.HID2Str4SL(inPersID, inIDLaenge);
END PersIDAlsString;


PROCEDURE      StringInPersID (inString : TString) : TPersID;
BEGIN
  RETURN HIDVerwaltung.Str2HID(inString);
END StringInPersID;



(* --------------------------------------------------------------------------
   -- Durchreichen der importierten Operationen
   -- Teilsystem VDat (Virtuelles Dateisystem)
   --------------------------------------------------------------------------
*)


PROCEDURE WriteLineInVDat (inHandle : THandle; inString : TString;
                           VAR outMessage :TString) :BOOLEAN;
BEGIN
  RETURN VDat.WriteLineInVDat(inHandle, inString, outMessage);
END WriteLineInVDat;

PROCEDURE ReadLineInVDat (inHandle : THandle; VAR outString : TString;
                          VAR outMessage :TString) :BOOLEAN;
BEGIN
  RETURN VDat.ReadLineInVDat(inHandle, outString, outMessage);
END ReadLineInVDat;

PROCEDURE EofInVDat (inHandle : THandle) : BOOLEAN;
BEGIN
  RETURN VDat.EofInVDat(inHandle);
END EofInVDat;


END HKeIMPORTE.
