MODULE HIDTest;

   FROM InOut IMPORT ReadCard, WriteCard, WriteString, WriteLn;

   FROM InOut IMPORT ReadLn, ReadString;

   FROM SYSTEM  IMPORT TSIZE;

   IMPORT HIDVerwaltung;

   IMPORT VDat;
	 
   IMPORT String;
   IMPORT WholeStr;

   TYPE TID=HIDVerwaltung.TID; 
	 
   VAR Befehl          	: CARDINAL;
       MaxProcNr       	: CARDINAL;
       TestProcs        : ARRAY[0..22] OF PROC;
       IDVExistiert     : BOOLEAN;
       IDExistiert      : BOOLEAN;
       ID 		: TID;
 

  PROCEDURE CreateIDVerwaltung();
  BEGIN
    WriteString("Operation: HIDVerwaltung.CreateIDVerwaltung");
    WriteLn;
    IF IDVExistiert THEN
      WriteString ("Es ist bereits eine ID Verwaltung angelegt worden!");
      WriteLn;
    ELSE
      HIDVerwaltung.CreateIDVerwaltung();	 
      IDVExistiert := TRUE;
      WriteString("IDVerwaltung ist eingerichtet!");  
      WriteLn;  
    END; (* IF *)
    WriteLn;
  END CreateIDVerwaltung;

  PROCEDURE DisposeIDVerwaltung();
  BEGIN
    WriteString("Operation: HIDVerwaltung.DisposeIDVerwaltung");
    WriteLn;
    IF NOT IDVExistiert THEN
      WriteString ("Es wurde noch keine ID Verwaltung angelegt!");
      WriteLn;
    ELSE
      WriteString ("ID Verwaltung gelscht!");
      WriteLn;
      HIDVerwaltung.DisposeIDVerwaltung();
      IDVExistiert:=FALSE;
    END; (* IF *)
    WriteLn;
  END DisposeIDVerwaltung;

  PROCEDURE HoleNeueID();
  BEGIN
    WriteString("Operation:  HIDVerwaltung.HoleNeueID");
    WriteLn;
    IF NOT IDVExistiert THEN
      WriteString ("Es ist noch keine ID Verwaltung angelegt!");
      WriteLn;
    ELSE
      WriteString("Neue ID ist : ");
      
      ID:=HIDVerwaltung.HoleNeueID();
      IDExistiert:=TRUE;
      StringAusgeben(HIDVerwaltung.HID2Str4SL(ID,5));
      WriteLn; 
    END; (* IF *)
    WriteLn;
  END HoleNeueID;
 
  PROCEDURE UeberlasseAlteID();
  BEGIN
    WriteString("Operation:  HIDVerwaltung.UeberlasseAlteID");
    WriteLn;
    IF NOT IDVExistiert THEN
      WriteString ("Es ist noch keine ID Verwaltung angelegt!");
      WriteLn;
    ELSE
      IF IDExistiert THEN
        WriteString("Ueberlassen wird : ");
        
        StringAusgeben(HIDVerwaltung.HID2Str4SL(ID,5));
        HIDVerwaltung.UeberlasseAlteID(ID);
        WriteLn; 
      ELSE
        WriteString("ID muss erst geholt werden!");
	WriteLn;
      END; (* IF *) 
    END; (* IF *)
    WriteLn;
  END UeberlasseAlteID;


  PROCEDURE Save();
  VAR   H       : VDat.THandleInVDat;
        M       : VDat.TModusInVDat;
        message : String.TString;
        Filename: String.TString;
  BEGIN
    WriteString("Operation: SaveHIDVerwaltung.Save");
    WriteLn;
    WriteString("Der Inhalt der HID Verwaltung wird gespeichert:");
    WriteLn;
    M:=VDat.SetWriteInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"hid.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT HIDVerwaltung.SaveInHID(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("HID Ordner ist gespeichert!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END Save;    

  PROCEDURE Load();
  VAR   H       : VDat.THandleInVDat;
        M       : VDat.TModusInVDat;
        message : String.TString;
        Filename: String.TString;
  BEGIN
    WriteString("Operation: HIDVerwaltung.Load");
    WriteLn;
    WriteString("Der Inhalt der HID Verwaltung wird geladen:");
    WriteLn;
    M:=VDat.SetReadInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"hid.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT HIDVerwaltung.LoadInHID(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("HID Ordner ist geladen!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END Load;    

  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("CreateIDVerwaltung");
    MenueItem ("DisposeIDVerwaltung");
    MenueItem ("HoleNeueID");
    MenueItem ("UeberlasseAlteID");
    MenueItem ("Load");
    MenueItem ("Save");
 
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (CreateIDVerwaltung);
    ProcEintragen (DisposeIDVerwaltung);
    ProcEintragen (HoleNeueID);
    ProcEintragen (UeberlasseAlteID);
    ProcEintragen (Load);
    ProcEintragen (Save);

    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN

    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;

PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..50] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; inoutStr : String.TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
END StringEingeben;

BEGIN
  IDVExistiert:=TRUE;
  InitTestProcs;
  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;

END HIDTest.
