(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HIDVerwADO.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:29 $
# $Revision: 1.1.1.1 $
# Bemerkungen: 
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE (* -- Behaelter-ADO *) HIDVerwADO;
  IMPORT HIDVerwSchablone;

  VAR HiKS_IDVerwaltung : HIDVerwSchablone.TIDVerwaltung;

  PROCEDURE CreateIDVerwaltung () ;
  (* erzeuge neue HID Verwaltung *)
  BEGIN
    HiKS_IDVerwaltung := HIDVerwSchablone.Create ();
  END CreateIDVerwaltung;

  PROCEDURE DisposeIDVerwaltung ();
  BEGIN
    HIDVerwSchablone.Dispose (HiKS_IDVerwaltung);
  END DisposeIDVerwaltung;


  PROCEDURE GetNewID () : TID;
  (* -- Liefert eine z.Z. unbenutzte ID *)
  BEGIN
    RETURN HIDVerwSchablone.HoleNeueID (HiKS_IDVerwaltung);
  END GetNewID;

  PROCEDURE LeaveOldID ( inID        : TID);
  BEGIN
    HIDVerwSchablone.UeberlasseAlteID (HiKS_IDVerwaltung,inID); 
  END LeaveOldID;

  PROCEDURE GetHighestID(): TID;
  (* -- Vorbed.: es existiert wenigsten eine ID
     -- gibt die hoechste zuletzt vergebene ID zurueck
     -- Nachbed.: ist ID der Rueckgabewert dann gilt fr alle ID's i:
                  i > ID: i ist noch nicht vergeben *)
  BEGIN
    RETURN HIDVerwSchablone.GibHoechsteID(HiKS_IDVerwaltung);
  END GetHighestID;

  PROCEDURE SetHighestID(inID : TID);
  (* -- Vorbed.: fuer alle ID's i:
                 i > inID: i ist noch nicht vergeben *)
  BEGIN
    HIDVerwSchablone.SetzeHoechsteID(HiKS_IDVerwaltung,inID);
  END SetHighestID;  

  PROCEDURE FreeIDsAvailable(): BOOLEAN;
  (* -- Vorbed.: keine
     -- Nachbed.: FreieIDsVorhanden(inIV) <=> FreieIDListe ist nicht leer *)
  BEGIN
    RETURN HIDVerwSchablone.FreieIDsVorhanden(HiKS_IDVerwaltung);
  END FreeIDsAvailable;  

  PROCEDURE FirstFreeID(): TID;
  (* -- Vorbed.: FreieIDsVorhanden(inIV)
     -- gibt die erste Id der freien ID-Liste zurueck.
     -- Nachbed.: keine
  *)
  BEGIN
    RETURN HIDVerwSchablone.ErsteFreieID(HiKS_IDVerwaltung);
  END FirstFreeID;  
   
  PROCEDURE NextFreeID( VAR inoutID: TID): BOOLEAN;
  (* -- Vorbed.: inoutID existiert in der freien ID-Liste
     -- gibt die auf inID folgende freie ID der freien ID-Liste zurueck.
     -- Nachbed.: NaechsteFreieID(inIV, inoutID) <=> inID ist die letzte ID
                                                     der Liste
  *)    
  BEGIN
    RETURN HIDVerwSchablone.NaechsteFreieID(HiKS_IDVerwaltung,inoutID);
  END NextFreeID;    

  BEGIN
    CreateIDVerwaltung();
END HIDVerwADO.
