(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: KondenSpeichern.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:01 $
# $Revision: 1.1.1.1 $
# Bemerkungen:  Funktioniert!
*)
(******************************************************************************)


(* Modul zum Speichern des TS Konditionen. hgw, 08.02.2001                    *)
(* Kurze Beschreibung der Vorgehensweise:                                     *)
(* Der Inhalt des Konditionsordners wird als ASCII Text der Reihe nach in eine*)
(* bereits geoeffnete Datei geschrieben oder von dort gelesen. Es wird jeweils*)
(* ein Datum pro Zeile geschieben                                             *)

IMPLEMENTATION MODULE (* -- Modul *) KondenSpeichern;
   
  FROM KondenIMPORTE IMPORT THandle,ReadLine, WriteLine, Eof, HID2Str, Str2HID;
  FROM WholeStr IMPORT CardToStr,StrToCard,ConvResults;  
  IMPORT KondenOrdner;
  IMPORT Kondition;
  IMPORT String;
  IMPORT Strings;
  IMPORT Datum;
  
  TYPE 	TKID = KondenOrdner.TKID;
	TKondTyp=KondenOrdner.TKondTyp;
	TKond=KondenOrdner.TKond;
	TDatum=Datum.TDatum;
	TMonat=Datum.TMonat;
	TStag=Datum.TStag;
	TString=String.TString;
	



  PROCEDURE Load(	inH : THandle;
			VAR Message : TString) : BOOLEAN; 
  (* -- vb: Datei existiert, ist nicht leer und ist zum Lesen geoeffnet
     -- Lade den BackupKonditionenOrdner in KondenOrdner mit dem Inhalt
        der Datei auf die inH verweist.
     -- nb: BackupKonditionenOrdner in ADT KondenOrdner ist geladen  *)  

  VAR str	: TString;
      aktKID   	: TKID;
      success   : BOOLEAN;
      CharArray	: ARRAY [1..255] OF CHAR;
      Result	: ConvResults;  
      Dvon,Dbis : TDatum;
      aktKond   : TKond;
      aktKondTyp: TKondTyp;
      BHD,SOG,SS: CARDINAL;
      BM	: TMonat;
      Stag      : TStag;

  BEGIN
	KondenOrdner.BackupDispose();     (* BackupKonditionsOrdner wegwerfen *)
	KondenOrdner.CreateBackupKondenOrdner();      (* neuen Ordner anlegen *)


        success:=TRUE;

        BM:=Datum.CreateMonat();
        Stag:=Datum.CreateStag();
        Dvon:=Datum.CreateDatum();
        Dbis:=Datum.CreateDatum();

        WHILE NOT Eof(inH) DO
          IF ReadLine(inH, str, Message) THEN
            aktKID:=Str2HID(str);
	    String.Dispose(str); 
          ELSE
            success:=FALSE;
          END;

          IF ReadLine(inH, str, Message) THEN
            IF NOT Datum.DatumVonString(str,Dvon,Message) THEN
              success:=FALSE;
            END;
	    String.Dispose(str); 
          ELSE
            success:=FALSE;
          END;
          IF ReadLine(inH, str, Message) AND success THEN
            IF NOT Datum.DatumVonString(str,Dbis,Message) THEN
              success:=FALSE;
            END;
	    String.Dispose(str); 
          ELSE
            success:=FALSE;
          END;

          (* Die erzeugten KonditionsADOs werden in den Ordner eingefgt und *)
          (* deshalb nicht wieder disposed *)

          IF ReadLine(inH, str, Message) AND success THEN
            String.Lies(str,CharArray);
	    String.Dispose(str); 
            IF Strings.Equal(CharArray,"Vertrag") THEN
              aktKondTyp:=Vertrag;
              aktKond:=Kondition.CreateVertragsKondition();
  	    ELSIF Strings.Equal(CharArray,"Weihnacht") THEN  
              aktKondTyp:=Weihnacht;
              aktKond:=Kondition.CreateWeihnachtsKondition();
	    ELSIF Strings.Equal(CharArray,"Tarif") THEN
              aktKondTyp:=Tarif;
              aktKond:=Kondition.CreateTarifKondition();
            ELSE
              success:=FALSE; (* Es konnte kein Entittstyp erkannt werden *)
	    END (* IF *);
          END (* IF *);

          (* Falls bis hierher alles gut gegangen ist, werden jetzt die  *)
	  (* KID und die beiden Datum-Attribute ins ADO uebertragen *)

          IF success THEN
            Kondition.SetzeKID(aktKond,aktKID);
            Kondition.SetzeGueltigVon(aktKond,Dvon);
            Kondition.SetzeGueltigBis(aktKond,Dbis);
          END (* IF *);
          
          (* in Abhngigkeit des E-Typs werden jetzt die restlichen Attribute *)
          (* eingelesen. *) 
          CASE aktKondTyp OF 
	    Vertrag:	IF ReadLine(inH, str, Message) AND success THEN 
			  String.Lies(str,CharArray);
			  StrToCard(CharArray,BHD,Result); 
	                  String.Dispose(str); 
                        ELSE
                          success:=FALSE;
			END (* IF *); 
	    		IF ReadLine(inH, str, Message) AND success THEN 
			  String.Lies(str,CharArray);
			  StrToCard(CharArray,SOG,Result); 
	                  String.Dispose(str); 
 			  Kondition.SetzeBHD(aktKond,BHD);
			  Kondition.SetzeStundenobergrenze(aktKond,SOG);
			  KondenOrdner.BackupInsert(aktKond);
                        ELSE
                          success:=FALSE;
			END (* IF *); 
            |
	    Weihnacht: 	IF ReadLine(inH, str, Message) AND success THEN 
			  IF NOT Datum.MonatVonString(str,BM,Message) THEN
                            success:=FALSE;
			  END (* IF *); 
	                  String.Dispose(str); 
                        ELSE
                          success:=FALSE;
			END (* IF *); 
	    		IF ReadLine(inH, str, Message) AND success THEN 
			  IF NOT Datum.StagVonString(str,Stag,Message) THEN
			    success:=FALSE;
			  ELSE  
 			    Kondition.SetzeBemessungsmonat(aktKond,BM);
			    Kondition.SetzeStichtag(aktKond,Stag);
			    KondenOrdner.BackupInsert(aktKond);
			  END (* IF *);
	                  String.Dispose(str); 
                        ELSE
                          success:=FALSE;
			END (* IF *); 
			
            |
	    Tarif: 	IF ReadLine(inH, str, Message) AND success THEN 
			  String.Lies(str,CharArray);
	                  String.Dispose(str); 
			  StrToCard(CharArray,SS,Result); 
			  Kondition.SetzeStundensatz(aktKond,SS);
			  KondenOrdner.BackupInsert(aktKond);
                        ELSE
                          success:=FALSE;
			END (* IF *) 
	  ELSE
            success:=FALSE;
          END (* CASE *);
        END (* WHILE *);
 
	IF NOT success AND (Message=NIL) THEN
	  Message:=String.Create();
          String.Schreibe(Message,
           "Beim Lesen des Konditionsordners ist ein Fehler aufgetreten!");
        END (* IF *);
        Datum.DisposeMonat(BM);
        Datum.DisposeStag(Stag);
        Datum.DisposeDatum(Dvon);
        Datum.DisposeDatum(Dbis); 

        KondenOrdner.AktiviereRestore();   (* Diese Funktion sollte eigentlich
						extern aufgerufen werden *)
						
	RETURN success;
  END Load;

	 

  PROCEDURE Save(inH : THandle; VAR Message : TString):BOOLEAN; 
  (* -- vb: Datei existiert und ist zum Schreiben geoeffnet
     -- Speichert den Inhalt des KonditionenOrdners inoutKondOrdner in
        der Datei auf die inHandle verweist.
     -- nb: KonditionsOrdner-Inhalt in inoutKondOrdner ist auf SekundaerSpeicher
        geschrieben *)   

  VAR str	: TString;
      success   : BOOLEAN;
      CharArray	: ARRAY [1..255] OF CHAR;
      aktKond   : TKond;
      aktKondTyp: TKondTyp;
      stag	: TString;
  BEGIN
	success:=TRUE;
	IF KondenOrdner.First(aktKond) THEN
	  REPEAT

	    (* ID schreiben *)
	    str:=HID2Str(Kondition.LiesKID(aktKond),0);
	    IF NOT WriteLine(inH,str,Message) THEN
              success:=FALSE;
            END (* IF *);
	    String.Dispose(str);

	    (* GueltigVon schreiben *)
	    str:=Datum.DatumAlsString(Kondition.LiesGueltigVon(aktKond));
	    IF NOT WriteLine(inH,str,Message) THEN
	      success:=FALSE;
	    END (* IF *);
	    String.Dispose(str);

	    (* GueltigBis schreiben *)
	    str:=Datum.DatumAlsString(Kondition.LiesGueltigBis(aktKond));
	    IF NOT WriteLine(inH,str,Message) THEN
	      success:=FALSE;
	    END (* IF *);
	    String.Dispose(str);

	    aktKondTyp:=Kondition.LiesEntitaetsTyp(aktKond);
            (* in Abhngigkeit des E-Typs werden jetzt die restlichen *)
            (* Attribute geschrieben. *) 
            
	    str:=String.Create();
	    CASE aktKondTyp OF 
	      Vertrag:  String.Schreibe(str,"Vertrag");
			IF NOT WriteLine(inH, str, Message) THEN 
                          success:=FALSE;
			END (* IF *); 
	    		CardToStr(Kondition.LiesBHD(aktKond),CharArray);
			String.Schreibe(str,CharArray);
			IF NOT WriteLine(inH, str, Message) THEN 
                          success:=FALSE;
			END (* IF *); 
	    		CardToStr(Kondition.LiesStundenobergrenze(aktKond),
				CharArray);
			String.Schreibe(str,CharArray);
			IF NOT WriteLine(inH, str, Message) THEN 
                          success:=FALSE;
			END (* IF *); 
              |
	      Weihnacht:String.Schreibe(str,"Weihnacht");
                        IF NOT WriteLine(inH, str, Message) THEN
                          success:=FALSE;
                        END (* IF *);  
			CardToStr(Datum.MonatAlsCard
				(Kondition.LiesBemessungsmonat(aktKond)),
				CharArray);
			String.Schreibe(str,CharArray);
                        IF NOT WriteLine(inH, str, Message) THEN
                          success:=FALSE;
                        END (* IF *);  
		 	stag:=Datum.StagAlsString
				(Kondition.LiesStichtag(aktKond));
                        IF NOT WriteLine(inH, stag, Message) THEN
                          success:=FALSE;
                        END (* IF *);  
              |
	      Tarif: 	String.Schreibe(str,"Tarif");
                        IF NOT WriteLine(inH, str, Message) THEN
                          success:=FALSE;
                        END (* IF *);   
                        CardToStr(
			Kondition.LiesStundensatz(aktKond),CharArray);
			String.Schreibe(str,CharArray);
                        IF NOT WriteLine(inH, str, Message) THEN
                          success:=FALSE;
                        END (* IF *);  

	    ELSE
              success:=FALSE;
            END (* CASE *);
 	  UNTIL NOT success OR NOT KondenOrdner.Next(aktKond);
          String.Dispose(str); 	    
	  Kondition.Dispose(aktKond);	    
	END (* IF KondenOrdner.First...*);  
	    
        IF NOT success THEN
          String.Schreibe(Message,
           "Beim Schreiben des Konditionsordners ist ein Fehler aufgetreten!");
        END (* IF *);
 
	RETURN success;			
	
  END Save;

END KondenSpeichern.
