IMPLEMENTATION MODULE FSetDatumSysVw;

FROM SYSTEM    IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik  IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik  IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik  IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik  IMPORT StelleTextDar, EntferneText;
FROM X_Grafik  IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik  IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik  IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik  IMPORT MeldungAnzeigen,JaNeinAbfrage;
FROM X_Grafik  IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik  IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik  IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik  IMPORT LiesMenueEintrag, EntferneMenue;
FROM SYSTEM    IMPORT CAST, ADR, ADDRESS;
FROM args      IMPORT GetArgs, ArgTable;
FROM InOut     IMPORT WriteString,WriteLn,WriteInt;
FROM DialogLib IMPORT DatumKorrekt;

IMPORT Datum;
IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT SysDat;
IMPORT Adm;
IMPORT Auto;


VAR

  FensterHandle	  	: ADDRESS;
  VaterFenster		: ADDRESS;
  Vater			: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  DatumFeldHandle	: ADDRESS;
  DatEingHelpMeldung	: ADDRESS;
  UpsMeldung         	: ADDRESS;
  AutoKnopf          	: ADDRESS;
  AutoEndeMeldHandle	: ADDRESS;
  DatOkKnopfHandle  	: ADDRESS;
  VersInfoMeldHdle1  	: ADDRESS;
  VersInfoMeldHdle2  	: ADDRESS;
  AutoDatumMeldung   	: ADDRESS;
  AutoDatumTitel     	: ADDRESS;
  DatumString        	: String.TString;
  inTitel 	      	: String.TString;
  error			: String.TString;
  ups                	: String.TString;
  errmessg		: String.TString;
  MeldHandle1        	: ADDRESS;
  MeldHandle2	      	: ADDRESS;
  AutoBetriebStarten 	: BOOLEAN;



TYPE TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;


(*----------------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeKnoepfe();
VAR Titel : String.TString;
BEGIN
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,380,220,CAST(PROC,EndeKnopfCallback));
END ErzeugeKnoepfe;

(*----------------------------------------------------------------------------------------*)


PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
  Dispose();
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE MaskeDatumEingabe;
VAR Titel,Text,s  : String.TString;
    inSpalten,inXPosition,inYPosition : INTEGER;
    LastAutoDate : Datum.TDatum;
BEGIN
   Titel := String.Create();

   String.Schreibe(Titel,"Letztes Autodatum");
   AutoDatumTitel := StelleMeldungDar(Titel,TRUE,FensterHandle,185,30);

   LastAutoDate   := SysDat.LiesLetztesAutoDatumInSysDat();

   s :=  Datum.DatumAlsString(LastAutoDate);
   AutoDatumMeldung := StelleMeldungDar(s,FALSE,FensterHandle,210,50);
   String.Dispose(s);

   Datum.DisposeDatum(LastAutoDate);

   String.Schreibe(Titel,"Neues SystemDatum eingeben: ");
   Text := String.Create();
   String.Schreibe(Text,"");
   DatumFeldHandle := StelleZeileDar(Titel,Text,10,FensterHandle,30,130);

   String.Schreibe(Titel,"(TT.MM.JJJJ)");
   DatEingHelpMeldung := StelleMeldungDar(Titel,FALSE,FensterHandle,255,150);

   String.Schreibe(Titel,"bernehmen");
   DatOkKnopfHandle := StelleKnopfDar(Titel,FensterHandle,380,120,CAST(PROC,DatumEingabeCallback));
   String.Dispose(Titel);
   String.Dispose(Text);
END MaskeDatumEingabe;

(*----------------------------------------------------------------------------------------*)

PROCEDURE DatumEingabeCallback();
VAR
   SysDatum     : Datum.TDatum;
   LastAutoDate : Datum.TDatum;
   s            : String.TString;

BEGIN
  DatumString := String.Create();
  LiesZeile(DatumFeldHandle,DatumString);
  IF NOT Datum.DatumVonString ( DatumString, SysDatum, error ) THEN
    MeldungAnzeigen(error);
    String.Dispose(error);
  ELSE
    (* Pruefe LastAutoDatum < Tagesdatum *)

    LastAutoDate := SysDat.LiesLetztesAutoDatumInSysDat();

    (* Falls LastAutoDate=undef ist wird LastAutoDate=Systemdatum gesetzt *)
    IF Datum.IstDatumEternity(LastAutoDate) THEN
	SysDat.SetzeLetztesAutoDatumInSysDat(SysDatum);
	LastAutoDate := SysDat.LiesLetztesAutoDatumInSysDat();  
    END (* IF *);

    IF Datum.SmallerDatum(SysDatum,LastAutoDate) THEN
      s := String.Create();
      String.Schreibe(s,"Systemdatum mu '>=' Datum des letzten Autobetriebes sein");
      MeldungAnzeigen(s);
      String.Dispose(s);
      ups := String.Create();
      String.Schreibe(ups,"U  U U UPS!!!");
      UpsMeldung := StelleMeldungDar(ups,TRUE,FensterHandle,250,100);     
      IF inTitel # NIL THEN
        String.Dispose(inTitel);
        inTitel := NIL;
      END (* IF *);
  
      IF UpsMeldung # NIL THEN
        EntferneMeldung(UpsMeldung);
        UpsMeldung := NIL;
      END (* IF *);
  
      IF DatumString # NIL THEN
        String.Dispose(DatumString);
        DatumString:=NIL;
      END (* IF *);
    ELSE

      (* Schreibe das neue Systemdatum ins SysDat - ADO *)
  
      SysDat.SetzeSystemDatumInSysDat(SysDatum);
  
      (* Baue neue Maske auf *)
  
      EntferneZeile(DatumFeldHandle);
      EntferneMeldung(DatEingHelpMeldung);
      EntferneKnopf(DatOkKnopfHandle);
      inTitel := String.Create();
      String.Schreibe(inTitel,"SystemDatum");
      MeldHandle1 := StelleMeldungDar(inTitel,TRUE,FensterHandle,195,140);
      MeldHandle2 := StelleMeldungDar(DatumString,FALSE,FensterHandle,208,160);
      IF AutoBetriebStarten THEN
        AutoBetriebStart();
      END (* IF *);
    END (* IF *);
  END (* IF *);

END DatumEingabeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE AutoKnopfCallback;
(* Durchfhrung des Automatischen Betriebes --> TS_ADM *)
VAR Titel : String.TString;
BEGIN
  IF NOT(UpsMeldung=NIL) THEN
    EntferneMeldung(UpsMeldung);
    UpsMeldung := NIL;
  END;
  EntferneKnopf(AutoKnopf);
  AutoKnopf:=NIL;
  Titel := String.Create();
  String.Schreibe(Titel,"Auto - Betrieb beendet");
  AutoEndeMeldHandle := StelleMeldungDar(Titel,TRUE,FensterHandle,210,210);
END AutoKnopfCallback;


(*----------------------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel : String.TString;
BEGIN
 Vater := inFunct;
 Titel := String.Create();
 String.Schreibe(Titel,"hiks.Systemverwaltung.DatumEingeben");
 FensterHandle :=  NeuesFenster( Titel,170,200,300,500);
 ErzeugeKnoepfe();
 MaskeDatumEingabe();
END Create;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
 EntferneFenster(FensterHandle);
 AktiviereVater := CAST(TActVater,Vater);
 AktiviereVater();
END Dispose;
(*----------------------------------------------------------------------------------------*)

PROCEDURE AutoBetriebStart();
VAR 	Titel 			: String.TString;
	LetztesAutoDatum	: Datum.TDatum;
	AktDatum		: Datum.TDatum;
        Meldung                 : ADDRESS;
BEGIN
  LetztesAutoDatum:=SysDat.LiesLetztesAutoDatumInSysDat();
  AktDatum:=SysDat.LiesSystemDatumInSysDat();

  Auto.NachziehenAutoBuen(LetztesAutoDatum,AktDatum);

  SysDat.SetzeLetztesAutoDatumInSysDat(AktDatum);
  Datum.DisposeDatum(AktDatum);
  Datum.DisposeDatum(LetztesAutoDatum);
  Titel := String.Create();
  String.Schreibe(Titel,"Autobetrieb beendet");
  Meldung := StelleMeldungDar(Titel,TRUE,FensterHandle,170,220);
  String.Dispose(Titel);
END AutoBetriebStart;

(*---------------------------------------------------------------------------------------- *)
PROCEDURE SetAutoBetriebAktiv();
BEGIN
  AutoBetriebStarten := TRUE;
END SetAutoBetriebAktiv;
(*------------------------------------------------------------------------------------------*)

BEGIN
  AutoBetriebStarten := FALSE;
  ups           := NIL;
  UpsMeldung    := NIL;
  inTitel       := NIL;
  DatumString   := NIL;
END FSetDatumSysVw.

