(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: MAIN.MOD,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:24 $
# $Revision: 1.1.1.1 $
# Bemerkungen:

MODULE main;

Johannes Magauer

*)
(******************************************************************************)

MODULE main;

FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM args IMPORT GetArgs, ArgTable;
FROM WholeStr IMPORT ConvResults, StrToCard;
IMPORT String;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM FAnlegenHK IMPORT CreateFAnlegen;
FROM FAendernHK IMPORT CreateFAendern;
FROM FSelektionHK IMPORT CreateFSelektion;
IMPORT HKe;


(* ACHTUNG : Das Programm entfernt keine erzeugten Strings und
** Stringlisten. Die X-Grafik-Bibliothek kopiert alle Strings, so
** dass diese nach Erzeugung der Fenster geloescht werden koennten. 
** Das Schliessen eines Fensters ueber die Window s-Menue-Leiste wird 
** von der X-Grafik-Bibliothek nicht erkannt und ist verboten. 
*)

  TYPE 	TFMainDS = RECORD
		     WinHdle,
		     Knopf1,
		     Knopf2,
		     Knopf3: ADDRESS;
		   END;	 (* und deren Elemente *)
       	TPFMain = POINTER TO TFMainDS;

  VAR
     HauptfensterHandle: ADDRESS;
     Args    : ArgTable;
     AnzArgs : CARDINAL;
     ichSelbst: TPFMain; (* Zeiger auf ADT Fenster Main *)
     meineAddr: ADDRESS; (* Addresse dazu *)
     reaktProc: TProc;

(* --------------------------------------------------------------- *)

PROCEDURE KnoepfeAnlegen();
  VAR
    StartKnopfText,
    EndeKnopfText,
    AendernKnopfText: String.TString;
    StartKnopfHandle,
    EndeKnopfHandle,
    AendernKnopfHandle: ADDRESS;
  BEGIN
    EndeKnopfText := String.Create();
    String.Schreibe(EndeKnopfText,"Ende");
    EndeKnopfHandle := StelleKnopfDar(EndeKnopfText,ichSelbst^.WinHdle,10,50,CAST(PROC,EndeKnopfCallback));
    String.Dispose(EndeKnopfText);

    StartKnopfText := String.Create();
    String.Schreibe(StartKnopfText,"Hilfskraft anlegen");
    StartKnopfHandle := StelleKnopfDar(StartKnopfText,ichSelbst^.WinHdle,100,50,CAST(PROC,StartKnopfCallback));
    String.Dispose(StartKnopfText);

    AendernKnopfText := String.Create();
    String.Schreibe(AendernKnopfText,"Hilfskraft selektieren");
    AendernKnopfHandle := StelleKnopfDar(AendernKnopfText,ichSelbst^.WinHdle,250,50,CAST(PROC,AendernKnopfCallback));
    String.Dispose(AendernKnopfText);

    WITH ichSelbst^ DO
      Knopf1:= EndeKnopfHandle;
      Knopf2:= StartKnopfHandle;
      Knopf3:= AendernKnopfHandle;
    END (*WITH*)
  END KnoepfeAnlegen;

PROCEDURE EndeKnopfCallback();
  BEGIN
    DisposeFMain();
  END EndeKnopfCallback;

PROCEDURE StartKnopfCallback();
  BEGIN
    DeaktFMain();
    CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END StartKnopfCallback;

PROCEDURE AendernKnopfCallback();
  BEGIN
    DeaktFMain();
    CreateFSelektion();
    (* Neues Fenster erzeugen *)
  END AendernKnopfCallback;

PROCEDURE DisposeFMain();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren *)
    KnoepfeEntfernen();
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    DISPOSE(ichSelbst);
    (* Lschen des letzten Stapeleintrages *)
  END DisposeFMain;

PROCEDURE KnoepfeEntfernen();
  BEGIN
    EntferneKnopf(ichSelbst^.Knopf1);
    EntferneKnopf(ichSelbst^.Knopf2);
    EntferneKnopf(ichSelbst^.Knopf3);
  END KnoepfeEntfernen;

PROCEDURE DeaktFMain();
  BEGIN
    SetzeKnopf(ichSelbst^.Knopf1, FALSE);
    SetzeKnopf(ichSelbst^.Knopf2, FALSE);
    SetzeKnopf(ichSelbst^.Knopf3, FALSE);
  END DeaktFMain;

PROCEDURE ReaktFMain();                                                           		
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren *)
    SetzeKnopf(ichSelbst^.Knopf1, TRUE);
    SetzeKnopf(ichSelbst^.Knopf2, TRUE);
    SetzeKnopf(ichSelbst^.Knopf3, TRUE);
  END ReaktFMain;

BEGIN
  GetArgs (AnzArgs,Args);
  HauptfensterHandle := InitialisiereGrafik(AnzArgs,Args,10,10,500,500);
  (* Addresse des Fensterrahmens bestimmen *)

  NEW (ichSelbst);
  (* Speicherplatz fr den "ADT Fenster Main" reservieren *)
  meineAddr:= CAST(ADDRESS, ichSelbst);
  (* Zeiger auf die Addresse des "ADT Fenster Main" bestimmen *)
  Push(ReaktFMain, meineAddr);
  (* Reaktivierungsprozedur des "ADT Fenster Main" und dessen Addresszeiger auf Stapel legen *)
  ichSelbst^.WinHdle:= HauptfensterHandle;
  (* Addresszeiger des Fensterrahmens im "ADT Fenster Main" eintragen *)
  KnoepfeAnlegen();
  StarteGrafik();
END main.
