(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: SysKstIMPORT.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 10:17:28 $
# $Revision: 1.2 $
# Bemerkungen: SysHK TS-Schnittstelle GRABO
	JZ
*)
(******************************************************************************)
 

MODULE SysKstIMPORT;

(* Modul zur Bndelung der Importe des TS_SysKst *)
FROM Datum 	IMPORT 	TDatum, TTag, TMonat, TJahr, TStag;
FROM String 	IMPORT 	TString;
FROM Stringliste 	IMPORT 	TStringliste;

FROM Vtre	IMPORT 	TVtrID, TVtr;




FROM Buen	IMPORT 	TBu, TBuID, CreateBu, DisposeBu, DuplicateBu, IsEqualBu, EqualizeBu, LiesBuIDinBu,
LiesKstIDinBu, SetzeKstIDinBu, LiesVtrIDinBu, SetzeVtrIDinBu, LiesBetraginBu,
SetzeBetraginBu, LiesGebuchtAminBu, SetzeGebuchtAminBu, LiesStorniertAminBu, 
SetzeStorniertAminBu, IstStorniertinBu, LiesBuchungsArtinBu,
SetzeBuchungsArtinBu, BuIDAlsString, StringInBuID, PruefeBuID, ExistiertBuIDBu;



FROM Ksten	IMPORT 	TKstID, TKst, CreateKst, SetzeKIDinKst, LiesKIDinKst,
SetzeEingAminKst, LiesEingAminKst, 			SetzeGesperrtAminKst,
LiesGesperrtAminKst,IstGesperrtAminKst,SetzeLiquidAminKst, 	
	LiesLiquidAminKst, IstLiquidiertAminKst, SetzeNameinKst,
LiesNameinKst, 			SetzeJahrinKst,LiesJahrinKst,
SetzeKontinginKst, LiesKontinginKst, SetzeAequivinKst, 		
LiesAequivinKst, ExistKst, KstIDAlsString, StringInKstID, PruefeKstID, 
GibKstenAlsStringlisteInKsten, 
SearchKstZuKID;



FROM Konden	IMPORT 	TKond, CreateVertragsKondition,
CreateWeihnachtsKondition, CreateTarifkondition, DisposeKond,
SetzeGueltVoninKond, LiesGueltVoninKond, SetzeGueltBisinKond,
LiesGueltBisinKond, SetzeBHDinVKond, LiesBHDinVKond, SetzeSOGinVKond,
LiesSOGinVKond, SetzeStdSinTKond, LiesStdSinTKond, SetzeSTaginWKond,
LiesSTaginWKond, SetzeBemMonatinWKond, LiesBemMonatinWKond, HoleGueltigeVKond,
HoleGueltigeTKond, HoleGueltigeWKond;




FROM PSB	IMPORT 	SperrenKst, EntsperrenKst, EinrichtenKst, BearbeitenBuchenKst,
BearbeitenAendernKst, TKondGeprueftEinf, WKondGeprueftEinf, VKondGeprueftEinf;




VAR

Kst:TKst;
KstID:TKstID;
D:TDatum;
BOL:BOOLEAN;
Str:TString;
Strl:TStringliste;
Jahr:TJahr;
Monat:TMonat;
Tag:TTag;
Card:CARDINAL;
Bu:TBu;
BuID:TBuID;
Kond:TKond;
VtrID:TVtrID;
INT:INTEGER;
STag:TStag;


BEGIN


Kst:=CreateKst();
SetzeKIDinKst (KstID, Kst);
KstID:=LiesKIDinKst(Kst);
SetzeEingAminKst(D, Kst);
D:=LiesEingAminKst(Kst);
SetzeGesperrtAminKst (D, Kst);
D:=LiesGesperrtAminKst (Kst);
BOL:=IstGesperrtAminKst (Kst);
SetzeLiquidAminKst (D, Kst);
D:=LiesLiquidAminKst (Kst);
BOL:=IstLiquidiertAminKst (Kst);
SetzeNameinKst (Str, Kst);
Str:=LiesNameinKst (Kst);
SetzeJahrinKst (Jahr, Kst);
Jahr:=LiesJahrinKst (Kst);
SetzeKontinginKst (Card, Kst);
Card:=LiesKontinginKst (Kst);
SetzeAequivinKst (Card, Kst);
Card:=LiesAequivinKst (Kst);

BOL:=ExistKst(Kst);

Str:=KstIDAlsString (KstID);
KstID:=StringInKstID (Str);
BOL:=PruefeKstID (Str, Str);


BOL:=SearchKstZuKID(KstID, Kst);


Strl:=GibKstenAlsStringlisteInKsten();



BOL:=EinrichtenKst (Kst, Str);
BOL:=BearbeitenBuchenKst (Bu, Kst, Str);
BOL:=BearbeitenAendernKst (Kst, Str);

BOL:=TKondGeprueftEinf (Kond, Str);
BOL:=WKondGeprueftEinf (Kond, Str);
BOL:=VKondGeprueftEinf (Kond, Str);

BOL:=SperrenKst(Kst, Str);
BOL:=EntsperrenKst(Kst, Str);




Bu:=CreateBu ();
DisposeBu (Bu);

BuID:=LiesBuIDinBu (Bu);
KstID:=LiesKstIDinBu (Bu);

SetzeKstIDinBu (Bu, KstID);

VtrID:=LiesVtrIDinBu (Bu);
SetzeVtrIDinBu (Bu, VtrID);

INT:=LiesBetraginBu (Bu);
SetzeBetraginBu (Bu, INT);

D:=LiesGebuchtAminBu (Bu);
SetzeGebuchtAminBu (Bu, D);

D:=LiesStorniertAminBu (Bu);
SetzeStorniertAminBu (Bu, D);

BOL:=IstStorniertinBu (Bu);

Str:=LiesBuchungsArtinBu (Bu);
SetzeBuchungsArtinBu (Bu, Str);

Str:=BuIDAlsString (BuID);
BuID:=StringInBuID (Str);
BOL:=PruefeBuID  (Str, Str);

BOL:=ExistiertBuIDBu (Bu);




Kond:=CreateVertragsKondition ();
Kond:=CreateWeihnachtsKondition ();
Kond:=CreateTarifkondition();
        
DisposeKond (Kond);

        
SetzeGueltVoninKond (D, Kond);
D:=LiesGueltVoninKond (Kond);
SetzeGueltBisinKond (D, Kond);
D:=LiesGueltBisinKond(Kond);
BOL:=SetzeBHDinVKond(Kond, Card);
Card:=LiesBHDinVKond(Kond);
BOL:=SetzeSOGinVKond(Kond, Card);
Card:=LiesSOGinVKond( Kond);
BOL:=SetzeStdSinTKond(Kond, Card);
Card:=LiesStdSinTKond( Kond);
BOL:=SetzeSTaginWKond(Kond, STag);
STag:=LiesSTaginWKond( Kond);
BOL:=SetzeBemMonatinWKond(Kond, Monat);
Monat:=LiesBemMonatinWKond( Kond);


BOL: =HoleGueltigeVKond( D, Kond);
BOL:=HoleGueltigeTKond( D, Kond);
BOL:=HoleGueltigeWKond( D, Kond);






END SysKstIMPORT.
