(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FBuchenKst;
Funktion: Kostenstelle buchen

JZ

V 0.7   2.3.01  17:20

*)
(******************************************************************************)

IMPLEMENTATION MODULE FBuchenKst;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;



(* HiKS-Importe *)
FROM SysReaktFStapel 	IMPORT Push, Pop, Top, TProc;
IMPORT Datum;
FROM Ksten IMPORT 	TKstID, TKst, CreateKst,
			DisposeKstID, SetzeKIDinKst, LiesKIDinKst,
 			SetzeEingAminKst, LiesEingAminKst,
 			SetzeGesperrtAminKst, LiesGesperrtAminKst, IstGesperrtAminKst,
 			SetzeLiquidAminKst, LiesLiquidAminKst, IstLiquidiertAminKst,
			SetzeNameinKst, LiesNameinKst,
			SetzeJahrinKst, LiesJahrinKst,
			SetzeKontinginKst, LiesKontinginKst,
			SetzeAequivinKst, LiesAequivinKst,
			ExistKst,
			KstIDAlsString, StringInKstID, PruefeKstID,
			GibKstenAlsStringlisteInKsten,
			InsertKst, AendernKst,
			SearchKstZuKID;
FROM Buen IMPORT 	TBuID, TBu, TBuArt,
			DisposeBuID, DuplicateBuID, IsEqualBuID, EqualizeBuID, SmallerBuID, SameBuID,
                	CreateBu, DisposeBu, DuplicateBu, IsEqualBu, EqualizeBu,
                	LiesBuIDBu, ExistiertBuIDBu, PruefeBuID, BuIDAlsString, StringInBuID,
                	LiesKstIDinBu, SetzeKstIDinBu, ExistiertKstIDinBu,
                	LiesVtrIDinBu, SetzeVtrIDinBu, ExistiertVtrIDinBu,
                	LiesBetraginBu, SetzeBetraginBu,
                	LiesGebuchtAminBu, SetzeGebuchtAminBu,
                	LiesStorniertAminBu, SetzeStorniertAminBu, IstStorniertinBu,
                	LiesBuchungsArtinBu, SetzeBuchungsArtinBu,
                	InsertBu, SearchBu, UpdateBu,
                	BerGebGelderDerKst,
                	StorniereBuZuVtr,
                	FirstBu, NextBu,
                	FirstBuZuKst, NextBuZuKst,
                	FirstBuZuVtr, NextBuZuVtr,
                	FirstBuMitBuArtZuVtr, NextBuMitBuArtZuVtr,
                	FirstBuUndStorno, NextBuUndStorno,
                	GibBuenAlsStringlisteinBuen,
                	LoadinBuen, SaveinBuen;


(*
FROM PSB IMPORT	BearbeitenBuchenKst;
*)


  TYPE 	TFBuchenKstDS = RECORD
		           WinHdle : ADDRESS;
		           BuchenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		
			   KstIDHdle,
			   NameHdle,
			   JahrHdle,
			   GesperrtAmHdle,
			   LiquidiertAmHdle,
			   BuchungsArtHdle, BuchungsArtInfoHdle,
			   BetragHdle : ADDRESS;
  	      		   Kst: TKst;
			   KstID: TKstID;
  	   		   KstIDString: String.TString;
  	      		 END;	
        TPFBuchenKst = POINTER TO TFBuchenKstDS;



(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfY1Pos=INT(185);
    KnopfY2Pos=INT(250);
    BuchenKnopfXPos=INT(40);
    LoeschenKnopfXPos=INT(160);
    AbbrechenKnopfXPos=INT(340);
  VAR
    KnopfText: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBuchenKst;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)

    InitEinAusgabeFelder();

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    KnopfText := String.Create();

    String.Schreibe(KnopfText,"Buchen");
    ichSelbst^.BuchenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, BuchenKnopfXPos, KnopfY2Pos, CAST(PROC,BuchenKnopfCallback));

    String.Schreibe(KnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, KnopfY2Pos, CAST(PROC,AbbrechenKnopfCallback));

    String.Dispose(KnopfText);
    IF TRACE THEN WriteString("FBuchenKst.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;




PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FBuchenKst.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE BuchenKnopfCallback();
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, BetragString, BuchungsArtString: String.TString;
    TextStr, MeldStr, KstIDStr, NameStr, JahrStr, BetragStr, BuchungsArtStr: ARRAY[1..200] OF CHAR;
    Betrag: INTEGER;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBuchenKst;
    Format: ConvTypes.ConvResults;
    DatenOkay: BOOLEAN;
    KstID: TKstID;
    Kst: TKst;
    Jahr: Datum.TJahr;
    Bu: TBu;
    Listenelement: String.TString;
    KstStringListe: Stringliste.TStringliste;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.BuchenKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    DatenOkay:=TRUE;

    MeldString:=String.Create();


    String.Lies(ichSelbst^.KstIDString, KstIDStr);

    BetragString:=String.Create();
    LiesZeile(ichSelbst^.BetragHdle, BetragString);
    String.Lies(BetragString, BetragStr);

    BuchungsArtString:=String.Create();
    LiesZeile(ichSelbst^.BuchungsArtHdle, BuchungsArtString);
    String.Lies(BuchungsArtString, BuchungsArtStr);


    IF TRACEDATEN THEN
      WriteString("Buchen Kst: KstID:"); WriteString(KstIDStr); WriteString(":");
      WriteString("BuchnugsArt:"); WriteString(BuchungsArtStr); WriteString(":");
      WriteString("Betrag:"); WriteString(BetragStr); WriteString(":");
    END;



    (* Betrag prfen und konvertieren *)
    IF StrToInteger(BetragStr,Betrag) THEN
      IF TRACEDATEN THEN
        WriteString(" Betrag:"); WriteInt(Betrag,5); WriteString(":");
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Der Buchungsbetrag ist ungueltig (nicht ganzzahlig)");
    END;

    (* BuchungsArt prfen *)
    IF Strings.Equal(BuchungsArtStr,"a") OR Strings.Equal(BuchungsArtStr,"g") OR
       Strings.Equal(BuchungsArtStr,"s") OR Strings.Equal(BuchungsArtStr,"w") THEN
      IF TRACEDATEN THEN
        WriteString(" BuchungsArt:"); WriteString(BuchungsArtStr); WriteString(":");
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Der BuchungsArt ist ungueltig ( a g s w)");
    END;
    IF TRACEDATEN THEN
      WriteLn;
    END;



    (* Sind die eingegeben Buchungsdaten okay, dann wird die Buchung durchgefuehrt *)
    IF DatenOkay THEN
       Bu:=CreateBu();
       SetzeBetraginBu(Bu, Betrag);

       IF Strings.Equal(BuchungsArtStr,"a") THEN
         SetzeBuchungsArtinBu(Bu, Abschluss);
       ELSIF Strings.Equal(BuchungsArtStr,"g") THEN
         SetzeBuchungsArtinBu(Bu, Gehalt);
       ELSIF Strings.Equal(BuchungsArtStr,"s") THEN
         SetzeBuchungsArtinBu(Bu, Sonst);
       ELSE (* Strings.Equal(BuchungsArtStr,"w")  *)
         SetzeBuchungsArtinBu(Bu, WG);
       END;

       SetzeKstIDinBu(Bu, ichSelbst^.KstID);


(*
       IF BearbeitenBuchenKst(Bu, ichSelbst^.Kst, MeldString) THEN
         AusgebenMeldung("Buchung wurde durchgefuehrt");
*)
       IF InsertBu(Bu, MeldString) THEN
         AusgebenMeldung("Buchung wurde durchgefuehrt");
       ELSE
         String.Lies(MeldString, MeldStr);
         Strings.Append("Meldung Bu:", MeldStr);
         AusgebenMeldung(MeldStr);
       END;

    END;


    (* groes bereinigen *)
    KstStringListe:=GibBuenAlsStringlisteinBuen();
    WHILE NOT (Stringliste.IsEmpty(KstStringListe)) DO
      Stringliste.GoStart(KstStringListe);
      Listenelement:=Stringliste.Current(KstStringListe);
      String.Lies(Listenelement, TextStr);
      String.Dispose(Listenelement);
      IF TRACEDATEN THEN
        WriteString("  Bu:"); WriteString(TextStr); WriteString(":"); WriteLn;
      END;
      Stringliste.Delete(KstStringListe);
    END;
    Stringliste.Dispose(KstStringListe);

    String.Dispose(MeldString);
    String.Dispose(BuchungsArtString);
    String.Dispose(BetragString);
    IF TRACE THEN WriteString("FBuchenKst.BuchenKnopfCallback End"); WriteLn; END;
  END BuchenKnopfCallback;





PROCEDURE CreateFAnlegen(inKstIDString:String.TString);
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFBuchenKst;
      meineAddr: ADDRESS;
      reaktProc: TProc;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Kostenstelle buchen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    ichSelbst^.KstIDString:=String.Duplicate(inKstIDString);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FBuchenKst.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;




PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;

  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

(*  LoeschenEinAusgabeFelder();
    EntferneKnopf(ichSelbst^.BuchenKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);   (* nicht alles entfernt !! *)
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FBuchenKst.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.DeaktFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);
    (*  Deaktiviere Knpfe  *)
    SetzeKnopf(ichSelbst^.BuchenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FBuchenKst.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.ReaktFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);
    (* Aktiviere alle Knoepfe *)
    SetzeKnopf(ichSelbst^.BuchenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FBuchenKst.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;




PROCEDURE InitEinAusgabeFelder();
  CONST
      XPos=INT(40);
      KstIDYPos=INT(50);
      KstIDLaen=INT(5);           
      NameYPos=INT(70);
      NameLaen=INT(20);           
      JahrYPos=INT(90);
      JahrLaen=INT(4);           
      GesperrtAmYPos=INT(110);
      GesperrtAmLaen=INT(10);
      LiquidiertAmYPos=INT(130);
      LiquidiertAmLaen=INT(10);
      BetragYPos=INT(170);
      BetragLaen=INT(4);
      BuchungsArtYPos=INT(190);
      BuchungsArtLaen=INT(1);
      BuchungsArtInfoXPos=INT(200);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
      Text, Inhalt: String.TString;
      MeldStr: ARRAY [1..200] OF CHAR;
      ZWString, MeldString: String.TString;
      DatumString, KstIDString, NameString, JahrString, BetragString,GesperrtAmString,
					LiquidiertAmString, BuchungsArtString: String.TString;
      KstIDStr, NameStr, JahrStr, BetragStr, BuchungsArtStr, LiquidiertAmStr,
      					GesperrtAmStr: ARRAY[1..200] OF CHAR;
      Betrag: INTEGER;

      Jahr: Datum.TJahr;
      EingegebenAm,
      GesperrtAm,
      LiquidiertAm: Datum.TDatum;
      ZWDatum: Datum.TDatum;
      Kontingent: CARDINAL;
      Aequivalent: CARDINAL;

  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.InitEinAusgabeFelde Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();


    KstIDString:=String.Duplicate(ichSelbst^.KstIDString);
    IF  PruefeKstID(KstIDString, MeldString) THEN
        ichSelbst^.KstID:=StringInKstID(KstIDString);
    ELSE
        String.Lies(MeldString, MeldStr);
        Strings.Append("Medlung zu KstID:", MeldStr);
        AusgebenMeldung(MeldStr);
        RETURN;
    END;



    ichSelbst^.Kst:=NIL;
    IF SearchKstZuKID(ichSelbst^.KstID, ichSelbst^.Kst) THEN
      NameString:=LiesNameinKst(ichSelbst^.Kst);

      Jahr:=LiesJahrinKst(ichSelbst^.Kst);

      Kontingent:=LiesKontinginKst(ichSelbst^.Kst);
      Aequivalent:=LiesAequivinKst(ichSelbst^.Kst);
      EingegebenAm:=LiesEingAminKst(ichSelbst^.Kst);
      GesperrtAm:=LiesGesperrtAminKst(ichSelbst^.Kst);
      LiquidiertAm:=LiesLiquidAminKst(ichSelbst^.Kst);

      String.Schreibe(Text,"KostenstellenID:  ");
      String.Anhaengen(KstIDString, Text);
      ichSelbst^.KstIDHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, KstIDYPos);

      String.Schreibe(Text,"Name:  ");
      String.Anhaengen(NameString, Text);
      ichSelbst^.NameHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, NameYPos);



    (*  Jahr ausgeben  *)
(*
      DatumString := String.Create();
      String.Schreibe(DatumString,"01.01.2001");
      Datum:=Datum.CreateDatum();
      IF Datum.DatumVonString(DatumString, Datum, MeldString) THEN
        Datum.SetzeJahrInDatum(Datum, Jahr);
      ELSE
        String.Lies(MeldString, MeldStr);
        Strings.Append("Meldung zu Datum:", MeldStr);
        AusgebenMeldung(MeldStr);
      END;
      DatumString:=Datum.DatumAlsString(Datum);
*)

(*
      JahrString := String.Create();
*)
      JahrString:=Datum.JahrAlsString(Jahr);

      String.Schreibe(Text,"Jahr:  ");
      String.Anhaengen(JahrString, Text);
      ichSelbst^.JahrHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, JahrYPos);


      IF Datum.IstDatumEternity(GesperrtAm) THEN
        GesperrtAmString := String.Create();
        String.Schreibe(GesperrtAmString,"nicht gesperrt");
      ELSE
        GesperrtAmString:=Datum.DatumAlsString(GesperrtAm);
      END;

      String.Schreibe(Text,"gesperrt am:  ");
      String.Anhaengen(GesperrtAmString, Text);
      ichSelbst^.GesperrtAmHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GesperrtAmYPos);



      BetragString := String.Create();
      String.Schreibe(Text,"Buchungsbetrag:");
      ichSelbst^.BetragHdle:=StelleZeileDar(Text, BetragString, BetragLaen,
	    					ichSelbst^.WinHdle, XPos, BetragYPos);

      String.Schreibe(Text,"(a-Abschluss, g-Gehalt, s-Sonstiges, w-WG)");
      ichSelbst^.BuchungsArtInfoHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle,
      							 BuchungsArtInfoXPos, BuchungsArtYPos);

      BuchungsArtString := String.Create();
      String.Schreibe(Text,"BuchungsArt:");
      ichSelbst^.BuchungsArtHdle:=StelleZeileDar(Text, BuchungsArtString, BuchungsArtLaen,
	    					ichSelbst^.WinHdle, XPos, BuchungsArtYPos);

      String.Dispose(NameString);
      String.Dispose(JahrString);
      String.Dispose(GesperrtAmString);
      String.Dispose(BuchungsArtString);
      String.Dispose(BetragString);
    ELSE
      MeldString := String.Create();
      String.Schreibe(MeldString,"Die Kst wurden nicht gefunden !? KstID:");
      String.Anhaengen(KstIDString, MeldString);
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
      String.Dispose(MeldString);
    END;



    String.Dispose(KstIDString);
    String.Dispose(Text);
    String.Dispose(Inhalt);
    IF TRACE THEN WriteString("FBuchenKst.InitEinAusgabeFelde End"); WriteLn; END;
  END InitEinAusgabeFelder;




PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FBuchenKst.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;





CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FBuchenKst.
