(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FKondVtrAnz;
Funktion: akuelle Vertragskondition anzeigen

JZ

V 0.6   28.2.01  19:44

*)
(******************************************************************************)


IMPLEMENTATION MODULE FKondVtrAnz;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM InOut IMPORT WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT 	Push, Pop, Top, TProc;
IMPORT Datum;
IMPORT SysDat;
FROM Konden IMPORT 	TKond, CreateVertragsKondition, DisposeKond,
			SetzeGueltVoninKond, LiesGueltVoninKond,
			SetzeGueltBisinKond, LiesGueltBisinKond,
			SetzeBHDinVKond, LiesBHDinVKond,
			SetzeSOGinVKond, LiesSOGinVKond,
			HoleGueltigeVKond,
                	InsertVKond;

(*
FROM PSB IMPORT	VKondGeprueftEinf;
*)



  TYPE 	TFKondVtrAnzDS = RECORD
		           WinHdle : ADDRESS;
		           AnlegenKnopfHdle,
			   LoeschenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   GueltigabHdle,
			   GueltigbisHdle,
			   BeschaeftigungsHDHdle,
			   StdObergrenzeHdle : ADDRESS
  	      		 END;	
        TPFKondVtrAnz = POINTER TO TFKondVtrAnzDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AnlegenKnopfXPos=INT(10);
    LoeschenKnopfXPos=INT(260);
    AbbrechenKnopfXPos=INT(390);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondVtrAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.AktivFAnlegen Begin"); WriteLn; END;
    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrAnz, meineAddr);

    InitEingabeFelder();

    Text := String.Create();
    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    							 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FKondVtrAnz.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FKondVtrAnz.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;





PROCEDURE LoeschenKnopfCallback();
   VAR 
    MeldHandle: ADDRESS;
    ichSelbst: TPFKondVtrAnz;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.LoeschenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrAnz, meineAddr);
    LoeschenEingabeFelder();
    InitEingabeFelder();
    IF TRACE THEN WriteString("FKondVtrAnz.LoeschenKnopfCallback End"); WriteLn; END;
  END LoeschenKnopfCallback;



PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFKondVtrAnz;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"aktuelle Vertragskondition anzeigen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FKondVtrAnz.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrAnz, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);   *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FKondVtrAnz.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.DeaktFAnlegen Begin"); WriteLn; END;
    (* Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FKondVtrAnz.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FKondVtrAnz.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      GueltigabYPos=INT(50);
      GueltigabLaen=INT(10);
      GueltigbisYPos=INT(75);
      GueltigbisLaen=INT(10);
      BeschaeftigungsHDYPos=INT(100);
      BeschaeftigungsHDLaen=INT(2);
      StdObergrenzeYPos=INT(125);
      StdObergrenzeLaen=INT(2);
  VAR
    Text, Inhalt: String.TString;
    ZWDatumString, GueltigabString, GueltigbisString, MeldString, StdObergrenzeString,
    					BeschaeftigungsHDString: String.TString;
    TextStr, ZWDatumStr, GueltigabStr, GueltigbisStr, MeldStr, StdObergrenzeStr,
    						BeschaeftigungsHDStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFKondVtrAnz;
    Format: ConvTypes.ConvResults;
    DatenOkay: BOOLEAN;
    BeschaeftigungsHD: CARDINAL;
    StdObergrenze: CARDINAL;
    ZWDatum: Datum.TDatum;
    VK: TKond;
    Gueltigab, Gueltigbis, Heute: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrAnz, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();
    MeldString := String.Create();
    ZWDatumString := String.Create();


(* ( * *)
    String.Schreibe(ZWDatumString,"25.2.2001");
    IF Datum.DatumVonString(ZWDatumString, ZWDatum, MeldString) THEN
	;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="Dubios: ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    END;
    Heute:=Datum.DuplicateDatum(ZWDatum);
(*
    SysDat.SetzeSystemDatumInSysDat(Heute);
*)
(* * ) *)
    Heute:=SysDat.LiesSystemDatumInSysDat();




    IF HoleGueltigeVKond(Heute, VK) THEN
      Gueltigab:=LiesGueltVoninKond(VK);
      GueltigabString:=Datum.DatumAlsString(Gueltigab);
      Gueltigbis:=LiesGueltBisinKond(VK);
      GueltigbisString:=Datum.DatumAlsString(Gueltigbis);
      BeschaeftigungsHD:=LiesBHDinVKond(VK);
      StdObergrenze:=LiesSOGinVKond(VK);

      WholeStr.CardToStr(BeschaeftigungsHD, BeschaeftigungsHDStr);
      BeschaeftigungsHDString := String.Create();
      String.Schreibe(BeschaeftigungsHDString, BeschaeftigungsHDStr);

      WholeStr.CardToStr(StdObergrenze, StdObergrenzeStr);
      StdObergrenzeString := String.Create();
      String.Schreibe(StdObergrenzeString, StdObergrenzeStr);

      String.Schreibe(Text,"Gltig ab:  ");
      String.Anhaengen(GueltigabString, Text);
      ichSelbst^.GueltigabHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GueltigabYPos);

      String.Schreibe(Text,"Gltig bis:  ");
      String.Anhaengen(GueltigbisString, Text);
      ichSelbst^.GueltigbisHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GueltigbisYPos);

      String.Schreibe(Text,"Beschftigungshchstdauer:  ");
      String.Anhaengen(BeschaeftigungsHDString, Text);
      ichSelbst^.BeschaeftigungsHDHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, BeschaeftigungsHDYPos);

      String.Schreibe(Text,"Stundenobergrenze:  ");
      String.Anhaengen(StdObergrenzeString, Text);
      ichSelbst^.StdObergrenzeHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, StdObergrenzeYPos);


      DisposeKond(VK);
      String.Dispose(GueltigabString);
      String.Dispose(GueltigbisString);
      String.Dispose(BeschaeftigungsHDString);
      String.Dispose(StdObergrenzeString);
    ELSE
      String.Schreibe(MeldString,"aktuelle VK wurden nicht gefunden !?");
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;



    String.Dispose(Text);
    String.Dispose(Inhalt);
    String.Dispose(MeldString);
    String.Dispose(ZWDatumString);
    IF TRACE THEN WriteString("FKondVtrAnz.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrAnz, meineAddr);
    EntferneZeile(ichSelbst^.GueltigabHdle);
    EntferneZeile(ichSelbst^.GueltigbisHdle);
    EntferneZeile(ichSelbst^.BeschaeftigungsHDHdle);
    EntferneZeile(ichSelbst^.BeschaeftigungsHDHdle);
    IF TRACE THEN WriteString("FKondVtrAnz.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFKondVtrAnz;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrAnz.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FKondVtrAnz.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FKondVtrAnz.
