(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FKondVtrEin.mod,v $
# $Author: Sopra $
# $Date: 2001/03/14 07:58:09 $
# $Revision: 1.9 $
# Bemerkungen:

IMPLEMENTATION MODULE FKondVtrEin;
Funktion: Vertragskondition einfuegen

JZ

V 0.6   28.1.01  17:15

*)
(******************************************************************************)


IMPLEMENTATION MODULE FKondVtrEin;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT 	Push, Pop, Top, TProc;
IMPORT Datum;
FROM Konden IMPORT 	TKond, CreateVertragsKondition, DisposeKond,
			SetzeGueltVoninKond, LiesGueltVoninKond,
			SetzeGueltBisinKond, LiesGueltBisinKond,
			SetzeBHDinVKond, LiesBHDinVKond,
			SetzeSOGinVKond, LiesSOGinVKond,
			HoleGueltigeVKond,
                	InsertVKond;
		
	
FROM PSB IMPORT	VKondGeprueftEinf;




  TYPE 	TFKondVtrEinDS = RECORD
		           WinHdle : ADDRESS;
		           AnlegenKnopfHdle,
			   LoeschenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   GueltigabHdle,
			   BeschaeftigungsHDHdle,
			   StdObergrenzeHdle : ADDRESS
  	      		 END;	
        TPFKondVtrEin = POINTER TO TFKondVtrEinDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AnlegenKnopfXPos=INT(50);
    LoeschenKnopfXPos=INT(260);
    AbbrechenKnopfXPos=INT(370);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondVtrEin;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)

    InitEingabeFelder();

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrEin, meineAddr);

    Text := String.Create();
    String.Schreibe(Text,"Vertragskondition anlegen");
    ichSelbst^.AnlegenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AnlegenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AnlegenKnopfCallback));

    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FKondVtrEin.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FKondVtrEin.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE AnlegenKnopfCallback();
  CONST
  VAR
    DatumString, GueltigabString, MeldString, BeschaeftigungsHDString, StdObergrenzeString: String.TString;
    DatumStr, GueltigabStr, TextStr, MeldStr, BeschaeftigungsHDStr, StdObergrenzeStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondVtrEin;
    DatenOkay: BOOLEAN;
    StdObergrenze,
    BeschaeftigungsHD: CARDINAL;
    VK: TKond;
    Gueltigab: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.AnlegenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrEin, meineAddr);

    GueltigabString:=String.Create();
    BeschaeftigungsHDString:=String.Create();
    StdObergrenzeString:=String.Create();
    MeldString:=String.Create();

    LiesZeile(ichSelbst^.GueltigabHdle, GueltigabString);
    String.Lies(GueltigabString, GueltigabStr);

    LiesZeile(ichSelbst^.BeschaeftigungsHDHdle, BeschaeftigungsHDString);
    String.Lies(BeschaeftigungsHDString, BeschaeftigungsHDStr);

    LiesZeile(ichSelbst^.StdObergrenzeHdle, StdObergrenzeString);
    String.Lies(StdObergrenzeString, StdObergrenzeStr);


    IF TRACEDATEN THEN
      WriteString("VK einfuegen: Gueltig ab:"); WriteString(GueltigabStr); WriteString(":");
      WriteString("BeschaeftigungsHD:"); WriteString(BeschaeftigungsHDStr); WriteString(":");
      WriteString("StdObergrenze:"); WriteString(StdObergrenzeStr); WriteString(":");
      WriteLn;
    END;



    (*      D a t e n     P r u e f e n       *)
    DatenOkay:=TRUE;

    VK:=CreateVertragsKondition();

    (* Gueltigab Prfen und konvertieren *)
     Gueltigab:=Datum.CreateDatum();
    IF Datum.DatumVonString(GueltigabString, Gueltigab, MeldString) THEN
      IF TRACEDATEN THEN
        MeldString:=Datum.DatumAlsString(Gueltigab);
        String.Lies(MeldString, MeldStr);
        WriteString("Gueltig ab:"); WriteString(MeldStr); WriteString(":");
      END;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="Gltig ab: ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    END;



    (* StdObergrenze prfen und konvertieren *)
    IF StrToCardinal(StdObergrenzeStr,StdObergrenze) THEN
      IF TRACEDATEN THEN
        WriteString("StdObergrenze:"); WriteCard(StdObergrenze,5); WriteString(":");
      END;
      IF SetzeSOGinVKond(VK,StdObergrenze) THEN
        ;
      ELSE
        DatenOkay:=FALSE;
        MeldStr:="StdObergrenze kann nicht gesetz werden !?";
        AusgebenMeldung(MeldStr);
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Die StdObergrenze ist ungueltig (nicht positiv ganzzahlig)");
    END;


    (* BeschaeftigungsHD prfen und konvertieren *)
    IF StrToCardinal(BeschaeftigungsHDStr,BeschaeftigungsHD) THEN
      IF TRACEDATEN THEN
        WriteString("BeschaeftigungsHD:"); WriteCard(BeschaeftigungsHD,5); WriteString(":");
      END;
      IF SetzeBHDinVKond(VK,BeschaeftigungsHD) THEN
        ;
      ELSE
        DatenOkay:=FALSE;
        MeldStr:="BeschaeftigungsHD kann nicht gesetz werden !?";
        AusgebenMeldung(MeldStr);
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Die BeschaeftigungsHD ist ungueltig (nicht positiv ganzzahlig)");
    END;
    IF TRACEDATEN THEN
      WriteLn;
    END;



    (* Sind die eingegebenen Vertragskonditionsdaten okay, dann wird die WK angelegt *)
    IF DatenOkay THEN
       SetzeGueltVoninKond(VK,Gueltigab);

       IF VKondGeprueftEinf(VK,MeldString) THEN
         AusgebenMeldung("Vertragskondition wurde angelegt");
(*
       IF InsertVKond(VK,MeldString) THEN
         AusgebenMeldung("Vertragskondition wurde angelegt");
*)
       ELSE
         String.Lies(MeldString, MeldStr);
         TextStr:="Meldung zu VK anlegen: ";
         Strings.Append(MeldStr, TextStr);
         AusgebenMeldung(TextStr);                                              
       END;
    END;


    DisposeKond(VK);
    IF Gueltigab <> NIL THEN
      Datum.DisposeDatum(Gueltigab);
    END;
    String.Dispose(GueltigabString);
    String.Dispose(BeschaeftigungsHDString);
    String.Dispose(StdObergrenzeString);
    String.Dispose(MeldString);
    IF TRACE THEN WriteString("FKondVtrEin.AnlegenKnopfCallback End"); WriteLn; END;
  END AnlegenKnopfCallback;





PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFKondVtrEin;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Vertragskondition anlegen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FKondVtrEin.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrEin;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrEin, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AnlegenKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);   *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FKondVtrEin.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrEin;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.DeaktFAnlegen Begin"); WriteLn; END;
    (* Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrEin, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FKondVtrEin.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrEin;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrEin, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FKondVtrEin.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      GueltigabYPos=INT(55);
      GueltigabLaen=INT(10);
      BeschaeftigungsHDYPos=INT(85);
      BeschaeftigungsHDLaen=INT(4);
      StdObergrenzeYPos=INT(115);
      StdObergrenzeLaen=INT(4);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrEin;
      Text, Inhalt: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrEin, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();

    String.Schreibe(Text,"Gltig ab (TT.MM.JJJJ):");
    ichSelbst^.GueltigabHdle:=StelleZeileDar(Text, Inhalt, GueltigabLaen,
				ichSelbst^.WinHdle, XPos, GueltigabYPos);
    String.Schreibe(Text,"Beschftigungshchstdauer (Monate):");
    ichSelbst^.BeschaeftigungsHDHdle:=StelleZeileDar(Text, Inhalt, BeschaeftigungsHDLaen,
				ichSelbst^.WinHdle, XPos, BeschaeftigungsHDYPos);
    String.Schreibe(Text,"Stundenobergrenze (Stunden/Woche):");
    ichSelbst^.StdObergrenzeHdle:=StelleZeileDar(Text, Inhalt, StdObergrenzeLaen,
				ichSelbst^.WinHdle, XPos, StdObergrenzeYPos);

    String.Dispose(Text);
    String.Dispose(Inhalt);
    IF TRACE THEN WriteString("FKondVtrEin.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondVtrEin;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondVtrEin, meineAddr);
    EntferneZeile(ichSelbst^.GueltigabHdle);
    EntferneZeile(ichSelbst^.BeschaeftigungsHDHdle);
    EntferneZeile(ichSelbst^.StdObergrenzeHdle);
    IF TRACE THEN WriteString("FKondVtrEin.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFKondVtrEin;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondVtrEin.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FKondVtrEin.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FKondVtrEin.
