(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FListBox;
Funktion: Anzeigen einer Stringliste in einer Listbox

JZ

V 0.0   4.3.01  12:14

*)
(******************************************************************************)

IMPLEMENTATION MODULE FListBox;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT	Push, Pop, Top, TProc;
(*
FROM Info IMPORT	ZeigeAlleKsten, ZeigeAlleVtre, ZeigeAlleHK,
			ZeigeAlleBuen, ZeigeAlleWKond, ZeigeAlleVKond, ZeigeAlleTKond;
*)
FROM VDruck IMPORT	Print, PrintStringliste, initDrucker;

			

  TYPE 	TFListBoxDS = RECORD
		           WinHdle: ADDRESS;
		           ListenHdle: ADDRESS;
			   AbbrechenKnopfHdle: ADDRESS;  		
			   DruckenKnopfHdle: ADDRESS;  		
			   LBUeberschrift: String.TString;  		
			   FHoehe, FBreite: INTEGER;
			   StringListe: Stringliste.TStringliste;  		
  	      		 END;	
        TPFListBox = POINTER TO TFListBoxDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(265);
    AbbrechenKnopfXPos=INT(500);
    DruckenKnopfXPos=INT(130);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFListBox;
  BEGIN
    IF TRACE THEN WriteString("FListBox.AktivFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFListBox, meineAddr);

    (* Erzeuge den Fensterinhalt *)
    StelledarListe();

    Text := String.Create();
    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle,
    				AbbrechenKnopfXPos, KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Schreibe(Text,"Drucken");
    ichSelbst^.DruckenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle,
    				DruckenKnopfXPos, KnopfYPos, CAST(PROC,DruckenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FListBox.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;




PROCEDURE StelledarListe();
  CONST
    KnopfYPos=INT(180);
    AbbrechenKnopfXPos=INT(410);
  VAR
    Text     : String.TString;
    Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFListBox;
  BEGIN
    IF TRACE THEN WriteString("FListBox.StelledarListe Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFListBox, meineAddr);


    Listenelement := String.Create();
    String.Schreibe (Listenelement,
    	"                                                                                ");
    Stringliste.Append(ichSelbst^.StringListe,Listenelement);
    String.Schreibe (Listenelement,
    	"12345678901234567890123456789012345678901234567890123456789012345678901234567890");
    Stringliste.Append(ichSelbst^.StringListe,Listenelement);


    ichSelbst^.ListenHdle := StelleListeDar(ichSelbst^.StringListe,ichSelbst^.LBUeberschrift,
    						10, ichSelbst^.WinHdle, 10, 20, CAST(PROC,ListeCallback));


(* nich noetig, da Originalliste
    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(KstStringListe)) DO
      Stringliste.GoStart(KstStringListe);
      Stringliste.Delete(KstStringListe);
    END;
    Stringliste.Dispose(KstStringListe);
*)


    IF TRACE THEN WriteString("FListBox.StelledarListe End"); WriteLn; END;
  END StelledarListe;



PROCEDURE AbbrechenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FListBox.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FListBox.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE DruckenKnopfCallback();
  VAR
    ZWDatumString, GueltigabString, GueltigbisString, MeldString, BemmonatString,
     						StichtagString: String.TString;
    ZWDatumStr, TextStr, GueltigabStr, GueltigbisStr, MeldStr, BemmonatStr, StichtagStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFListBox;
  BEGIN
    IF TRACE THEN WriteString("FListBox.DruckenKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFListBox, meineAddr);

    MeldString := String.Create();

    IF PrintStringliste(ichSelbst^.StringListe, MeldString) THEN
      TextStr:="Es wurde auf die Datei 'erg.txt' erfolgreich ausgegeben!";
      AusgebenMeldung(TextStr);
    ELSE
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;

    String.Dispose(MeldString);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(ichSelbst^.StringListe)) DO
      Stringliste.GoStart(ichSelbst^.StringListe);
      Stringliste.Delete(ichSelbst^.StringListe);
    END;
    Stringliste.Dispose(ichSelbst^.StringListe);

    DisposeFAnlegen();
    Top(reaktProc, meineAddr);
    reaktProc();

    IF TRACE THEN WriteString("FListBox.DruckenKnopfCallback End"); WriteLn; END;
  END DruckenKnopfCallback;



PROCEDURE ListeCallback(Nr:INTEGER);
  CONST
  VAR
    MeldString, KstIDString: String.TString;
    MeldStr, KstIDStr: ARRAY[1..200] OF CHAR;
    ElementString: String.TString;
    ElementStr: ARRAY [1..100] OF CHAR;
    TextStr: ARRAY [1..100] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFListBox;
  BEGIN
    IF TRACE THEN WriteString("FListBox.ListeCallback Begin"); WriteLn; END;

    IF TRACE THEN WriteString("FListBox.ListeCallback End"); WriteLn; END;
  END ListeCallback;




PROCEDURE CreateFAnlegen(	inFUeberschrift:	String.TString;
				inLBUeberschrift:	String.TString;
  				inStringListe: 		Stringliste.TStringliste );
(*				inFHoehe, inFBreite:	INTEGER;   *)
  CONST
      FXPos=INT(80);
      FYPos=INT(50);
      FHoehe=INT(300);
      FBreite=INT(700);
  VAR Text: String.TString;
      ichSelbst: TPFListBox;
      meineAddr: ADDRESS;
      Listenelement: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FListBox.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW(ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

(*
    IF inFHoehe < FMinHoehe THEN
      ichSelbst^.FHoehe:=FMinHoehe;
    ELSE
      ichSelbst^.FHoehe:=inFHoehe;
    END;
    IF inFBreite < FMinBreite THEN
      ichSelbst^.FBreite:=FMinBreite;
    ELSE
      ichSelbst^.FBreite:=inFBreite;
    END;
*)

    ichSelbst^.LBUeberschrift:=inLBUeberschrift;
    ichSelbst^.StringListe:=Stringliste.Create();

    Stringliste.GoStart(inStringListe);
    WHILE NOT Stringliste.OffEnd(inStringListe) DO
      Listenelement:=Stringliste.Current(inStringListe);
      Stringliste.Append(ichSelbst^.StringListe,Listenelement);
      Stringliste.StepNext(inStringListe);
    END; (* WHILE*)

    Text := String.Create();
    String.Schreibe( Text,"Selektion der zu bearbeitenden Kostenstelle");
    ichSelbst^.WinHdle:=NeuesFenster(inFUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(Text);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FListBox.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFListBox;
  BEGIN
    IF TRACE THEN WriteString("FListBox.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFListBox, meineAddr);

(*  EntferneListe(ichSelbst^.ListenHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen  *)
    DISPOSE(ichSelbst);
    Pop();
    IF TRACE THEN WriteString("FListBox.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFListBox;
  BEGIN
    IF TRACE THEN WriteString("FListBox.ReaktFAnlegen Begin"); WriteLn; END;
    IF TRACE THEN WriteString("FListBox.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;




PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FListBox.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FListBox.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FListBox.
