(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FSelBeaKst.mod,v $
# $Author: Sopra $
# $Date: 2001/03/11 16:49:50 $
# $Revision: 1.3 $
# Bemerkungen:

IMPLEMENTATION MODULE FSelBeaKst;
Funktion: Selektion einer Kostenstelle zum Bearbeiten

JZ

V 0.6   26.2.01  21:14


*)
(******************************************************************************)

IMPLEMENTATION MODULE FSelBeaKst;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT  Push, Pop, Top, TProc;
IMPORT  FBearbKst;
FROM Ksten IMPORT 	TKstID, TKst, CreateKst,
			SetzeKIDinKst, LiesKIDinKst,
 			SetzeEingAminKst, LiesEingAminKst,
 			SetzeGesperrtAminKst, LiesGesperrtAminKst,IstGesperrtAminKst,
 			SetzeLiquidAminKst, LiesLiquidAminKst, IstLiquidiertAminKst,
 			SetzeNameinKst, LiesNameinKst,
 			SetzeJahrinKst,LiesJahrinKst,
 			SetzeKontinginKst, LiesKontinginKst,
 			SetzeAequivinKst, LiesAequivinKst,
			ExistKst,
			KstIDAlsString, StringInKstID, PruefeKstID,
			GibKstenAlsStringlisteInKsten,
			SearchKstZuKID;


  TYPE 	TFSelektionBearbKstDS = RECORD
		           WinHdle : ADDRESS;
		           ListenHdle : ADDRESS;
			   AbbrechenKnopfHdle:ADDRESS;  		
  	      		 END;	
        TPFSelektionBearbKst = POINTER TO TFSelektionBearbKstDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSelektionBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.AktivFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);

    (* Erzeuge den Fensterinhalt *)
    StelledarListe();

    Text := String.Create();
    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle,
    				AbbrechenKnopfXPos, KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FSelektionBearbKst.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;




PROCEDURE StelledarListe();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    Text     : String.TString;
    Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSelektionBearbKst;
    KstStringListe: Stringliste.TStringliste;
    I:INTEGER;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.StelledarListe Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);


(*
    KstStringListe := Stringliste.Create();
    Listenelement := String.Create();

    String.Schreibe (Listenelement,"01585 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"12345 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"11111 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"22222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"32222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"42222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"52222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"62222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"72222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"82222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);

    FOR I:=1 TO 30 DO
      String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
      Stringliste.Append(KstStringListe,Listenelement);
    END;

    String.Dispose(Listenelement);
*)

    KstStringListe:=GibKstenAlsStringlisteInKsten();

    Text := String.Create();
    String.Schreibe (Text, "KstID     N  a  m  e          Jahr  GesperrtAm");
    ichSelbst^.ListenHdle := StelleListeDar(KstStringListe,Text,9,ichSelbst^.WinHdle,
    							50,40,CAST(PROC,ListeCallback));
    String.Dispose(Text);


    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(KstStringListe)) DO
      Stringliste.GoStart(KstStringListe);
      Stringliste.Delete(KstStringListe);
    END;
    Stringliste.Dispose(KstStringListe);

    IF TRACE THEN WriteString("FSelektionBearbKst.StelledarListe End"); WriteLn; END;
  END StelledarListe;



PROCEDURE AbbrechenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FSelektionBearbKst.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE ListeCallback(Nr:INTEGER);
  CONST
  VAR
    MeldString, KstIDString: String.TString;
    MeldStr, KstIDStr: ARRAY[1..200] OF CHAR;
    ElementString: String.TString;
    ElementStr: ARRAY [1..100] OF CHAR;
    TextStr: ARRAY [1..100] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSelektionBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.ListeCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);

    ElementString := String.Create();
    KstIDString := String.Create();

    LiesListenelement(ichSelbst^.ListenHdle, Nr, ElementString);
    String.Lies(ElementString, ElementStr);
    String.Auslesen(ElementString,0,5,KstIDString);
    String.Lies(KstIDString, MeldStr);
(*
    WriteString("KstID:"); WriteString(MeldStr); WriteString(":"); WriteLn;
*)

    (* aktuelles Fenster entfernen *)
    DisposeFAnlegen();
    (* Neues Fenster erzeugen und KstID der ausgewaehlten Kst uebergeben *)
    FBearbKst.CreateFAnlegen(KstIDString);

    (* bereinigen *)
    String.Dispose(ElementString);
    String.Dispose(KstIDString);
    IF TRACE THEN WriteString("FSelektionBearbKst.ListeCallback End"); WriteLn; END;
  END ListeCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR Text: String.TString;
      ichSelbst: TPFSelektionBearbKst;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW(ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    Text := String.Create();
    String.Schreibe( Text,"Selektion der zu bearbeitenden Kostenstelle");
    ichSelbst^.WinHdle:=NeuesFenster(Text,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(Text);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FSelektionBearbKst.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBearbKst, meineAddr);

(*  EntferneListe(ichSelbst^.ListenHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen  *)
    DISPOSE(ichSelbst);
    Pop();
    IF TRACE THEN WriteString("FSelektionBearbKst.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBearbKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.ReaktFAnlegen Begin"); WriteLn; END;
    IF TRACE THEN WriteString("FSelektionBearbKst.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;




PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBearbKst.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FSelektionBearbKst.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FSelBeaKst.
