(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FSelResVer.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 08:04:04 $
# $Revision: 1.2 $
# Bemerkungen:

IMPLEMENTATION MODULE FSelResVer;
Funktion: Selektion einer Kostenstelle zum Bearbeiten

JZ

V 0.0   8.3.01  18:14


*)
(******************************************************************************)

IMPLEMENTATION MODULE FSelResVer;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;
IMPORT Datum;

(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT  Push, Pop, Top, TProc;
IMPORT SysDat;
IMPORT Adm;



  TYPE 	TFSelResVerDS = RECORD
		           WinHdle : ADDRESS;
		           ListenHdle : ADDRESS;
			   AbbrechenKnopfHdle:ADDRESS;  		
  	      		 END;	
        TPFSelResVer = POINTER TO TFSelResVerDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSelResVer;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.AktivFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelResVer, meineAddr);

    (* Erzeuge den Fensterinhalt *)
    StelledarListe();

    Text := String.Create();
    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle,
    				AbbrechenKnopfXPos, KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FSelResVer.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;




PROCEDURE StelledarListe();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    DatumString, GueltigabString, MeldString, BemmonatString, StichtagString: String.TString;
    DatumStr, GueltigabStr, TextStr, MeldStr, BemmonatStr, StichtagStr: ARRAY[1..200] OF CHAR;
    Text     : String.TString;
    VersionString, VersionDatumString, Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSelResVer;
    VersionStringListe: Stringliste.TStringliste;
    VersionDatum: Datum.TDatum;
    Version: SysDat.TVersion;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.StelledarListe Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelResVer, meineAddr);

    VersionStringListe := Stringliste.Create();
    Listenelement := String.Create();
    MeldString := String.Create();
    Text := String.Create();

    IF NOT (Adm.ReadIniDatei(MeldString)) THEN
      String.Lies(MeldString, MeldStr);
      TextStr:=" ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
      RETURN;
    END;

   String.Schreibe (Text, "     -  ");

   IF SysDat.FirstBackupInSysDat(Version, VersionDatum) THEN
     VersionString:=SysDat.VersionAlsString(Version);
     VersionDatumString:=Datum.DatumAlsString(VersionDatum);
     Listenelement:=String.Duplicate(VersionString);
     String.Anhaengen(Text,Listenelement);
     String.Anhaengen(VersionDatumString,Listenelement);
     Stringliste.Append(VersionStringListe,Listenelement);

     WHILE SysDat.NextBackupInSysDat(Version, VersionDatum) DO
       VersionString:=SysDat.VersionAlsString(Version);
       VersionDatumString:=Datum.DatumAlsString(VersionDatum);
       Listenelement:=String.Duplicate(VersionString);
       String.Anhaengen(Text,Listenelement);
       String.Anhaengen(VersionDatumString,Listenelement);
       Stringliste.Append(VersionStringListe,Listenelement);
     END;
   END;


    String.Schreibe (Text, "Version   Datum");
    ichSelbst^.ListenHdle := StelleListeDar(VersionStringListe,Text,9,ichSelbst^.WinHdle,
    							50,40,CAST(PROC,ListeCallback));
    String.Dispose(Text);


    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(VersionStringListe)) DO
      Stringliste.GoStart(VersionStringListe);
      Stringliste.Delete(VersionStringListe);
    END;
    Stringliste.Dispose(VersionStringListe);

    IF TRACE THEN WriteString("FSelResVer.StelledarListe End"); WriteLn; END;
  END StelledarListe;



PROCEDURE AbbrechenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FSelResVer.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE ListeCallback(Nr:INTEGER);
  CONST
  VAR
    MeldString, VersionString: String.TString;
    MeldStr, VersionStr: ARRAY[1..200] OF CHAR;
    ElementString: String.TString;
    ElementStr: ARRAY [1..100] OF CHAR;
    TextStr: ARRAY [1..100] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSelResVer;
    Version: SysDat.TVersion;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.ListeCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelResVer, meineAddr);

    ElementString := String.Create();
    VersionString := String.Create();

    LiesListenelement(ichSelbst^.ListenHdle, Nr, ElementString);
    String.Lies(ElementString, ElementStr);
    (* VersionString muss rein numerisch ohne Blanks sein !! *)
    String.Auslesen(ElementString,0,1,VersionString);
    String.Lies(VersionString, MeldStr);

    IF TRACEDATEN THEN
      WriteString("Version:"); WriteString(MeldStr); WriteString(":"); WriteLn;
    END;

    IF NOT (SysDat.VersionVonString (VersionString,Version,MeldString)) THEN
      String.Lies(MeldString, MeldStr);
      TextStr:=" VersionVonString ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    ELSE
      IF Adm.RestoreSystemInAdm(Version,MeldString) THEN
        TextStr:="Restore war erfolgreich";
        AusgebenMeldung(TextStr);
      ELSE
        String.Lies(MeldString, MeldStr);
        TextStr:=" Restore: ";
        Strings.Append(MeldStr, TextStr);
        AusgebenMeldung(TextStr);
      END;
    END;

    (* aktuelles Fenster entfernen *)
    DisposeFAnlegen();
    (* Neues Fenster erzeugen und KstID der ausgewaehlten Kst uebergeben *)

    (* bereinigen *)
    String.Dispose(ElementString);
    String.Dispose(VersionString);
    IF TRACE THEN WriteString("FSelResVer.ListeCallback End"); WriteLn; END;
  END ListeCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR Text: String.TString;
      ichSelbst: TPFSelResVer;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW(ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    Text := String.Create();
    String.Schreibe( Text,"Selektion der zu bearbeitenden Kostenstelle");
    ichSelbst^.WinHdle:=NeuesFenster(Text,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(Text);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FSelResVer.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelResVer;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelResVer, meineAddr);

(*  EntferneListe(ichSelbst^.ListenHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen  *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FSelResVer.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelResVer;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.ReaktFAnlegen Begin"); WriteLn; END;
    IF TRACE THEN WriteString("FSelResVer.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;




PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSelResVer.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FSelResVer.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FSelResVer.
