(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FSysDatEin;
Funktion: SysDatum aendern

JZ

V 0.0   7.3.01  17:15

*)
(******************************************************************************)


IMPLEMENTATION MODULE FSysDatEin;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT 	Push, Pop, Top, TProc;
IMPORT Datum;
IMPORT SysDat;


  TYPE 	TFSysDatEinDS = RECORD
		           WinHdle : ADDRESS;
		           AendernKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		
			   SysDatHdle : ADDRESS
  	      		 END;	
        TPFSysDatEin = POINTER TO TFSysDatEinDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AendernKnopfXPos=INT(50);
    AbbrechenKnopfXPos=INT(370);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSysDatEin;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)

    InitEingabeFelder();

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysDatEin, meineAddr);

    Text := String.Create();
    String.Schreibe(Text,"SysDatum aendern");
    ichSelbst^.AendernKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AendernKnopfXPos,
    						 KnopfYPos, CAST(PROC,AendernKnopfCallback));

    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FSysDatEin.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FSysDatEin.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE AendernKnopfCallback();
  CONST
  VAR
    DatumString, GueltigabString, MeldString, BeschaeftigungsHDString, StdObergrenzeString: String.TString;
    DatumStr, GueltigabStr, TextStr, MeldStr, BeschaeftigungsHDStr, StdObergrenzeStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSysDatEin;
    DatenOkay: BOOLEAN;
    SysDatum: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.AnlegenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysDatEin, meineAddr);

    DatumString:=String.Create();
    MeldString:=String.Create();

    LiesZeile(ichSelbst^.SysDatHdle, DatumString);
    String.Lies(DatumString, DatumStr);

    IF TRACEDATEN THEN
      WriteString("SysDat aendern: SysDat:"); WriteString(DatumStr); WriteString(":");
      WriteLn;
    END;

    (*      D a t e n     P r u e f e n       *)
    DatenOkay:=TRUE;

    (* Gueltigab Prfen und konvertieren *)
    SysDatum:=Datum.CreateDatum();
    IF Datum.DatumVonString(DatumString, SysDatum, MeldString) THEN
      IF TRACEDATEN THEN
        MeldString:=Datum.DatumAlsString(SysDatum);
        String.Lies(MeldString, MeldStr);
        WriteString("  SysDat:"); WriteString(MeldStr); WriteString(":"); WriteLn;
      END;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="SysDatum: ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    END;


    IF DatenOkay THEN
      SysDat.SetzeSystemDatumInSysDat(SysDatum);
      TextStr:="SysDatum wurde geaendert";
      AusgebenMeldung(TextStr);
      DisposeFAnlegen();
    END;

    IF SysDatum <> NIL THEN
      Datum.DisposeDatum(SysDatum);
    END;
    String.Dispose(DatumString);
    String.Dispose(MeldString);

    IF TRACE THEN WriteString("FSysDatEin.AnlegenKnopfCallback End"); WriteLn; END;
  END AendernKnopfCallback;





PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFSysDatEin;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"System-Datum aendern");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FSysDatEin.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysDatEin;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysDatEin, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AendernKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);   *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FSysDatEin.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysDatEin;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.DeaktFAnlegen Begin"); WriteLn; END;
    (* Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysDatEin, meineAddr);
    SetzeKnopf(ichSelbst^.AendernKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FSysDatEin.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysDatEin;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysDatEin, meineAddr);
    SetzeKnopf(ichSelbst^.AendernKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FSysDatEin.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      SysDatYPos=INT(55);
      SysDatLaen=INT(10);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysDatEin;
      DatumString, Text, Inhalt: String.TString;
      SysDatum: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysDatEin, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();

    SysDatum:=SysDat.LiesSystemDatumInSysDat();
    DatumString:=Datum.DatumAlsString(SysDatum);

    String.Schreibe(Text,"SysDatum:");
    ichSelbst^.SysDatHdle:=StelleZeileDar(Text, DatumString, SysDatLaen, ichSelbst^.WinHdle,
    						XPos, SysDatYPos);

    String.Dispose(DatumString);
    String.Dispose(Text);
    String.Dispose(Inhalt);
    IF TRACE THEN WriteString("FSysDatEin.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysDatEin;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysDatEin, meineAddr);
    EntferneZeile(ichSelbst^.SysDatHdle);
    IF TRACE THEN WriteString("FSysDatEin.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFSysDatEin;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSysDatEin.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FSysDatEin.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FSysDatEin.
