(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE SysReaktFStapel

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE SysReaktFStapel;

FROM SYSTEM IMPORT ADDRESS;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;

  TYPE TPtr = POINTER TO TStapel;
       TStapel = RECORD
		   Prozedure : TProc;
		   FensterTypAddresse: ADDRESS;
                   Next: TPtr;
		 END;
  VAR top: TPtr;

PROCEDURE Push(proc: TProc; FensterTypAddr: ADDRESS);
(* Legt eine Prozedure mit leerer Parameterliste (diese muss zuvor mit dem CAST-Befehl an den Typen TProc angepasst werden)
   sowie die Addresse eines FensterADT's (muss ebenfalls zuvor mit CAST an den Datentypen ADDRESS angepasst werden) auf den Stapel *)
  VAR neu: TPtr;
  BEGIN
    NEW (neu);
    neu^.Prozedure := proc;
    neu^.FensterTypAddresse := FensterTypAddr;
    neu^.Next := top;
    top:= neu;
  END Push;

PROCEDURE Pop();
(* Lsche das oberste Element des Stapels *)
  VAR del: TPtr;
  BEGIN
    del := top;
    top := top^.Next;
    DISPOSE (del);
  END Pop;

PROCEDURE Top(VAR inoutProc: TProc; VAR inoutFensterTypAddr: ADDRESS);
(* Lies die Werte des obersten Elements des Stapels aus ohne dieses Element vom Stapel zu lschen *)
  VAR del: TPtr;
  BEGIN
    inoutProc := top^.Prozedure;
    inoutFensterTypAddr := top^.FensterTypAddresse;
  END Top;

BEGIN
    top := NIL;
END SysReaktFStapel.


