(*   Fernuni  Hagen ,  SOPRA WS20001/01     Christian Sonnweber *)

IMPLEMENTATION MODULE FAendern2VtrHKB;

FROM  SYSTEM    IMPORT   CAST, ADR, ADDRESS;
FROM  X_Grafik  IMPORT   StelleListeDar,EntferneListe;
FROM  X_Grafik  IMPORT   LiesListenelement, AendereListenelement;
FROM  X_Grafik  IMPORT   StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM  X_Grafik  IMPORT   StelleTextDar, EntferneText;
FROM  X_Grafik  IMPORT   StelleMeldungDar, EntferneMeldung;
FROM  X_Grafik  IMPORT   InitialisiereGrafik, StarteGrafik;
FROM  X_Grafik  IMPORT   NeuesFenster, EntferneFenster;
FROM  X_Grafik  IMPORT   MeldungAnzeigen,JaNeinAbfrage;
FROM  X_Grafik  IMPORT   StringEingabeFenster, StringEingabeAuslesen;
FROM  X_Grafik  IMPORT   StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM  X_Grafik  IMPORT   StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM  X_Grafik  IMPORT   LiesMenueEintrag, EntferneMenue;
FROM  args      IMPORT   GetArgs, ArgTable;
FROM  InOut     IMPORT   WriteString,WriteLn,WriteInt;

IMPORT   Strings;
IMPORT   String;
IMPORT   Stringliste;
IMPORT   FLadenSysVw;
IMPORT   Vtre;
IMPORT   Datum;
IMPORT   SysDat;
IMPORT   WholeStr;
IMPORT   DialogLib;
IMPORT   HKB;



TYPE TVater = PROCEDURE(  );

     TCharString = ARRAY[0..255] OF CHAR;



VAR
  FensterHandle		: ADDRESS;
  VaterFenster		: ADDRESS;
  Vater			: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  VtrIdMeldTitel	: ADDRESS;
  VtrIdMeld		: ADDRESS;
  PersIdMeldTitel       : ADDRESS;
  PersIdMeld		: ADDRESS;
  KstIdMeldTitel	: ADDRESS;
  KstIdMeld		: ADDRESS;
  WeiterKnopfHandle	: ADDRESS;
  AendernKnopfHandle	: ADDRESS;
  StdZahlTitel		: ADDRESS;
  StdZahlAnzeige	: ADDRESS;
  TaetigkeitTitel	: ADDRESS;
  TaetigkeitAnzeige     : ADDRESS;
  BegrTitel		: ADDRESS;
  BegrAnzeige           : ADDRESS;
  GueltigBisZeile	: ADDRESS;
  GueltigVonTitel       : ADDRESS;
  GueltigVonAnzeige	: ADDRESS;
  GueltigBisAnzeige     : ADDRESS;
  SystemDatTitel	: ADDRESS;
  HkeListeHdle		: ADDRESS;
  Hinweis1 		: ADDRESS;
  VtrListHdle           : ADDRESS;
  VaterActProcHdle	: ADDRESS;
  StornoKnopfHdle       : ADDRESS;
  SystemDatAnzeige	: ADDRESS;
  StorniertAmMeld       : ADDRESS;
  StorniertAmTitel      : ADDRESS;
  TestMeldung1          : ADDRESS;
  TestMeldung2          : ADDRESS;
  VtrStrList		: Stringliste.TStringliste;
  globalVtrId_str  	: String.TString;
  globalPersId_str	: String.TString;
  globalKstId_str 	: String.TString;
  Vertrag		: Vtre.TVtr;
  Vertrag_Kopie         : Vtre.TVtr;


(* ----------------------------------------------------------------------------------------*)

PROCEDURE StC( inStr : String.TString ) : TCharString;
(* Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies( inStr,outcharfeld );
 RETURN outcharfeld;
END StC;

(* ----------------------------------------------------------------------------------------*)

PROCEDURE InitMaske(  );
(* Erzeugt die initiale Ein-Ausgabemaske *)
VAR Titel       : String.TString;

BEGIN
  Titel := String.Create(  );
  String.Schreibe( Titel,"Abbrechen" );
  EndeKnopfHandle := StelleKnopfDar( Titel,FensterHandle,330,450,
                                    CAST( PROC,EndeKnopfCallback ) );

  InitialDialog(  );

END InitMaske;

(* ----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback(  );
VAR Abfragetext : String.TString;
BEGIN
  Dispose(  );
END EndeKnopfCallback;


(* ----------------------------------------------------------------------------------------*)

PROCEDURE StornoKnopfCallback(  );
VAR ok     : BOOLEAN;
    errmsg : String.TString;
    text   : String.TString;
BEGIN
  IF NOT  Vtre.IstStornoInVtr ( Vertrag ) THEN
  	ok := HKB.StornierenVtr ( Vertrag,errmsg );
  	IF NOT ok THEN
  	 text := String.Create(  );
  	 String.Schreibe( text,"Stornieren nicht mglich" );
  	 TestMeldung2 := StelleMeldungDar( errmsg,TRUE,FensterHandle,380,150 );
  	 String.Dispose( text );
  	ELSE
  	 text := String.Create(  );
  	 String.Schreibe( text,"Storno erfolgreich ausgefhrt" );
  	 MeldungAnzeigen(text);
  	 String.Dispose( text );
         Dispose();
  	END;
  ELSE
    text :=  String.Create(  );
    String.Schreibe( text,"Storno fehlgeschlagen: Vertrag ist bereits storniert!" );
    TestMeldung2 := StelleMeldungDar( text,TRUE,FensterHandle,300,150 );
    String.Dispose( text );
  END;	

END StornoKnopfCallback;

(* ----------------------------------------------------------------------------------------*)

PROCEDURE InitialDialog(  );

                    (*  ------------lokale Prozedur von InitialDialog(  ) ------------- *)

PROCEDURE AusgabeFormular(  );

VAR Abfragetext : String.TString;
    Titel	: String.TString;
    Text        : String.TString;
    HilfString  : String.TString;
    HeuteString : String.TString;
    Heute   		: Datum.TDatum;
    GueVonDatum      : Datum.TDatum;
    GueBisDatum : Datum.TDatum;

    Zeichenkette: ARRAY[0..255] OF CHAR;
    StdZahl     : CARDINAL;


BEGIN
  HilfString := String.Create(  );
  Titel      := String.Create(  );


  String.Schreibe( Titel,"VtrID:" );
  VtrIdMeldTitel := StelleMeldungDar( Titel,TRUE,FensterHandle,280,60 );
  VtrIdMeld  :=  StelleMeldungDar( globalVtrId_str,FALSE,FensterHandle,330,60 );
  String.Dispose( globalVtrId_str );

  String.Schreibe( Titel,"PersID:" );
  PersIdMeldTitel := StelleMeldungDar( Titel,FALSE,FensterHandle,60,90 );
  PersIdMeld      := StelleMeldungDar( globalPersId_str,FALSE,FensterHandle,155,90 );
  String.Dispose( globalPersId_str );

  String.Schreibe( Titel,"KstID:" );
  KstIdMeldTitel := StelleMeldungDar( Titel,FALSE,FensterHandle,60,120 );
  KstIdMeld      := StelleMeldungDar( globalKstId_str,FALSE,FensterHandle,155,120 );
  String.Dispose( globalKstId_str );

  (*  Vertrag.Stundenzahl ausgeben *)
  String.Schreibe( Titel,"Anz.Std.: " );
  StdZahlTitel   := StelleMeldungDar( Titel,FALSE,FensterHandle,60,150 );
  Text := String.Create(  );
  StdZahl        := Vtre.LiesStdzahlinVtr( Vertrag );
  WholeStr.CardToStr( StdZahl,Zeichenkette );
  String.Schreibe( Text,Zeichenkette );
  StdZahlAnzeige := StelleMeldungDar( Text,FALSE,FensterHandle,155,150 );
  String.Dispose( Text );

  (*  Vertrag.Taetigkeit ausgeben *)
  String.Schreibe( Titel,"Taetigkeit:" );
  TaetigkeitTitel   := StelleMeldungDar( Titel,FALSE,FensterHandle,60,180 );
  Text	:= Vtre.LiesTaetigktinVtr ( Vertrag );
  TaetigkeitAnzeige := StelleMeldungDar( Text,FALSE,FensterHandle,155,180 );
  String.Dispose( Text );

  (*  Vertrag.Begruendung ausgeben *)
  String.Schreibe( Titel,"Begruendung: " );
  BegrTitel   := StelleMeldungDar( Titel,FALSE,FensterHandle,60,210 );
  Text 	      := Vtre.LiesBegruendinVtr ( Vertrag );
  BegrAnzeige := StelleMeldungDar( Text,FALSE,FensterHandle,155,210 );
  String.Dispose( Text );

  (* Vertrag.GueltigVon ausgeben *)
  String.Schreibe( Titel,"GueltigVon: " );
  GueltigVonTitel   := StelleMeldungDar( Titel,FALSE,FensterHandle,60,240 );
  GueVonDatum       := Vtre.LiesGueltigVoninVtr ( Vertrag );
  Text	            := Datum.DatumAlsString( GueVonDatum );
  GueltigVonAnzeige := StelleMeldungDar( Text,FALSE,FensterHandle,155,240 );
  String.Dispose( Text );
  Datum.DisposeDatum( GueVonDatum );


  (* Vertrag.StorniertAm ausgeben *)
  String.Schreibe( Titel,"Storniert: " );
  GueltigVonTitel   := StelleMeldungDar( Titel,FALSE,FensterHandle,60,270 );
  GueVonDatum       := Vtre.LiesStornoAminVtr ( Vertrag );
  Text	            := Datum.DatumAlsString( GueVonDatum );
  GueltigVonAnzeige := StelleMeldungDar( Text,FALSE,FensterHandle,155,270 );
  Datum.DisposeDatum( GueVonDatum );


  (*  -- Vertrag.GueltigBis ausgeben *)
  String.Schreibe( Titel,"GueltigBis:" );
  GueBisDatum       := Vtre.LiesGueltigBisinVtr ( Vertrag );
  Text	            := Datum.DatumAlsString( GueBisDatum );
  GueltigBisZeile   := StelleZeileDar( Titel,Text,10,FensterHandle,270,300 );
  String.Dispose( Text );
  Datum.DisposeDatum( GueBisDatum );


  String.Dispose( Text );

  Heute           := SysDat.LiesSystemDatumInSysDat(  );
  HeuteString     := String.Create(  );
  String.Schreibe( HeuteString,StC( Datum.DatumAlsString( Heute ) ) );
  String.Schreibe( Titel,"Systemdatum: " );
  SystemDatTitel   := StelleMeldungDar( Titel,FALSE,FensterHandle,60,30 );
  SystemDatAnzeige := StelleMeldungDar( HeuteString,TRUE,FensterHandle,150,30 );
  String.Dispose( HeuteString );



  IF NOT Vtre.IstStornoInVtr (Vertrag) THEN
     String.Schreibe( Titel,"Aenderung bernehmen" );
     AendernKnopfHandle := StelleKnopfDar( Titel,FensterHandle,155,350,CAST( PROC,AendernKnopfCallback ) );
     String.Schreibe( Titel, "Vertrag stornieren" );
     StornoKnopfHdle  := StelleKnopfDar( Titel,FensterHandle,395,350,CAST( PROC,StornoKnopfCallback ) );
     String.Dispose( Titel );
  END;

END AusgabeFormular;

		     (* ----------------LokaleProcedure von InitialDialog(  )----------------*)


PROCEDURE VertragEinlesen( VAR outVtr : Vtre.TVtr ) : BOOLEAN;

VAR VertrID : Vtre.TVtrID;
    success : BOOLEAN;
    errmsg  : String.TString;

BEGIN

  success := Vtre.PruefeVtrID( globalVtrId_str,errmsg ) ;
  IF success THEN
    VertrID := Vtre.StringInVtrID ( globalVtrId_str );
    success := Vtre.SearchVtr( VertrID,outVtr );
  END;
  IF NOT success THEN
    WriteString( "Einlesen des Vertrages fehlgeschlagen" );WriteLn(  );
  END;
  RETURN( success );

END VertragEinlesen;
								
			

                        (* -------------Hauptprocedure "InitialDialog(  )--------------*)

VAR Text     : String.TString;
    success  : BOOLEAN;

BEGIN

 success := VertragEinlesen( Vertrag );

 IF NOT success THEN
  Text := String.Create(  );
  String.Schreibe( Text,"Vtr einlesen fehlgeschlagen" );
  MeldungAnzeigen( Text );
  String.Dispose( Text );
 END;
 IF success THEN
  AusgabeFormular(  );
 END;

END InitialDialog;

(* ---------------------------------------------------------------------------*)

PROCEDURE AendernKnopfCallback(  );
(*
    -- Einlesen von DatumBis aus Formular,
    -- anschlieend Datum in Vertrag einschreiben
*)

VAR sGueltigBis_g	: String.TString;
    ok 						: BOOLEAN;
    BisDatum    	: Datum.TDatum;
    errmsg      	: String.TString;
    meldung     	: String.TString;
    okMeldungHdle	: ADDRESS;

BEGIN

  sGueltigBis_g := String.Create(  );
  LiesZeile( GueltigBisZeile,sGueltigBis_g );
  IF Datum.DatumVonString ( sGueltigBis_g,BisDatum,errmsg ) THEN
  (*  -- Aenderung im Ordner Vtre durchfhren *)
    IF  HKB.AendernVtr ( Vertrag,BisDatum,errmsg ) THEN
      meldung := String.Create();
      String.Schreibe( meldung,"nderung erfolgreich durchgefhrt" );
      TestMeldung1 := StelleMeldungDar( meldung,TRUE,FensterHandle,380,150 );
      String.Dispose( meldung );
    ELSE
      TestMeldung1 := StelleMeldungDar( errmsg,TRUE,FensterHandle,380,150 );
    END;
  ELSE
     MeldungAnzeigen( errmsg );
     String.Dispose( errmsg );
  END (* IF *);

 END AendernKnopfCallback;
(*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* ----------------------------------------------------------------------------*)

PROCEDURE Create( invtrid : ADDRESS;inpersid : ADDRESS;inkstid : ADDRESS; ingrossvater : ADDRESS );

VAR Titel : String.TString;

BEGIN

  Vertrag    := NIL;

 (*
    -- Casting  und modulinternes Globalisieren
    -- der vom Vaterfenster bergebenen Parameter
 *)
  globalVtrId_str  := CAST( String.TString,invtrid );
  globalPersId_str := CAST( String.TString,inpersid );
  globalKstId_str  := CAST( String.TString,inkstid );
  VaterActProcHdle := ingrossvater;
  Titel := String.Create(  );
  String.Schreibe( Titel,"V e r t r a g   S t o r n i e r e n  |  A e n d e r n.." );
  FensterHandle :=  NeuesFenster( Titel,100,100,500,740 );
  InitMaske(  );

END Create;

(* ------------------------------------------------------------------------------*)

PROCEDURE Dispose(  );

VAR AktiviereVater : TVater;

BEGIN
  EntferneFenster( FensterHandle );
  AktiviereVater := CAST( TVater,VaterActProcHdle );
  AktiviereVater(  );

END Dispose;
(* ------------------------------------------------------------------------------*)

PROCEDURE ExtractVtrId( inQuelle : String.TString; VAR inoutZiel : String.TString;
   		       inStartPos,inAnzahl : CARDINAL );
(*  Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;

BEGIN

  selString := String.Create(  );
  String.Auslesen ( inQuelle,inStartPos,inAnzahl,selString );
  WriteString( StC( selString ) );WriteLn(  );
  String.Equalize( inoutZiel,selString );
  WriteString( StC( inoutZiel ) );WriteLn(  );
  String.Dispose( selString );

END ExtractVtrId;

(* ---------------------------------------------------------------------------------*)

PROCEDURE ExtractPersId( inQuelle : String.TString; VAR inoutZiel : String.TString;
   			inStartPos,inAnzahl : CARDINAL );
(*  Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;

BEGIN

  selString := String.Create(  );
  String.Auslesen ( inQuelle,inStartPos,inAnzahl,selString );
  String.Equalize( inoutZiel,selString );
  String.Dispose( selString );

END ExtractPersId;
(* ----------------------------------------------------------------------------------*)


PROCEDURE ExtractKstId( inQuelle : String.TString; VAR inoutZiel : String.TString;
   		       inStartPos,inAnzahl : CARDINAL );
(*  Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via inoutZiel*)
VAR selString : String.TString;

BEGIN

  selString := String.Create(  );
  String.Auslesen ( inQuelle,inStartPos,inAnzahl,selString );
  String.Equalize( inoutZiel,selString );
  String.Dispose( selString );

END ExtractKstId;
(* ----------------------------------------------------------------------------------*)

END FAendern2VtrHKB.
