(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FAnlegenVtrHKB;

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FAnlegenVtrHKB;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT StelleListeDar, EntferneListe, LiesListenelement;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM WholeStr IMPORT CardToStr;
FROM InOut IMPORT WriteCard, WriteString, WriteLn;

FROM Datum IMPORT TDatum, DatumVonString;
FROM FVtrHKB IMPORT CreateFVtr;

IMPORT String;
IMPORT Stringliste;
IMPORT HKe;
IMPORT Ksten;
IMPORT FPruefmodulHK;


  TYPE 	TFAnlegenVtrDS = RECORD
		           WinHdle,
		           OkKnopf,
		           AbbrechenKnopf,
		           HKListe,
		           KstListe,
		           PersIDZ,
		           KstIDZ : ADDRESS;
		           SHKID,
		           SKstID: String.TString; 		
		         END;	
       	TPFAnlegenVtr = POINTER TO TFAnlegenVtrDS;

  CONST CFLINKS = 80;
  	CFOBEN = 140;
  	CFHOEHE = 400;
  	CFBREITE = 800;
  	CKNOPFOKX = 480;
  	CKNOPFOKY = 180;
  	CKNOPFABBRECHENX = 550;
  	CKNOPFABBRECHENY = 300;
  	CHKLISTEX = 60;
  	CHKLISTEY = 50;
  	CKSTLISTEX = 60;
  	CKSTLISTEY = 170;
  	CPERSIDL = 5;
  	CPERSIDX = 480;
  	CPERSIDY = 60;
  	CKSTIDL = 5;
  	CKSTIDX = 480;
  	CKSTIDY = 90;

(*************************************************************************************************)
(********************************** PROZEDURE KnoepfeAnlegenVtr() ********************************)
(*************************************************************************************************)

PROCEDURE KnoepfeAnlegenVtr();
  VAR
    hilfsText: String.TString;
    OkHandle, AbbrechenHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegenVtr;

  BEGIN
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);
    hilfsText := String.Create();
(*************************************************************************************************)
    String.Schreibe(hilfsText,"-->Eingabe besttigen");
    OkHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFOKX,CKNOPFOKY,
    				    CAST(PROC,OkKnopfCallback));

    String.Schreibe(hilfsText,"Abbrechen");
    AbbrechenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFABBRECHENX,
    				      CKNOPFABBRECHENY,CAST(PROC,AbbrechenKnopfCallback));
(*************************************************************************************************)
    String.Dispose(hilfsText);
    WITH ichSelbst^ DO
      OkKnopf:= OkHandle;
      AbbrechenKnopf:= AbbrechenHandle;
    END (*WITH*)
  END KnoepfeAnlegenVtr;

(*************************************************************************************************)
(******************************* PROCEDURE AbbrechenKnopfCallback() ******************************)
(*************************************************************************************************)

PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    DisposeFAnlegenVtr();
  END AbbrechenKnopfCallback;

(*************************************************************************************************)
(********************************** PROCEDURE OkKnopfCallback() **********************************)
(*************************************************************************************************)

PROCEDURE OkKnopfCallback();
  VAR
     ichSelbst: TPFAnlegenVtr; (* Zeiger auf ADT Fenster FSelektion *)
     meineAddr: ADDRESS; (* Addresse dazu *)
     reaktProc: TProc;
     IDHK, IDKst: String.TString;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);
    IF NOT ((ichSelbst^.PersIDZ = NIL) OR (ichSelbst^.KstIDZ = NIL)) THEN
        IDHK := String.Create();
        IDKst := String.Create();

        EntferneFenster(ichSelbst^.WinHdle);
        IDHK := String.Duplicate(ichSelbst^.SHKID);
        IDKst := String.Duplicate(ichSelbst^.SKstID);
        Pop();
        DISPOSE(ichSelbst);
        CreateFVtr(IDHK, IDKst);
        String.Dispose(IDHK);
        String.Dispose(IDKst);
    END; (* IF *)
  END OkKnopfCallback;

(*************************************************************************************************)
(******************************* PROZEDURE StringlisteAnlegenVtr() *******************************)
(*************************************************************************************************)

PROCEDURE StringlisteAnlegenVtr();
  VAR
    hilfsText: String.TString;
    HKeStringliste, KstStringliste: Stringliste.TStringliste;
    HKListeHandle, KstListeHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegenVtr;

  BEGIN
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);
    hilfsText := String.Create();
    HKeStringliste := HKe.GibHKeAlsStringlisteinHKe();
    KstStringliste := Ksten.GibKstenAlsStringlisteInKsten();
(*************************************************************************************************)
    String.Schreibe(hilfsText,"  Id    Name   ");
    HKListeHandle := StelleListeDar(HKeStringliste,hilfsText,4,ichSelbst^.WinHdle,CHKLISTEX,
    				    CHKLISTEY,CAST(PROC,HKeListeCallback));

    KstListeHandle := StelleListeDar(KstStringliste,hilfsText,4,ichSelbst^.WinHdle,CKSTLISTEX,
    				     CKSTLISTEY,CAST(PROC,KstListeCallback));
(*************************************************************************************************)
    String.Dispose(hilfsText);
    Stringliste.Dispose(HKeStringliste);
    Stringliste.Dispose(KstStringliste);
    WITH ichSelbst^ DO
      HKListe:= HKListeHandle;
      KstListe:= KstListeHandle;
    END (*WITH*)
  END StringlisteAnlegenVtr;

(*************************************************************************************************)
(********************************* PROCEDURE HKeListeCallback() **********************************)
(*************************************************************************************************)

PROCEDURE HKeListeCallback(element : INTEGER);
  VAR
    ichSelbst: TPFAnlegenVtr; (* Zeiger auf ADT Fenster FSelektion *)
    meineAddr: ADDRESS; (* Addresse dazu *)
    reaktProc: TProc;
    Titel, Elementstring, Text: String.TString;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);

    Elementstring := String.Create();
    Text := String.Create();
    LiesListenelement(ichSelbst^.HKListe,element,Elementstring);
    String.Auslesen(Elementstring,0,5,Text);
    ichSelbst^.SHKID:= String.Duplicate(Text);
    Titel := String.Create();
    String.Schreibe(Titel,"PersonalID:");
    ichSelbst^.PersIDZ:=StelleZeileDar(Titel,Text,CPERSIDL,ichSelbst^.WinHdle,CPERSIDX,CPERSIDY);
    String.Dispose(Elementstring);
    String.Dispose(Titel);
    String.Dispose(Text);
  END HKeListeCallback;

(*************************************************************************************************)
(********************************* PROCEDURE KstListeCallback() **********************************)
(*************************************************************************************************)

PROCEDURE KstListeCallback(element : INTEGER);
  VAR
    ichSelbst: TPFAnlegenVtr; (* Zeiger auf ADT Fenster FSelektion *)
    meineAddr: ADDRESS; (* Addresse dazu *)
    reaktProc: TProc;
    Titel, Elementstring, Text : String.TString;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);

    Elementstring := String.Create();
    Text := String.Create();
    LiesListenelement(ichSelbst^.KstListe,element,Elementstring);
    String.Auslesen(Elementstring,0,5,Text);
    ichSelbst^.SKstID:= String.Duplicate(Text);
    Titel := String.Create();
    String.Schreibe(Titel,"KostenstellenID:");
    ichSelbst^.KstIDZ:=StelleZeileDar(Titel,Text,CKSTIDL,ichSelbst^.WinHdle,CKSTIDX,CKSTIDY);
    String.Dispose(Elementstring);
    String.Dispose(Titel);
    String.Dispose(Text);
  END KstListeCallback;

(*************************************************************************************************)
(********************************** PROCEDURE CreateFAnlegenVtr() ********************************)
(*************************************************************************************************)

PROCEDURE CreateFAnlegenVtr();
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFAnlegenVtr;
      meineAddr: ADDRESS;
  BEGIN
    NEW (ichSelbst);
    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"V e r t r a g   E r z e u g e n  &  B u c h e n");
    WinHdle:=NeuesFenster(FensterUeberschrift,CFOBEN,CFLINKS,CFHOEHE,CFBREITE);
    String.Dispose(FensterUeberschrift);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegenVtr, meineAddr);
    ichSelbst^.WinHdle:=WinHdle;
    ichSelbst^.PersIDZ:= NIL;
    ichSelbst^.KstIDZ:= NIL;
    StringlisteAnlegenVtr();
    KnoepfeAnlegenVtr();
  END CreateFAnlegenVtr;

(*************************************************************************************************)
(********************************** PROCEDURE DisposeFAnlegenVtr() *******************************)
(*************************************************************************************************)

PROCEDURE DisposeFAnlegenVtr();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenVtr;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);
   (* MeldungenEntfernen(); *)
   (* ZeilenEntfernen(); *)
   (* KnoepfeEntfernen(); *)
    EntferneFenster(ichSelbst^.WinHdle);

    Pop();
    DISPOSE(ichSelbst);
    Top(reaktProc, meineAddr);
    reaktProc();
  END DisposeFAnlegenVtr;



(*************************************************************************************************)
(*********************************** PROCEDURE DeaktFAnlegenVtr() ********************************)
(*************************************************************************************************)

PROCEDURE DeaktFAnlegenVtr();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenVtr;
  BEGIN
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);
  END DeaktFAnlegenVtr;

(*************************************************************************************************)
(*********************************** PROCEDURE ReaktFAnlegenVtr() ********************************)
(*************************************************************************************************)

PROCEDURE ReaktFAnlegenVtr();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenVtr;
  BEGIN
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFAnlegenVtr, meineAddr);

  END ReaktFAnlegenVtr;

(*************************************************************************************************)
(*********************************** PROCEDURE AnzeigenMeldung() *********************************)
(*************************************************************************************************)
(*
PROCEDURE AnzeigenMeldung(inStr:ARRAY OF CHAR);                                                           		
  VAR
      MeldText: String.TString;
  BEGIN
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText);
    String.Dispose(MeldText);
  END AnzeigenMeldung; *)

END FAnlegenVtrHKB.


