MODULE SysDatTest;

   FROM InOut IMPORT ReadCard, WriteCard, WriteString, WriteLn;
   FROM InOut IMPORT ReadLn, ReadString;

   FROM SYSTEM  IMPORT TSIZE;

   IMPORT Datum;
   IMPORT SysDat;
   IMPORT VDat;
   IMPORT String;
    
   VAR Befehl          	: CARDINAL;
       TestVersion     	: SysDat.TVersion;
       TestProcs       	: ARRAY[0..20] OF PROC;
       MaxProcNr       	: CARDINAL;
       Vexistiert      : BOOLEAN;

  PROCEDURE CreateVersion();
  VAR str1:String.TString;
      message:String.TString;
      outD: Datum.TDatum;
  BEGIN
    WriteString("Operation: SysDat.CreateVersion");
    WriteLn;
    IF TestVersion<>NIL THEN
      WriteString ("Es existiert bereits eine TestVersion");
      WriteLn;
    ELSE 
      str1 := String.Create ();
      StringEingeben ("Wert fuer Version eingeben :",str1);
      IF SysDat.VersionVonString(str1,TestVersion,message) THEN
        WriteString("Ein ADO vom Typ Version ist angelegt worden.");
        WriteLn;
        WriteString("TestVersion ist auf ");
        StringAusgeben(SysDat.VersionAlsString(TestVersion));
        WriteString("gesetzt.");
        WriteLn;
        Vexistiert:=TRUE;
      ELSE
        StringAusgeben(message);
        String.Dispose(message);
      END (* IF *); 
    END; (* IF *)
    WriteLn;
  END CreateVersion;

  PROCEDURE DisposeVersion();
  VAR str1:String.TString;
      message:String.TString;
      outD: Datum.TDatum;
  BEGIN
    WriteString("Operation: SysDat.DisposeVersion");
    WriteLn;
    IF Vexistiert THEN
      SysDat.DisposeVersionInSysDat (TestVersion);
      Vexistiert:=FALSE;
      WriteString ("TestVersions ADO wurde geloescht");
      WriteLn;
    ELSE 
      WriteString ("TestVersions ADO existiert noch nicht");        
      WriteLn;
    END; (* IF *)
    WriteLn;
  END DisposeVersion;

  PROCEDURE LiesBackupVersion();
  VAR str1	: String.TString;
      V		: SysDat.TVersion;
  BEGIN
    WriteString("Operation: SysDat.LiesBackupVersion");
    WriteLn;
    WriteString("Der aktuelle Wert des Backupversionszaehlers in SysDat ist :");
    V:=SysDat.LiesBackupVersionInSysDat ();
    str1:=SysDat.VersionAlsString(V);
    StringAusgeben(str1);
    String.Dispose(str1);
    SysDat.DisposeVersionInSysDat(V);
    WriteLn;
  END LiesBackupVersion;

  PROCEDURE LiesBackupDatum();
  VAR str:String.TString;
      message:String.TString;
      D: Datum.TDatum;
  BEGIN
    WriteString("Operation: SysDat.LiesBackupDatum");
    WriteLn;
    IF Vexistiert THEN
      WriteString("Zur Versions Nr. ");
      str:=SysDat.VersionAlsString(TestVersion);
      StringAusgeben(str);
      String.Dispose(str); 
      WriteString("gehrt das Backup-Datum ");
      D:=SysDat.LiesBackupDatumInSysDat(TestVersion);
      str:=Datum.DatumAlsString(D);
      StringAusgeben(str);
      String.Dispose(str); 
      WriteLn;
    ELSE
      WriteString("Zuerst ein Versions-ADO anlegen!");
      WriteLn;
    END (* IF *);
    WriteLn;
  END LiesBackupDatum;

  PROCEDURE  NeuesBackup();
  VAR str	: String.TString;
      V		: SysDat.TVersion;
  BEGIN
    WriteString("Operation: SysDat.NeuesBackup"); 
    WriteLn;
    SysDat.NeuesBackupInSysDat();
    V:=SysDat.LiesBackupVersionInSysDat (); 
    str:=SysDat.VersionAlsString(V);
    WriteString("Neues Backup in SysDat eingetragen!");
    WriteLn;
    WriteString("Der Backupzaehler in SysDat hat jetzt den Wert: ");
    StringAusgeben(str);
    String.Dispose(str);
    SysDat.DisposeVersionInSysDat(V);  
  END NeuesBackup;

  PROCEDURE Load();
  VAR M		: VDat.TModusInVDat;
      H 	: VDat.THandleInVDat;
      Filename	: String.TString;
      message	: String.TString;
  BEGIN
    WriteString("Operation: SysDat.Load"); 
    WriteLn;
        WriteString("Die Datei hiks.ini wird geladen:");
    WriteLn;
    M:=VDat.SetReadInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"hiks.ini");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT SysDat.LoadInSysDat(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("hiks.ini ist geladen!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);    
    WriteLn;                                   
  END Load;

  PROCEDURE Save();
  VAR M         : VDat.TModusInVDat;
      H         : VDat.THandleInVDat;
      Filename  : String.TString;
      message   : String.TString; 
  BEGIN
    WriteString("Operation: SysDat.Save"); 
    WriteLn;
        WriteString("Die Datei hiks.ini wird gespeichert:");
    WriteLn;
    M:=VDat.SetWriteInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"hiks.ini");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT SysDat.SaveInSysDat(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("hiks.ini ist gespeichert!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);    
    WriteLn;                                   
  END Save;

  PROCEDURE BackupsAusgeben();
  VAR V		: SysDat.TVersion;
      D		: Datum.TDatum;
      Vstr,Dstr	: String.TString;

  BEGIN
    WriteString("Operation: SysDat.First/NextBackup");
    WriteLn;
    IF SysDat.FirstBackupInSysDat(V,D) THEN
      REPEAT
        Vstr:=SysDat.VersionAlsString(V);
	Dstr:=Datum.DatumAlsString(D);
        WriteString("Backup Nr. ");
        StringAusgeben(Vstr);
	WriteString(" vom ");
        StringAusgeben(Dstr);
        WriteLn;
        String.Dispose(Vstr);
	String.Dispose(Dstr);
      UNTIL NOT SysDat.NextBackupInSysDat(V,D);
      SysDat.DisposeVersionInSysDat(V);
      Datum.DisposeDatum(D);
    ELSE
      WriteString("Es sind noch keine Daten ueber Backups vorhanden!");
      WriteLn;
    END (* IF *);
    WriteLn;
  END BackupsAusgeben;
	
  PROCEDURE LiesLetztesAutoDatum();
  VAR D		: Datum.TDatum;
      Dstr	: String.TString;

  BEGIN
    WriteString("Operation: LiesLetztesAutodatum");
    WriteLn;
    WriteString("Der letzte Lauf des automatischen Betriebs erfolgte am : ");
    D:=SysDat.LiesLetztesAutoDatumInSysDat();
    Dstr:=Datum.DatumAlsString(D);
    StringAusgeben(Dstr);
    Datum.DisposeDatum(D);
    String.Dispose(Dstr);
    WriteLn;
    WriteLn;
  END  LiesLetztesAutoDatum;

  PROCEDURE SetzeLetztesAutoDatum();
  VAR D         	: Datum.TDatum;
      Dstr,message 	: String.TString;

  BEGIN
    WriteString("Operation: SetzeLetztesAutodatum");
    WriteLn;
    WriteString("Datum des letzten Automatischen Betriebes setzen:");
    WriteLn;
    Dstr:=String.Create();
    StringEingeben("Datum : ",Dstr);
    IF Datum.DatumVonString(Dstr,D,message) THEN
      SysDat.SetzeLetztesAutoDatumInSysDat(D);
      WriteString("Datum des letzten Automatischen Betriebes ist auf ");
      Dstr:=Datum.DatumAlsString(D);
      StringAusgeben(Dstr);
      Datum.DisposeDatum(D);
      String.Dispose(Dstr);
      WriteString("gesetzt.");
      WriteLn;
    ELSE
      StringAusgeben(message);
      String.Dispose(message);
    END (* IF *);
    WriteLn;
  END SetzeLetztesAutoDatum;  
	
  PROCEDURE LiesSystemDatum();
  VAR D		: Datum.TDatum;
      Dstr	: String.TString;

  BEGIN
    WriteString("Operation: LiesSystemDatum");
    WriteLn;
    WriteString("Das SystemDatum ist : ");
    D:=SysDat.LiesSystemDatumInSysDat();
    Dstr:=Datum.DatumAlsString(D);
    StringAusgeben(Dstr);
    Datum.DisposeDatum(D);
    String.Dispose(Dstr);
    WriteLn;
    WriteLn;
  END LiesSystemDatum;

  PROCEDURE SetzeSystemDatum();
  VAR D         	: Datum.TDatum;
      Dstr,message  	: String.TString;

  BEGIN
    WriteString("Operation: SetzeSystemDatum");
    WriteLn;
    WriteString("HiKS Systemdatum setzen:");
    WriteLn;
    Dstr:=String.Create();
    StringEingeben("Datum : ",Dstr);
    IF Datum.DatumVonString(Dstr,D,message) THEN
      SysDat.SetzeSystemDatumInSysDat(D);
      WriteString("Systemdatum ist auf ");
      Dstr:=Datum.DatumAlsString(D);
      StringAusgeben(Dstr);
      Datum.DisposeDatum(D);
      String.Dispose(Dstr);
      WriteString("gesetzt.");
      WriteLn;
    ELSE
      StringAusgeben(message);
      String.Dispose(message);
    END (* IF *);
    WriteLn;
  END SetzeSystemDatum;  
         

  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("SysDat.CreateVersion");
    MenueItem ("SysDat.DisposeVersion");
    MenueItem ("SysDat.LiesBackupVersion");
    MenueItem ("SysDat.LiesBackupDatum");
    MenueItem ("SysDat.NeuesBackup");
    MenueItem ("SysDat.Load");
    MenueItem ("SysDat.Save");
    MenueItem ("SysDat.First/Next Iterator");
    MenueItem ("SysDat.LiesLetztesAutoDatum");
    MenueItem ("SysDat.SetzeLetztesAutoDatum");
    MenueItem ("SysDat.LiesSystemDatum");
    MenueItem ("SysDat.SetzeSystemDatum");
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (CreateVersion);
    ProcEintragen (DisposeVersion);
    ProcEintragen (LiesBackupVersion);
    ProcEintragen (LiesBackupDatum);
    ProcEintragen (NeuesBackup);
    ProcEintragen (Load);
    ProcEintragen (Save);
    ProcEintragen (BackupsAusgeben);
    ProcEintragen (LiesLetztesAutoDatum);
    ProcEintragen (SetzeLetztesAutoDatum);
    ProcEintragen (LiesSystemDatum);
    ProcEintragen (SetzeSystemDatum);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN

    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;

PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..50] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; inoutStr : String.TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
END StringEingeben;

BEGIN
  InitTestProcs;
  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;
END SysDatTest.
