(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: VDat.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:07 $
# $Revision: 1.1.1.1 $
# Bemerkungen:
        Kompilierfhiger Status ist erreicht! hgw 12.1.2001 17:40
        Modul ist fertig getestet und tut -hoffentlich- das was es soll.
        hgw, 18.2.2001
	Beim Implementieren des TS Konden ist aufgefallen dass die EOF Funktion
	des Systems erst TRUE liefert, wenn's schon zu spaet ist. Also hab ich
	mir was eigenes ueberlegt.
	hgw, 22.2.2001
#
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE VDat;


FROM UxFiles   IMPORT 	Open, Close, EndFile, File, OpenMode, FileSize, SetPos,
			GetPos;
FROM String    IMPORT 	TString, Create, Schreibe, Lies;
FROM TextInOut IMPORT 	EOL, WriteString, WriteLn, Read; 
IMPORT InOut;


TYPE THandleInVDat=File;  
     THandle=THandleInVDat;
     TModus=TModusInVDat;

PROCEDURE OpenInVDat (VAR outH: THandle; inFileN: TString; inModus: TModus):
	BOOLEAN;
(*
vb: 	Falls inModus=Appendmodus dann muss Datei inFileN existieren, i
	sonst keine
Oeffnet Datei inFileN. Falls Datei nicht existiert, und Modus = schreiben  
dann wird ein File mit dem angegebenen Namen erzeugt; falls Datei existiert
wird diese Datei zur Bearbeitung im inModus geffnet. 
nb:	Datei ist geoeffnet und outH verweist auf Datei. Falls Modus=append
	steht der Dateizeiger hinter dem letzten Zeichen in der Datei
*)

VAR 	done: BOOLEAN;
	str: ARRAY [1..255] OF CHAR;
	size: CARDINAL;

BEGIN
	Lies(inFileN,str);
        Open(outH,str,inModus,done);
	IF inModus=ReadWrite THEN	(* Sonderbehandlung fuer Appendmodus *)
		FileSize(str,size,done);(* Dateizeiger wird an das Ende der *)
		IF done THEN		(* Datei gesetzt *)	
			SetPos(outH,size);	
		END (* IF *);
	END (* IF *);
	RETURN done;
END OpenInVDat; 
  	
PROCEDURE CloseInVDat ( inH: THandle):BOOLEAN;
(*
vb:   inH ist geoeffnet
Beendet die Datei-Operationen und schliet inH
nb:   inH ist geschlossen
*) 
VAR done: BOOLEAN;
BEGIN
	Close(inH,done);
	RETURN done;
END CloseInVDat;
  	
PROCEDURE SetWriteInVDat():TModus;
(*
vb:   keine
Gibt Wert fr Schreibmodus zurck
nb:   keine
*)
VAR Modus: TModus;
BEGIN
	Modus:=WriteOnly;
	RETURN Modus;
END SetWriteInVDat;


PROCEDURE SetReadInVDat():TModus;
(*
vb:   keine
Gibt Wert fr Lesemodus zurck
nb:   keine
*)
VAR Modus: TModus;
BEGIN
	Modus:=ReadOnly;
	RETURN Modus;
END SetReadInVDat;

PROCEDURE SetAppendInVDat():TModus;
(*
vb:   keine
Gibt Wert fr Appendmodus zurck
nb:   keine
*)
VAR Modus: TModus;
BEGIN
	Modus:=ReadWrite;
	RETURN Modus;
END SetAppendInVDat;
 
PROCEDURE ReadLineInVDat ( inH : THandle;
                           VAR outString: TString;
                           VAR outM: TString):BOOLEAN;
 
(*
vb:   inH existiert und Datei ist zum Lesen geoeffnet
Liest aus der Datei inH von der aktuellen Position bis zum
nchsten EOL oder EOF . Falls dabei ein Fehler auftritt wird
false und ein Fehler in outM zurckgegeben, sonst true und die
gelesene Zeile in outString
nb:   ReadLineInVDat=TRUE AND outString existiert OR
      ReadLineInVDat=FALSE AND outM existiert
*)
VAR 	c		:CHAR;
    	i		:CARDINAL;
	CharArray	:ARRAY [1..255] OF CHAR;
	err		:BOOLEAN;
	

BEGIN
	c:='';
	err:=TRUE;
	outString:=Create();
 

	FOR i:=1 TO 255 DO          (* wg. Problemen mit zufaelligen Daten *)
	  CharArray[i]:=CHR(0);	    (* wird das Array initialisiert *)
        END (* FOR *);
	
	i:=1;
	WHILE (c <> EOL) AND (i <= 255) AND (NOT EofInVDat(inH)) DO 
		Read(inH,c);
                IF c<>EOL THEN 
			CharArray[i]:=c; 
		END (* IF *);
		i:=i+1;
	END (* WHILE *);	
	Schreibe(outString,CharArray);
	IF (i=256) OR  EndFile(inH) THEN
		outM:=Create();
		Schreibe (outM,"Fehler beim Einlesen in ReadLine!");
		err:=FALSE;
	END (* IF *);
        RETURN err;
END ReadLineInVDat;

PROCEDURE WriteLineInVDat( inH : THandle;
                           inS:TString;
                           VAR outM:TString):BOOLEAN;
(*
vb:   inH existiert und Datei ist zum Scheiben geoeffnet
Schreibt in die Datei inH an der aktuellen Position
den String inS gefolgt von einem Zeilen-Ende-Zeichen
Falls dabei ein Fehler auftritt, wird false und ein Fehler in
inoutM zurckgegeben, sonst true
nb:   WriteLineInVDat=TRUE AND inS ist in Datei inH geschrieben OR
      ReadLineInVDat=FALSE AND outM existiert
*)
VAR
	CharArray: ARRAY[1..255]OF CHAR;
BEGIN
	Lies(inS,CharArray);
	WriteString(inH,CharArray);
	WriteLn(inH);
	RETURN TRUE; (* dient nur der Kompatibilitt *)
END WriteLineInVDat;


PROCEDURE EofInVDat ( inH : THandle): BOOLEAN;
(*
vb:   inH ist geoeffnet
Falls Dateizeiger unmittelbar vor dem Dateiende steht, so dass der naechste Leseversuch EndFile=TRUE zurueckliefern wuerde, dann wird TRUE zurueckgegeben,
sonst FALSE
nb:   keine
*)

VAR pos: CARDINAL;
    eof: BOOLEAN;
    c  : CHAR;
BEGIN
	GetPos(inH,pos);
	IF NOT EndFile(inH) THEN
		Read(inH,c);       (* Testen, ob das naechste Zeichen EOF ist *)
		eof:=EndFile(inH);  
		SetPos(inH,pos);   (* Wieder auf die alte Position stellen *)
	ELSE
		eof:=TRUE;
	END (* IF *);
	
	RETURN	eof;
END EofInVDat;
     	
END VDat.  	



