MODULE VDatTest;

   FROM InOut IMPORT ReadCard, WriteCard, WriteString, WriteLn;

   FROM InOut IMPORT ReadLn, ReadString;

   FROM SYSTEM  IMPORT TSIZE;

   FROM VDat IMPORT 	THandleInVDat,TModusInVDat,OpenInVDat,CloseInVDat,
			SetWriteInVDat,SetReadInVDat,SetAppendInVDat,
			ReadLineInVDat,WriteLineInVDat,EofInVDat ;
   
   IMPORT String;
   TYPE TTestMode=RECORD
			M : TModusInVDat;  
			S : String.TString;
			K : CARDINAL;
		END;
    
   VAR Befehl          	: CARDINAL;
       TestFile      	: THandleInVDat;
       TestMode		: TTestMode;
       TestProcs       	: ARRAY[0..20] OF PROC;
       MaxProcNr       	: CARDINAL;
       THexistiert      : BOOLEAN;
       TMexistiert      : BOOLEAN;

  PROCEDURE Open();
  VAR str1:String.TString;
  BEGIN
    WriteString("Operation: VDat.OpenInVDat");
    WriteLn;
    IF THexistiert THEN
      WriteString ("Es ist bereits eine Datei geffnet");
      WriteLn;
    ELSE 
      IF TMexistiert THEN
        str1 := String.Create ();
        StringEingeben ("Namen der Datei eingeben :",str1);
        IF OpenInVDat(TestFile,str1,TestMode.M) THEN
	  WriteString("Datei ");
	  StringAusgeben(str1);
	  WriteString("ist zum ");
	  StringAusgeben(TestMode.S);
	  WriteString("geoeffnet.");
	  WriteLn;
          THexistiert:=TRUE;
        ELSE
 	  WriteString("Datei konnte nicht geoeffnet werden!");
    	  WriteLn;
        END (* IF *);
        String.Dispose(str1);
      ELSE
        WriteString("Zuerst muss der Modus festgelegt sein!");
	WriteLn;
      END (* IF *);
    END; (* IF *)
    WriteLn;
  END Open;

  PROCEDURE SetRead();
  BEGIN
    WriteString("Operation: VDat.SetRead");
    WriteLn;
    TestMode.M:=SetReadInVDat();
    IF TestMode.S=NIL THEN
	TestMode.S:=String.Create();
    END (* IF *);
    String.Schreibe(TestMode.S,"lesen");
    TestMode.K:=1;
    WriteString("Lesemodus gesetzt.");
    TMexistiert:=TRUE;
    WriteLn;
    WriteLn;
  END SetRead;

  PROCEDURE SetWrite();
  BEGIN
    WriteString("Operation: VDat.SetWrite");
    WriteLn;
    TestMode.M:=SetWriteInVDat();
    IF TestMode.S=NIL THEN
	TestMode.S:=String.Create();
    END (* IF *);
    String.Schreibe(TestMode.S,"schreiben");
    TestMode.K:=2;
    TMexistiert:=TRUE;
    WriteString("Schreibmodus gesetzt.");
    WriteLn;
    WriteLn;
  END SetWrite;

  PROCEDURE SetAppend();
  BEGIN
    WriteString("Operation: VDat.SetAppend");
    WriteLn;
    TestMode.M:=SetAppendInVDat();
    IF TestMode.S=NIL THEN
	TestMode.S:=String.Create();
    END (* IF *);
    String.Schreibe(TestMode.S,"anhaengen");
    TestMode.K:=3;
    TMexistiert:=TRUE;
    WriteString("Appendmodus gesetzt.");
    WriteLn;
    WriteLn;
  END SetAppend;

  PROCEDURE Close();
  BEGIN
    WriteString("Operation: VDat.Close");
    WriteLn;
    IF THexistiert THEN
	IF CloseInVDat(TestFile) THEN
	  THexistiert:=FALSE;
	ELSE
	  WriteString("Datei konnte nicht fehlerfrei geschlossen werden!");
	  WriteLn();
	END (* IF *);
    ELSE
	WriteString("Vorbedingung ist verletzt!");
    	WriteLn;
    END (* IF *);
    WriteLn;
  END Close;

  PROCEDURE ReadLine();
  VAR Text	: String.TString;
      Message	: String.TString; 
  BEGIN
    WriteString("Operation: VDat.ReadLine");
    WriteLn;
    IF THexistiert AND (TestMode.K = 1) AND NOT EofInVDat(TestFile) THEN
    	IF ReadLineInVDat(TestFile,Text,Message) THEN
		WriteString("gelesen worden ist:");
		StringAusgeben(Text);
		String.Dispose(Text);
	ELSE
		StringAusgeben(Message);
		String.Dispose(Message);
	END (* IF *)
    ELSE
        WriteString("Vorbedingung ist verletzt!"); 
    	WriteLn;
    END (* IF *);
    WriteLn;
  END ReadLine;

  PROCEDURE WriteLine();
  VAR Text    : String.TString;
      Message : String.TString;

  BEGIN
    WriteString("Operation: VDat.WriteLine");
    WriteLn;
    IF THexistiert AND (TestMode.K = 2) OR (TestMode.K = 3) THEN
        Text:=String.Create();
        StringEingeben ("TestZeile eingeben :",Text);
    	IF WriteLineInVDat(TestFile,Text,Message) THEN
		WriteString("geschrieben wurde:");
		StringAusgeben(Text);
		String.Dispose(Text);
	ELSE
		StringAusgeben(Message);
                String.Dispose(Message);
	END (* IF *)
    ELSE
        WriteString("Vorbedingung ist verletzt!"); 
    	WriteLn;
    END (* IF *);
    WriteLn;
  END WriteLine;

  PROCEDURE Eof ();
  
  BEGIN
    WriteString("Operation: VDat.Eof");
    WriteLn;
    IF EofInVDat(TestFile) THEN
	WriteString(" TRUE");
    ELSE
	WriteString(" FALSE");
    END (* IF *);
    WriteLn;
  END Eof;

  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("VDat.Open");
    MenueItem ("VDat.SetRead");
    MenueItem ("VDat.SetWrite");
    MenueItem ("VDat.SetAppend");
    MenueItem ("VDat.Close");
    MenueItem ("VDat.ReadLine");
    MenueItem ("VDat.WriteLine");
    MenueItem ("VDat.Eof");
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (Open);
    ProcEintragen (SetRead);
    ProcEintragen (SetWrite);
    ProcEintragen (SetAppend);
    ProcEintragen (Close);
    ProcEintragen (ReadLine);
    ProcEintragen (WriteLine);
    ProcEintragen (Eof);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN

    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;

PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..50] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; inoutStr : String.TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
END StringEingeben;

BEGIN
  InitTestProcs;
  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;
END VDatTest.
