MODULE VtreTesten;

  IMPORT String;
  IMPORT Stringliste;

  IMPORT Ksten;    (* Kostenstellen *)
  IMPORT HKe;      (* Hilfskraefte *)
  IMPORT Vtre;     (* Vertraege *)
  IMPORT VDat;     (* Virtuelles Dateisystem *)

  FROM SysDat IMPORT LiesSystemDatumInSysDat, SetzeSystemDatumInSysDat;
  FROM Datum IMPORT TDatum, TJahr, LiesJahrInDatum, DatumVonString, DatumAlsString,
                    DisposeDatum, CreateDatum, SetzeDatumEternity;
  FROM InOut IMPORT ReadCard, WriteCard, WriteString, WriteLn;
  FROM InOut IMPORT ReadLn, ReadString;
  FROM WholeStr IMPORT ConvResults, CardToStr, StrToCard;

  TYPE
       TKst             = Ksten.TKst;
       TKstID           = Ksten.TKstID;
       THK              = HKe.THK;
       TPersID          = HKe.TPersID;
       TVtr             = Vtre.TVtr;
       TVtrID           = Vtre.TVtrID;
       TString          = String.TString;
       TStringliste     = Stringliste.TStringliste;

 VAR Befehl           : CARDINAL;
     MaxProcNr        : CARDINAL;
     TestProcs        : ARRAY[0..40] OF PROC;


(**********************************************************************************)
(* Initialisierungen                                                              *)
(**********************************************************************************)


  PROCEDURE CreateVtrAndInsert (inPersID : TPersID; inKstID :TKstID;
                                vonDatum, bisDatum, stornoDatum : TDatum;
                                stdZahl : CARDINAL);
  VAR aktVtr : TVtr;
      taetigkt, begruendg : TString;
      outMessage : TString;
      egal : BOOLEAN;
  BEGIN

    taetigkt := String.Create();
    String.Schreibe (taetigkt, "Taetigkeit_ist_ein_String_lnger_als_20_Zeichen");
    begruendg := String.Create();
    String.Schreibe (begruendg, "Begrndg");

    aktVtr := Vtre.CreateVtr();
    Vtre.SetzePersIDinVtr (aktVtr, inPersID);
    Vtre.SetzeKstIDinVtr (aktVtr, inKstID);
    Vtre.SetzeGueltigVoninVtr (aktVtr, vonDatum);
    Vtre.SetzeGueltigBisinVtr (aktVtr, bisDatum);
    egal := Vtre.SetzeStornoAminVtr (aktVtr, stornoDatum);
    egal := Vtre.SetzeStdzahlinVtr (aktVtr, stdZahl);
    egal := Vtre.SetzeTaetigktinVtr (aktVtr, taetigkt);
    egal := Vtre.SetzeBegruendinVtr (aktVtr, begruendg);

    IF Vtre.InsertVtr (aktVtr, outMessage)
    THEN
      WriteString ("-> Vertrag erfoldreich in Ordner aufgenommen");
      WriteLn;
     ELSE
      WriteString ("-> Fehler: "); StringAusgeben (outMessage);
      WriteLn;
      String.Dispose (outMessage);
    END;

    Vtre.DisposeVtr (aktVtr);
    String.Dispose (taetigkt);
    String.Dispose (begruendg);

  END CreateVtrAndInsert;


  PROCEDURE VtreInit;
  VAR tempString, outMessage : TString;
      persID : TPersID;
      aktHK : THK;
      kstID : TKstID;
      vonDatum, bisDatum, stornoDatum  : TDatum;
      stdzahl : CARDINAL;
      egal : BOOLEAN;
  BEGIN

   tempString := String.Create();

   (* Ersten Vertrag anlegen *)
   String.Schreibe (tempString, "2");
   persID := HKe.StringInPersID (tempString);
   String.Schreibe (tempString, "125");
   kstID := Ksten.StringInKstID (tempString);
   String.Schreibe (tempString, "01.01.2001");
   outMessage := String.Create();
   egal := DatumVonString (tempString, vonDatum, outMessage);
   String.Schreibe (tempString, "30.04.2001");
   egal := DatumVonString (tempString, bisDatum, outMessage);
   stornoDatum := CreateDatum ();
   CreateVtrAndInsert (persID, kstID, vonDatum, bisDatum, stornoDatum, 15);
   DisposeDatum (vonDatum);
   DisposeDatum (bisDatum);
   DisposeDatum (stornoDatum);
   String.Dispose (outMessage);
   Ksten.DisposeKstID (kstID);
   HKe.DisposePersID (persID);



   (* Zweiten Vertrag anlegen *)
   String.Schreibe (tempString, "2");
   persID := HKe.StringInPersID (tempString);
   String.Schreibe (tempString, "126");
   kstID := Ksten.StringInKstID (tempString);
   String.Schreibe (tempString, "01.05.2001");
   outMessage := String.Create();
   egal := DatumVonString (tempString, vonDatum, outMessage);
   String.Schreibe (tempString, "31.07.2001");
   egal := DatumVonString (tempString, bisDatum, outMessage);
   stornoDatum := CreateDatum ();
   CreateVtrAndInsert (persID, kstID, vonDatum, bisDatum, stornoDatum, 25);
   DisposeDatum (vonDatum);
   DisposeDatum (bisDatum);
   DisposeDatum (stornoDatum);
   String.Dispose (outMessage);
   Ksten.DisposeKstID (kstID);
   HKe.DisposePersID (persID);



   (* Dritten Vertrag anlegen *)
   String.Schreibe (tempString, "2");
   persID := HKe.StringInPersID (tempString);
   String.Schreibe (tempString, "126");
   kstID := Ksten.StringInKstID (tempString);
   String.Schreibe (tempString, "01.10.2001");
   outMessage := String.Create();
   egal := DatumVonString (tempString, vonDatum, outMessage);
   String.Schreibe (tempString, "31.12.2001");
   egal := DatumVonString (tempString, bisDatum, outMessage);
   stornoDatum := CreateDatum ();
   CreateVtrAndInsert (persID, kstID, vonDatum, bisDatum, stornoDatum, 20);
   DisposeDatum (vonDatum);
   DisposeDatum (bisDatum);
   DisposeDatum (stornoDatum);
   String.Dispose (outMessage);
   Ksten.DisposeKstID (kstID);
   HKe.DisposePersID (persID);


   (* Vierten Vertrag anlegen *)
   String.Schreibe (tempString, "4");
   persID := HKe.StringInPersID (tempString);
   String.Schreibe (tempString, "127");
   kstID := Ksten.StringInKstID (tempString);
   String.Schreibe (tempString, "01.08.2001");
   outMessage := String.Create();
   egal := DatumVonString (tempString, vonDatum, outMessage);
   bisDatum := CreateDatum();
   SetzeDatumEternity (bisDatum);
   stornoDatum := CreateDatum ();
   CreateVtrAndInsert (persID, kstID, vonDatum, bisDatum, stornoDatum, 10);
   DisposeDatum (vonDatum);
   DisposeDatum (bisDatum);
   DisposeDatum (stornoDatum);
   String.Dispose (outMessage);
   Ksten.DisposeKstID (kstID);
   HKe.DisposePersID (persID);


   (* Fnften Vertrag anlegen *)
   String.Schreibe (tempString, "4");
   persID := HKe.StringInPersID (tempString);
   String.Schreibe (tempString, "127");
   kstID := Ksten.StringInKstID (tempString);
   String.Schreibe (tempString, "01.02.2001");
   outMessage := String.Create();
   egal := DatumVonString (tempString, vonDatum, outMessage);
   String.Schreibe (tempString, "29.04.2001");
   egal := DatumVonString (tempString, bisDatum, outMessage);
   stornoDatum := CreateDatum ();
   CreateVtrAndInsert (persID, kstID, vonDatum, bisDatum, stornoDatum, 5);
   DisposeDatum (vonDatum);
   DisposeDatum (bisDatum);
   DisposeDatum (stornoDatum);
   String.Dispose (outMessage);
   Ksten.DisposeKstID (kstID);
   HKe.DisposePersID (persID);


   (* Sechsten Vertrag anlegen *)
   String.Schreibe (tempString, "4");
   persID := HKe.StringInPersID (tempString);
   String.Schreibe (tempString, "127");
   kstID := Ksten.StringInKstID (tempString);
   String.Schreibe (tempString, "01.05.2001");
   outMessage := String.Create();
   egal := DatumVonString (tempString, vonDatum, outMessage);
   String.Schreibe (tempString, "30.09.2001");
   egal := DatumVonString (tempString, bisDatum, outMessage);
   stornoDatum := CreateDatum ();
   CreateVtrAndInsert (persID, kstID, vonDatum, bisDatum, stornoDatum, 7);
   DisposeDatum (vonDatum);
   DisposeDatum (bisDatum);
   DisposeDatum (stornoDatum);
   String.Dispose (outMessage);
   Ksten.DisposeKstID (kstID);
   HKe.DisposePersID (persID);

   String.Dispose (tempString);

  END VtreInit;



(**********************************************************************************)
(* Vertraege                                                                      *)
(**********************************************************************************)


 PROCEDURE VtreListeAusgeben;
 VAR VtreListe : TStringliste;
     headline : TString;
 BEGIN

    WriteString("********* Operation: Vtre.GibVtrAlsStringlisteInVtr ************");
    WriteLn;

    VtreListe := Vtre.GibVtrAlsStringlisteInVtr();
    headline := String.Create();
    String.Schreibe (headline, "VtrID PerID KstID ErstellDat ");
    StringAusgeben (headline);
    String.Dispose (headline);
    KompletteListeAusgeben (VtreListe);
    Stringliste.Dispose (VtreListe);
 END VtreListeAusgeben;


 PROCEDURE VtreAllesListeAusgeben;
 VAR VtreListe : TStringliste;
     headline : TString;
 BEGIN

    WriteString("********* Operation: Vtre.GibAllesAlsStringlisteInVtr ***********");
    WriteLn;

    headline := String.Create();
    String.Schreibe (headline,
    "VtrID PerID KstID ErstellDat GueltigVon GueltigBis Storno     Stdzl Taetigkt   Begruendg ");
    StringAusgeben (headline);
    String.Dispose (headline);
    VtreListe := Vtre.GibAllesAlsStringlisteInVtr();
    KompletteListeAusgeben (VtreListe);
    Stringliste.Dispose (VtreListe);
 END VtreAllesListeAusgeben;


 PROCEDURE VtreAlleAusgeben;
 VAR aktVtr : TVtr;
     aktVtrID : TVtrID;
     idString : TString;
     arrayofchar : ARRAY [1..255] OF CHAR;
 BEGIN

   WriteString("****** Operationen: Vtre.FirstVtrUndStorno, NextVtrUndStorno *****");
   WriteLn;

   IF Vtre.FirstVtrUndStorno (aktVtr)
   THEN
     aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
     idString := Vtre.VtrIDAlsString (aktVtrID);
     String.Lies (idString, arrayofchar);
     WriteString ("-> Vertraege gefunden. VtrID ist: ");
     WriteString (arrayofchar);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);

     WHILE Vtre.NextVtrUndStorno (aktVtr) DO
        aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
        idString := Vtre.VtrIDAlsString (aktVtrID);
        String.Lies (idString, arrayofchar);
        WriteString (", ");
        WriteString (arrayofchar);
        Vtre.DisposeVtrID (aktVtrID);
        String.Dispose (idString);
     END; (* WHILE *)
     WriteLn;

     Vtre.DisposeVtr (aktVtr);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);
  ELSE
    WriteString ("-> Fehler: Gesuchter Vertrag nicht gefunden");
    WriteLn;
  END;

 END VtreAlleAusgeben;


 PROCEDURE VtreZuHK;
 VAR idString, suchHK: TString;
     persID : TPersID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("******* Operationen: Vtre.FirstVtrZuHK, NextVtrZuHK ***********");
   WriteLn;

     WriteString ("PersID der Hilfskraft eingeben:");
     suchHK := String.Create ();
     StringEingeben (suchHK);
     persID := HKe.StringInPersID (suchHK);

     IF Vtre.FirstVtrZuHK (persID, aktVtr)
     THEN
       aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
       idString := Vtre.VtrIDAlsString (aktVtrID);;
       String.Lies (idString, arrayofchar);
       WriteString ("-> Vertraege gefunden. VtrID ist: ");
       WriteString (arrayofchar);
       Vtre.DisposeVtrID (aktVtrID);
       String.Dispose (idString);

       WHILE Vtre.NextVtrZuHK (persID, aktVtr) DO
          aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
          idString := Vtre.VtrIDAlsString (aktVtrID);;
          String.Lies (idString, arrayofchar);
          WriteString (", ");
          WriteString (arrayofchar);
          Vtre.DisposeVtrID (aktVtrID);
          String.Dispose (idString);
       END; (* WHILE *)
       WriteLn;

    ELSE
      WriteString ("-> Fehler: Gesuchter Vertrag nicht gefunden");
      WriteLn;
    END;

     HKe.DisposePersID (persID);

 END VtreZuHK;


 PROCEDURE VtreExistVtrZuHK;
 VAR idString, suchHK: TString;
     persID : TPersID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("**************** Operation: Vtre.ExistVtrZuHK *******************");
   WriteLn;

     WriteString ("PersID der Hilfskraft eingeben:");
     suchHK := String.Create ();
     StringEingeben (suchHK);
     persID := HKe.StringInPersID (suchHK);

     IF Vtre.ExistVtrZuHK (persID)
     THEN
        WriteString ("->Vertrag zu HK existiert"); WriteLn;
     ELSE
        WriteString ("-> Vertrag zu HK nicht gefunden");
     END;

 END VtreExistVtrZuHK;


 PROCEDURE VtreZuHKinZtpkt;
 VAR idString, suchHK, datumString, outMessage : TString;
     datum : TDatum;
     persID : TPersID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("* Operationen: Vtre.FirstVtrZuHKinZeitpunkt, NextVtrZuHKinZeitpunkt *");
   WriteLn;

     WriteString ("PersID der Hilfskraft eingeben:");
     suchHK := String.Create ();
     StringEingeben (suchHK);
     persID := HKe.StringInPersID (suchHK);

     WriteString ("Zeitpunkt eingeben:");
     datumString := String.Create ();
     StringEingeben (datumString);

     outMessage := String.Create();

     IF DatumVonString (datumString, datum, outMessage)
     THEN
       IF Vtre.FirstVtrZuHKinZeitpunkt (persID, datum, aktVtr)
       THEN
         aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
         idString := Vtre.VtrIDAlsString (aktVtrID);;
         String.Lies (idString, arrayofchar);
         WriteString ("-> Vertraege gefunden. VtrID ist: ");
         WriteString (arrayofchar);
         Vtre.DisposeVtrID (aktVtrID);
         String.Dispose (idString);

         WHILE Vtre.NextVtrZuHKinZeitpunkt (persID, datum, aktVtr) DO
            aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
            idString := Vtre.VtrIDAlsString (aktVtrID);;
            String.Lies (idString, arrayofchar);
            WriteString (", ");
            WriteString (arrayofchar);
            Vtre.DisposeVtrID (aktVtrID);
            String.Dispose (idString);
         END; (* WHILE *)
         WriteLn;

      ELSE
        WriteString ("-> Kein Vertrag zu Datum und Hilfskraft gefunden");
        WriteLn;
      END;

      HKe.DisposePersID (persID);
     ELSE
        WriteString ("-> Ungueltiges Datum eingegeben");
        WriteLn;
     END;

 END VtreZuHKinZtpkt;



 PROCEDURE VtreZuHKinZtraum;
 VAR idString, suchHK, vondatumString, bisdatumString, outMessage : TString;
     vondatum, bisdatum : TDatum;
     persID : TPersID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("* Operationen: Vtre.FirstVtrZuHKinZeitraum, NextVtrZuHKinZeitraum *");
   WriteLn;

     WriteString ("PersID der Hilfskraft eingeben:");
     suchHK := String.Create ();
     StringEingeben (suchHK);
     persID := HKe.StringInPersID (suchHK);

     WriteString ("Zeitraum-Anfang eingeben:");
     vondatumString := String.Create();
     StringEingeben (vondatumString);

     WriteString ("Zeitraum-Ende eingeben:");
     bisdatumString := String.Create();
     StringEingeben (bisdatumString);



     (* vondatum := CreateDatum();
     bisdatum := CreateDatum(); *)
     outMessage := String.Create();

     IF DatumVonString (vondatumString, vondatum, outMessage) AND
        DatumVonString (bisdatumString, bisdatum, outMessage)
     THEN
       IF Vtre.FirstVtrZuHKinZeitraum (persID, vondatum, bisdatum, aktVtr)
       THEN
         aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
         idString := Vtre.VtrIDAlsString (aktVtrID);;
         String.Lies (idString, arrayofchar);
         WriteString ("-> Vertraege gefunden. VtrID ist: ");
         WriteString (arrayofchar);
         Vtre.DisposeVtrID (aktVtrID);
         String.Dispose (idString);

         WHILE Vtre.NextVtrZuHKinZeitraum (persID, vondatum,
                                           bisdatum, aktVtr) DO
            aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
            idString := Vtre.VtrIDAlsString (aktVtrID);;
            String.Lies (idString, arrayofchar);
            WriteString (", ");
            WriteString (arrayofchar);
            Vtre.DisposeVtrID (aktVtrID);
            String.Dispose (idString);
         END;
         WriteLn;

      ELSE
        WriteString ("-> Kein Vertrag zu Zeitraum gefunden");
        WriteLn;
      END;

      HKe.DisposePersID (persID);
     ELSE
        WriteString ("-> Ungueltiges Datum eingegeben");
        WriteLn;
     END;

 END VtreZuHKinZtraum;



 PROCEDURE VtreZuKst;
 VAR idString, suchKst: TString;
     aktKstID : TKstID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("*********** Operationen: Vtre.FirstVtrZuKst, NextVtrZuKst ***********");
   WriteLn;

     WriteString ("KstID der Kostenstelle eingeben:");
     suchKst := String.Create ();
     StringEingeben (suchKst);

     aktKstID := Ksten.StringInKstID (suchKst);

     IF Vtre.FirstVtrZuKst (aktKstID, aktVtr)
       THEN
         aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
         idString := Vtre.VtrIDAlsString (aktVtrID);;
         String.Lies (idString, arrayofchar);
         WriteString ("-> Vertraege gefunden. VtrID ist: ");
         WriteString (arrayofchar);
         Vtre.DisposeVtrID (aktVtrID);
         String.Dispose (idString);

         WHILE Vtre.NextVtrZuKst (aktKstID, aktVtr) DO

            aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
            idString := Vtre.VtrIDAlsString (aktVtrID);;
            String.Lies (idString, arrayofchar);
            WriteString (", ");
            WriteString (arrayofchar);
            Vtre.DisposeVtrID (aktVtrID);
            String.Dispose (idString);
         END; (* WHILE *)
         WriteLn;

      ELSE
        WriteString ("-> Fehler: Gesuchter Vertrag nicht gefunden");
        WriteLn;
      END;
     Ksten.DisposeKstID (aktKstID);
 END VtreZuKst;


 PROCEDURE VtreZuKstInZeitraum;
 VAR idString, suchKst, vondatumString, bisdatumString, outMessage: TString;
     aktKstID : TKstID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     vondatum, bisdatum : TDatum;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("* Operationen: Vtre.FirstVtrZuKstinZeitraum, NextVtrZuKstinZeitraum *");
   WriteLn;

     WriteString ("KstID der Kostenstelle eingeben:");
     suchKst := String.Create ();
     StringEingeben (suchKst);

     aktKstID := Ksten.StringInKstID (suchKst);


     WriteString ("Zeitraum-Anfang eingeben:");
     vondatumString := String.Create();
     StringEingeben (vondatumString);

     WriteString ("Zeitraum-Ende eingeben:");
     bisdatumString := String.Create();
     StringEingeben (bisdatumString);


   IF DatumVonString (vondatumString, vondatum, outMessage) AND
      DatumVonString (bisdatumString, bisdatum, outMessage)
     THEN
       IF Vtre.FirstVtrZuKstinZeitraum (aktKstID, vondatum, bisdatum, aktVtr)
       THEN
         aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
         idString := Vtre.VtrIDAlsString (aktVtrID);;
         String.Lies (idString, arrayofchar);
         WriteString ("-> Vertraege gefunden. VtrID ist: ");
         WriteString (arrayofchar);
         Vtre.DisposeVtrID (aktVtrID);
         String.Dispose (idString);

         WHILE Vtre.NextVtrZuKstinZeitraum (aktKstID, vondatum,
                                            bisdatum, aktVtr)
         DO
            aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
            idString := Vtre.VtrIDAlsString (aktVtrID);;
            String.Lies (idString, arrayofchar);
            WriteString (", ");
            WriteString (arrayofchar);
            Vtre.DisposeVtrID (aktVtrID);
            String.Dispose (idString);
         END;  (* WHILE *)
         WriteLn;
         Vtre.DisposeVtr (aktVtr);
      ELSE
        WriteString ("-> Fehler: Gesuchter Vertrag nicht gefunden");
        WriteLn;
      END;
     DisposeDatum (vondatum);
     DisposeDatum (bisdatum);
   END; (* IF DatumVonString *)
   Ksten.DisposeKstID (aktKstID);
   String.Dispose (suchKst);
   String.Dispose (vondatumString);
   String.Dispose (bisdatumString);
 END VtreZuKstInZeitraum;


 PROCEDURE VtreLfdAusgeben;
 VAR aktVtr : TVtr;
     aktVtrID : TVtrID;
     idString : TString;
     arrayofchar : ARRAY [1..255] OF CHAR;
 BEGIN

   WriteString("*********** Operationen: Vtre.FirstVtr, NextVtr *****************");
   WriteLn;

   IF Vtre.FirstVtr (aktVtr)
   THEN
     aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
     idString := Vtre.VtrIDAlsString (aktVtrID);
     String.Lies (idString, arrayofchar);
     WriteString ("-> Vertraege gefunden. VtrID ist: ");
     WriteString (arrayofchar);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);

     WHILE Vtre.NextVtr (aktVtr) DO
        aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
        idString := Vtre.VtrIDAlsString (aktVtrID);
        String.Lies (idString, arrayofchar);
        WriteString (", ");
        WriteString (arrayofchar);
        Vtre.DisposeVtrID (aktVtrID);
        String.Dispose (idString);
     END; (* WHILE *)
     WriteLn;

     Vtre.DisposeVtr (aktVtr);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);
  ELSE
    WriteString ("-> Fehler: Gesuchter Vertrag nicht gefunden");
    WriteLn;
  END;
 END VtreLfdAusgeben;


 PROCEDURE VtreLfdAbDatumAusgeben;
 VAR aktVtr : TVtr;
     aktVtrID : TVtrID;
     datum : TDatum;
     idString, datumString, outMessage : TString;
     arrayofchar : ARRAY [1..255] OF CHAR;
 BEGIN

   WriteString("****** Operationen: Vtre.FirstVldVtrAbDatum, NextVldVtrAbDatum ******");
   WriteLn;

   WriteString ("Datum eingeben:");
   datumString := String.Create();
   StringEingeben (datumString);


   IF DatumVonString (datumString, datum, outMessage) THEN

   IF Vtre.FirstVldVtrAbDatum (datum, aktVtr)
   THEN
     aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
     idString := Vtre.VtrIDAlsString (aktVtrID);
     String.Lies (idString, arrayofchar);
     WriteString ("-> Vertraege gefunden. VtrID ist: ");
     WriteString (arrayofchar);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);

     WHILE Vtre.NextVldVtrAbDatum (datum, aktVtr) DO
        aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
        idString := Vtre.VtrIDAlsString (aktVtrID);
        String.Lies (idString, arrayofchar);
        WriteString (", ");
        WriteString (arrayofchar);
        Vtre.DisposeVtrID (aktVtrID);
        String.Dispose (idString);
     END; (* WHILE *)
     WriteLn;

     Vtre.DisposeVtr (aktVtr);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);
  ELSE
    WriteString ("-> Fehler: Gesuchter Vertrag nicht gefunden");
    WriteLn;
  END;

  ELSE
    WriteString ("-> Ungueltiges Datum eingegeben");
    WriteLn;
  END;

 END VtreLfdAbDatumAusgeben;



 PROCEDURE VtreLfdInZeitraumAusgeben;
 VAR aktVtr : TVtr;
     aktVtrID : TVtrID;
     idString, vondatumString, bisdatumString, outMessage : TString;
     vondatum, bisdatum : TDatum;
     arrayofchar : ARRAY [1..255] OF CHAR;
 BEGIN

   WriteString("****** Operationen: Vtre.FirstVtrImZeitraum, NextVtrImZeitraum ******");
   WriteLn;

     WriteString ("Zeitraum-Anfang eingeben:");
     vondatumString := String.Create();
     StringEingeben (vondatumString);

     WriteString ("Zeitraum-Ende eingeben:");
     bisdatumString := String.Create();
     StringEingeben (bisdatumString);


   IF DatumVonString (vondatumString, vondatum, outMessage) AND
      DatumVonString (bisdatumString, bisdatum, outMessage)
     THEN

   IF Vtre.FirstVtrImZeitraum (vondatum, bisdatum, aktVtr)
   THEN
     aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
     idString := Vtre.VtrIDAlsString (aktVtrID);
     String.Lies (idString, arrayofchar);
     WriteString ("-> Vertraege gefunden. VtrID ist: ");
     WriteString (arrayofchar);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);

     WHILE Vtre.NextVtrImZeitraum (vondatum, bisdatum, aktVtr) DO
        aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
        idString := Vtre.VtrIDAlsString (aktVtrID);
        String.Lies (idString, arrayofchar);
        WriteString (", ");
        WriteString (arrayofchar);
        Vtre.DisposeVtrID (aktVtrID);
        String.Dispose (idString);
     END; (* WHILE *)
     WriteLn;

     Vtre.DisposeVtr (aktVtr);
     Vtre.DisposeVtrID (aktVtrID);
     String.Dispose (idString);
  ELSE
    WriteString ("-> Fehler: Gesuchter Vertrag nicht gefunden");
    WriteLn;
  END; (* Vtre.FirstVtrImZeitraum *)

  String.Dispose (vondatumString);
  String.Dispose (bisdatumString);
  String.Dispose (outMessage);
  DisposeDatum (vondatum);
  DisposeDatum (bisdatum);
  ELSE
    WriteString ("-> Ungueltiges Datum eingegeben");
    WriteLn;
  END;

 END VtreLfdInZeitraumAusgeben;


 PROCEDURE VtreLfdZuHK;
 VAR idString, suchHK, eins, zwei, outMessage : TString;
     vondatum, bisdatum : TDatum;
     persID : TPersID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("****** Operationen: Vtre.FirstValidVtrZuHK, NextValidVtrZuHK  ******");
   WriteLn;

     WriteString ("PersID der Hilfskraft eingeben:");
     suchHK := String.Create ();
     StringEingeben (suchHK);
     persID := HKe.StringInPersID (suchHK);

     IF Vtre.FirstValidVtrZuHK (persID, aktVtr)
     THEN
         aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
         idString := Vtre.VtrIDAlsString (aktVtrID);;
         String.Lies (idString, arrayofchar);
         WriteString ("-> Vertraege gefunden. VtrID ist: ");
         WriteString (arrayofchar);
         Vtre.DisposeVtrID (aktVtrID);
         String.Dispose (idString);

         WHILE Vtre.NextValidVtrZuHK (persID, aktVtr) DO
            aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
            idString := Vtre.VtrIDAlsString (aktVtrID);;
            String.Lies (idString, arrayofchar);
            WriteString (", ");
            WriteString (arrayofchar);
            Vtre.DisposeVtrID (aktVtrID);
            String.Dispose (idString);
         END;
         WriteLn;

    ELSE
        WriteString ("-> Kein Vertrag zu HK gefunden");
        WriteLn;
    END;

      HKe.DisposePersID (persID);
      String.Dispose (suchHK);
      String.Dispose (eins);
      String.Dispose (zwei);
 END VtreLfdZuHK;


 PROCEDURE VtreLfdZuHKinZtraum;
 VAR idString, suchHK, vondatumString, bisdatumString, outMessage : TString;
     vondatum, bisdatum : TDatum;
     persID : TPersID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("* Operationen: Vtre.FirstVldVtrZuHKinZtraum, NextVldVtrZuHKinZtraum  *");
   WriteLn;

     WriteString ("PersID der Hilfskraft eingeben:");
     suchHK := String.Create ();
     StringEingeben (suchHK);
     persID := HKe.StringInPersID (suchHK);

     WriteString ("Zeitraum-Anfang eingeben:");
     vondatumString := String.Create();
     StringEingeben (vondatumString);

     WriteString ("Zeitraum-Ende eingeben:");
     bisdatumString := String.Create();
     StringEingeben (bisdatumString);

     outMessage := String.Create();

     IF DatumVonString (vondatumString, vondatum, outMessage) AND
        DatumVonString (bisdatumString, bisdatum, outMessage)
     THEN
       IF Vtre.FirstVldVtrZuHKinZtraum (persID, vondatum, bisdatum, aktVtr)
       THEN
         aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
         idString := Vtre.VtrIDAlsString (aktVtrID);;
         String.Lies (idString, arrayofchar);
         WriteString ("-> Vertraege gefunden. VtrID ist: ");
         WriteString (arrayofchar);
         Vtre.DisposeVtrID (aktVtrID);
         String.Dispose (idString);

         WHILE Vtre.NextVldVtrZuHKinZtraum (persID, vondatum,
                                           bisdatum, aktVtr) DO
            aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
            idString := Vtre.VtrIDAlsString (aktVtrID);;
            String.Lies (idString, arrayofchar);
            WriteString (", ");
            WriteString (arrayofchar);
            Vtre.DisposeVtrID (aktVtrID);
            String.Dispose (idString);
         END;
         WriteLn;

      ELSE
        WriteString ("-> Kein Vertrag zu Zeitraum gefunden");
        WriteLn;
      END;

      HKe.DisposePersID (persID);
     ELSE
        WriteString ("-> Ungueltiges Datum eingegeben");
        WriteLn;
     END;

 END VtreLfdZuHKinZtraum;


 PROCEDURE VtreLfdZuHKinZtpkt;
 VAR idString, suchHK, datumString, outMessage : TString;
     datum : TDatum;
     persID : TPersID;
     aktVtr : TVtr;
     aktVtrID : TVtrID;
     arrayofchar : ARRAY [1..255] OF CHAR;
     OK : BOOLEAN;
 BEGIN

   WriteString("* Operationen: Vtre.FirstVldVtrZuHKinZtpunkt, NextVldVtrZuHKinZtpunkt *");
   WriteLn;

     WriteString ("PersID der Hilfskraft eingeben:");
     suchHK := String.Create ();
     StringEingeben (suchHK);
     persID := HKe.StringInPersID (suchHK);

     WriteString ("Zeitpunkt eingeben:");
     suchHK := String.Create ();
     StringEingeben (datumString);

     IF DatumVonString (datumString, datum, outMessage)
     THEN
       IF Vtre.FirstVldVtrZuHKinZtpunkt (persID, datum, aktVtr)
       THEN
         aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
         idString := Vtre.VtrIDAlsString (aktVtrID);;
         String.Lies (idString, arrayofchar);
         WriteString ("-> Vertraege gefunden. VtrID ist: ");
         WriteString (arrayofchar);
         Vtre.DisposeVtrID (aktVtrID);
         String.Dispose (idString);

         WHILE Vtre.NextVldVtrZuHKinZtpunkt (persID, datum, aktVtr) DO
            aktVtrID := Vtre.LiesVtrIDinVtr (aktVtr);
            idString := Vtre.VtrIDAlsString (aktVtrID);;
            String.Lies (idString, arrayofchar);
            WriteString (", ");
            WriteString (arrayofchar);
            Vtre.DisposeVtrID (aktVtrID);
            String.Dispose (idString);
         END; (* WHILE *)
         WriteLn;

      ELSE
        WriteString ("-> Kein Vertrag zu Datum gefunden");
        WriteLn;
      END;

      HKe.DisposePersID (persID);
     ELSE
        WriteString ("-> Ungueltiges Datum eingegeben");
        WriteLn;
     END;

 END VtreLfdZuHKinZtpkt;


 PROCEDURE VtrAnlegen;
 VAR persID : TPersID;
     kstID : TKstID;
     vonDatum, bisDatum, stornoDatum : TDatum;
     gueltigVon_str, gueltigBis_str, stornoDatum_str, persID_str, kstID_str,
     outMessage, outMessage1, outMessage2 : TString;
     stdZahl : CARDINAL;
     ok1, ok2, egal : BOOLEAN;
 BEGIN

   WriteString ("PersID der Hilfskraft eingeben:");
   persID_str := String.Create ();
   StringEingeben (persID_str);
   IF HKe.PruefePersID (persID_str, outMessage1) THEN
      persID := HKe.StringInPersID (persID_str);
      ok1 := TRUE;
   ELSE
      WriteString ("-> Fehler: "); StringAusgeben (outMessage1);
      String.Dispose (outMessage1);
      ok1 := FALSE;
   END;

   WriteString ("KstID der Kostenstelle eingeben:");
   kstID_str := String.Create ();
   StringEingeben (kstID_str);
   IF ok1 THEN
      IF Ksten.PruefeKstID (kstID_str, outMessage2) THEN
         kstID := Ksten.StringInKstID (kstID_str);
         ok2 := TRUE;
      ELSE
         WriteString ("-> Fehler: "); StringAusgeben (outMessage2);
         ok2 := FALSE;
         String.Dispose (outMessage2);
      END;
   END;

   WriteString ("VertragsAnfang eingeben:");
   gueltigVon_str := String.Create();
   StringEingeben (gueltigVon_str);

   WriteString ("VertragsEnde eingeben:");
   gueltigBis_str := String.Create();
   StringEingeben (gueltigBis_str);

   stornoDatum_str := String.Create();
   String.Schreibe (stornoDatum_str, "undef");
   egal := DatumVonString (stornoDatum_str, stornoDatum, outMessage);

   IF ok1 AND ok2 AND
      DatumVonString (gueltigVon_str, vonDatum, outMessage) AND
      DatumVonString (gueltigBis_str, bisDatum, outMessage)
   THEN
      CreateVtrAndInsert (persID, kstID, vonDatum, bisDatum, stornoDatum, 25);
      DisposeDatum (vonDatum);
      DisposeDatum (bisDatum);
   ELSE
      String.Dispose (outMessage);
   END;

   String.Dispose (persID_str);
   String.Dispose (kstID_str);
   String.Dispose (gueltigVon_str);
   String.Dispose (gueltigBis_str);
   String.Dispose (stornoDatum_str);

   DisposeDatum (stornoDatum);

   IF ok1 THEN
      HKe.DisposePersID (persID);
   END;

   IF ok2 THEN
      Ksten.DisposeKstID (kstID);
   END;

 END VtrAnlegen;

 PROCEDURE VtrAendern;
 VAR gueltigbis : TDatum;
     gueltigbis_str, vtrid_str, outMessage : TString;
     vtrid : TVtrID;
     aktVtr : TVtr;
 BEGIN

   WriteString ("VertragsID eingeben:");
   vtrid_str := String.Create();
   StringEingeben (vtrid_str);

   IF Vtre.PruefeVtrID (vtrid_str, outMessage) THEN

      vtrid := Vtre.StringInVtrID (vtrid_str);

      WriteString ("Neues VertragsEnde eingeben:");
      gueltigbis_str := String.Create();
      StringEingeben (gueltigbis_str);

      IF DatumVonString (gueltigbis_str, gueltigbis, outMessage) THEN

         IF Vtre.SearchVtr (vtrid, aktVtr) THEN
            Vtre.SetzeGueltigBisinVtr (aktVtr, gueltigbis);
            IF Vtre.AendernVtr (aktVtr, outMessage) THEN
               WriteString ("Vertrag erfolgreich im Ordner gendert");
               WriteLn;
            ELSE
               WriteString ("-> Fehler: "); StringAusgeben (outMessage);
               WriteLn;
               String.Dispose (outMessage);
            END;

         ELSE
           WriteString ("-> Fehler: ");
           StringAusgeben (outMessage);
           WriteLn;
           String.Dispose (outMessage);
         END;

      ELSE
         WriteString ("-> Fehler: "); StringAusgeben (outMessage); WriteLn;
         String.Dispose (outMessage);
      END;

   ELSE
      WriteString ("-> Fehler: "); StringAusgeben (outMessage); WriteLn;
      String.Dispose (outMessage);
   END;

 END VtrAendern;



 PROCEDURE VtreStringInVtrID;
 VAR wert : CARDINAL;
     arrayofchar : ARRAY [1..255] OF CHAR;
     result : ConvResults;
     erfolgreich : BOOLEAN;
     outMessage, idString : TString;
     aktVtrID : TVtrID;
 BEGIN

   WriteString("*************** Operationen: Vtre.StringInVtrID ***********************");
   WriteLn;

     WriteString ("VtrID  eingeben:");
     idString := String.Create ();
     StringEingeben (idString);
     IF Vtre.PruefeVtrID (idString, outMessage)
     THEN
       WriteString ("-> Format und Wert des Strings ist OK");
       WriteLn;
       aktVtrID := Vtre.StringInVtrID (idString);
       WriteString ("-> ADO VtrID erfolgreich erzeugt");
       WriteLn;
       Vtre.DisposeVtrID (aktVtrID);
     ELSE
       WriteString ("-> Konvertierungsfehler: ");
       String.Lies (outMessage, arrayofchar);
       WriteString (arrayofchar);
       WriteLn;
     END; (* IF *)
     String.Dispose (idString);
     String.Dispose (outMessage);
 END VtreStringInVtrID;


 PROCEDURE VtreStorno;
 VAR wert : CARDINAL;
     arrayofchar : ARRAY [1..255] OF CHAR;
     result : ConvResults;
     egal : BOOLEAN;
     outMessage, idString, outmessage2, outmessage3, stornodatum : TString;
     aktVtrID : TVtrID;
     aktVtr : TVtr;
     datum : TDatum;
 BEGIN

   WriteString("*********** Operationen: Vtre.SetzeStornoInVtr, AendernVtr ************");
   WriteLn;

     WriteString ("VtrID eingeben:");
     idString := String.Create ();
     StringEingeben (idString);
     IF Vtre.PruefeVtrID (idString, outMessage)
     THEN
       aktVtrID := Vtre.StringInVtrID (idString);
       IF Vtre.SearchVtr (aktVtrID, aktVtr) THEN
          WriteString ("Storno-Datum eingeben:");
          stornodatum := String.Create ();
          StringEingeben (stornodatum);

          IF DatumVonString (stornodatum, datum, outmessage2) THEN
             egal := Vtre.SetzeStornoAminVtr (aktVtr, datum);
             IF Vtre.AendernVtr (aktVtr, outmessage3) THEN
                WriteString ("Vertrag erfolgreich storniert");
                WriteLn;
             ELSE
                WriteString ("Fehler beim Aendern im Ordner");
                WriteLn;
                String.Dispose (outmessage3);
             END; (* IF Vtre.Aendern *)
          ELSE
            WriteString ("-> Konvertierungsfehler Datum");
          END; (* IF DatumVonString *)
          Vtre.DisposeVtrID (aktVtrID);
          Vtre.DisposeVtr (aktVtr);
          String.Dispose (outmessage2);
     ELSE
       WriteString ("-> Konvertierungsfehler VtrID ");
       String.Lies (outMessage, arrayofchar);
       WriteString (arrayofchar);
       WriteLn;
     END; (* IF SearchVtr *)
   END; (* IF Vtre.PruefVtrID *)

     String.Dispose (idString);
     String.Dispose (outMessage);

 END VtreStorno;


 PROCEDURE VtrePruefen;
 VAR outMessage, idString : TString;
     aktVtrID : TVtrID;
     aktVtr : TVtr;
     datum, heute : TDatum;
 BEGIN

   WriteString("* Operationen: Vtre.IstNochNichtLfdVtr, IstAbgelaufenVtr,                *");
   WriteString("*              IstLfdVtr, BeginntNotImLfdJahr                            *");
   WriteLn;

     heute := LiesSystemDatumInSysDat();

     WriteString ("VtrID eingeben:");
     idString := String.Create ();
     StringEingeben (idString);
     IF Vtre.PruefeVtrID (idString, outMessage)
     THEN
       aktVtrID := Vtre.StringInVtrID (idString);
       IF Vtre.SearchVtr (aktVtrID, aktVtr) THEN

          IF Vtre.IstNochNichtLfdVtr (aktVtr) THEN
             WriteString ("-> Vertrag ist noch nicht laufend");
             WriteLn;
          ELSE
             WriteString ("-> Vertrag ist NICHT noch nicht laufend");
             WriteLn;
          END; (* IF Vtre.IstAbgelaufenVtr *)


          IF Vtre.IstAbgelaufenVtr (aktVtr) THEN
             WriteString ("-> Vertrag ist abgelaufen");
             WriteLn;
          ELSE
             WriteString ("-> Vertrag ist noch nicht abgelaufen");
             WriteLn;
          END; (* IF Vtre.IstAbgelaufenVtr *)

          IF Vtre.IstLfdVtr (aktVtr, heute) THEN
             WriteString ("-> Vertrag ist laufend");
             WriteLn;
          ELSE
             WriteString ("-> Vertrag ist nicht laufend");
             WriteLn;
          END; (* IF Vtre.IstAbgelaufenVtr *)

          IF Vtre.BeginntNotImLfdJahr (aktVtr) THEN
             WriteString ("-> Vertrag beginnt nicht im lfd. Jahr");
             WriteLn;
          ELSE
             WriteString ("-> Vertrag beginnt im lfd. Jahr");
             WriteLn;
          END; (* IF Vtre.IstAbgelaufenVtr *)

       ELSE
          WriteString ("-> Vertrag nicht gefunden");
          WriteLn;
       END; (* IF Vtre.SearchVtr *)
       String.Dispose (outMessage);
       Vtre.DisposeVtr (aktVtr);
       Vtre.DisposeVtrID (aktVtrID);
     ELSE
        WriteString ("-> Konvertierungsfehler VtrID");
        WriteLn;
     END; (* IF Vtre.PruefeVtrID *)

     DisposeDatum (heute);
     String.Dispose (idString);

 END VtrePruefen;


 PROCEDURE VtreIsEqualVtrDaten;
 VAR outMessage, id1String, id2String : TString;
     aktVtrID1, aktVtrID2 : TVtrID;
     aktVtr1, aktVtr2 : TVtr;
     pruefeID1, pruefeID2 : BOOLEAN;
 BEGIN

   WriteString("* Operationen: Vtre.IsEqualVtrDaten                *");
   WriteLn;WriteLn;

   WriteString ("1. VtrID eingeben:");
   id1String := String.Create ();
   StringEingeben (id1String);
   pruefeID1 :=  Vtre.PruefeVtrID (id1String, outMessage);
   IF NOT pruefeID1
   THEN
     String.Dispose (outMessage);
     WriteString ("-> Fehler: 1. VertagsID kann nicht konvertiert werden");
     WriteLn;
   ELSE
     WriteString ("2. VtrID eingeben:");
     id2String := String.Create ();
     StringEingeben (id2String);
     pruefeID2 :=  Vtre.PruefeVtrID (id2String, outMessage);
     IF NOT pruefeID2
     THEN
        String.Dispose (outMessage);
        WriteString ("-> Fehler: 2. VertagsID kann nicht konvertiert werden");
        WriteLn;
     END;
   END;

   IF pruefeID1 AND pruefeID2
   THEN
     aktVtrID1 := Vtre.StringInVtrID (id1String);
     aktVtrID2 := Vtre.StringInVtrID (id2String);

     IF Vtre.SearchVtr (aktVtrID1, aktVtr1) AND Vtre.SearchVtr (aktVtrID2, aktVtr2)
     THEN
       IF Vtre.IsEqualVtr (aktVtr1, aktVtr2)
       THEN
         WriteString ("-> Vertrge sind zustandsgleich");
         WriteLn;
       ELSE
         WriteString ("-> Vertrge sind NICHT zustandsgleich");
         WriteLn;
       END;

       IF Vtre.IsEqualVtrDaten (aktVtr1, aktVtr2)
       THEN
         WriteString ("-> Vertragsdaten sind zustandsgleich");
         WriteLn;
       ELSE
         WriteString ("-> Vertragsdaten sind NICHT zustandsgleich");
         WriteLn;
       END;

       Vtre.DisposeVtr (aktVtr1);
       Vtre.DisposeVtr (aktVtr2);
     END;

     Vtre.DisposeVtrID (aktVtrID1);
     Vtre.DisposeVtrID (aktVtrID2);
   END;
 END VtreIsEqualVtrDaten;

 PROCEDURE VtreBerMaxStd;
 VAR std : CARDINAL;
     outMessage, idString : TString;
     aktVtrID : TVtrID;
     aktVtr : TVtr;
     datum: TDatum;
 BEGIN

   WriteString("************** Operation: Vtre.BerMaxStdZahlDerHK ***************");
   WriteLn;

     WriteString ("VtrID eingeben:");
     idString := String.Create ();
     StringEingeben (idString);
     IF Vtre.PruefeVtrID (idString, outMessage)
     THEN
       aktVtrID := Vtre.StringInVtrID (idString);
       IF Vtre.SearchVtr (aktVtrID, aktVtr) THEN
          std := Vtre.BerMaxStdZahlDerHK (aktVtr);
          WriteString (" Max. Stundenzahl der HK ist: ");
          WriteCard (std,5);
          WriteLn;
       ELSE
          WriteString ("-> Vertrag nicht gefunden");
          WriteLn;
       END; (* IF Vtre.SearchVtr *)

       String.Dispose (outMessage);
       Vtre.DisposeVtr (aktVtr);
       Vtre.DisposeVtrID (aktVtrID);
    ELSE
       WriteString ("-> Konvertierungsfehler VtrID");
       WriteLn;
    END; (* IF Vtre.PruefeVtrID *)

 END VtreBerMaxStd;


  PROCEDURE VtreOrdnerSave();
  VAR  	H 	: VDat.THandleInVDat;
       	M 	: VDat.TModusInVDat;
	message : String.TString;
	Filename: String.TString;
  BEGIN
    WriteString("************* Operation: Vtre.SaveinVtre **********************");
    WriteLn;
    WriteString("Der gesamte Ordnerinhalt wird gespeichert:");
    WriteLn;
    M:=VDat.SetWriteInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"vertraege.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT Vtre.SaveinVtre(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("VertrgeOrdner ist gespeichert!");	
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END VtreOrdnerSave;


  PROCEDURE VtreOrdnerLoad();
  VAR   H       : VDat.THandleInVDat;
        M       : VDat.TModusInVDat;
        message : String.TString;
        Filename: String.TString;
  BEGIN
    WriteString("************* Operation: Vtre.LoadinVtre **********************");
    WriteLn;
    WriteString("Der Ordnerinhalt wird geladen:");
    WriteLn;
    M:=VDat.SetReadInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"vertraege.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT Vtre.LoadinVtre(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("VertrgeOrdner ist geladen!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END VtreOrdnerLoad;


(**********************************************************************************)
(* System                                                                         *)
(**********************************************************************************)

 PROCEDURE SystemSetzeDatum;
 VAR  systemdatum, outmessage1 : TString;
      datum : TDatum;
 BEGIN
   WriteString ("System-Datum eingeben:");
   systemdatum := String.Create ();
   StringEingeben (systemdatum);

   IF DatumVonString (systemdatum, datum, outmessage1) THEN
      SetzeSystemDatumInSysDat (datum);
      WriteString ("-> Systemdatum erfolgreich gesetzt");
      WriteLn;
      DisposeDatum (datum);
   ELSE
      WriteString ("-> Konvertierungsfehler Datum");
      WriteLn;
      String.Dispose (outmessage1);
   END; (* IF DatumVonString *)

   String.Dispose (systemdatum);
END SystemSetzeDatum;


(*******************************************************************************)
(*                    Hilfskraefte                                             *)
(*******************************************************************************)


 PROCEDURE HKEinfuegen;
 VAR aktHK : THK;
     outMessage : TString;
 BEGIN
   aktHK := HKe.CreateHK();
   IF HKe.InsertHK (aktHK, outMessage)
   THEN
    WriteString ("HK erfolgreich aufgenommen");
   ELSE
    WriteString ("HK konnte nicht erfolgreich aufgenommen werden");
    String.Dispose (outMessage);
   END;
 END HKEinfuegen;


(**********************************************************************************)
(* Oberflaeche                                                                    *)
(**********************************************************************************)

 PROCEDURE IhreWahl() : CARDINAL;
 VAR outEingabe : CARDINAL;
 BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
 END IhreWahl;


 PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
 BEGIN
    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;


 PROCEDURE Programmende;
 BEGIN
   WriteString("Programmende!");
   WriteLn
 END Programmende;

  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (VtreListeAusgeben);
    ProcEintragen (VtreAllesListeAusgeben);
    ProcEintragen (VtreAlleAusgeben);
    ProcEintragen (VtreZuHK);
    ProcEintragen (VtreExistVtrZuHK);
    ProcEintragen (VtreZuHKinZtpkt);
    ProcEintragen (VtreZuHKinZtraum);
    ProcEintragen (VtreZuKst);
    ProcEintragen (VtreZuKstInZeitraum);
    ProcEintragen (VtreLfdAusgeben);
    ProcEintragen (VtreLfdAbDatumAusgeben);
    ProcEintragen (VtreLfdInZeitraumAusgeben);
    ProcEintragen (VtreLfdZuHK);
    ProcEintragen (VtreLfdZuHKinZtraum);
    ProcEintragen (VtreLfdZuHKinZtpkt);
    ProcEintragen (VtreInit);
    ProcEintragen (VtrAnlegen);
    ProcEintragen (VtrAendern);
    ProcEintragen (VtreStringInVtrID);
    ProcEintragen (VtreStorno);
    ProcEintragen (VtrePruefen);
    ProcEintragen (VtreIsEqualVtrDaten);
    ProcEintragen (VtreBerMaxStd);
    ProcEintragen (VtreOrdnerSave);
    ProcEintragen (VtreOrdnerLoad);
    ProcEintragen (SystemSetzeDatum);
    ProcEintragen (HKEinfuegen);
    MaxProcNr := ProcNr;
  END InitTestProcs;


 PROCEDURE Auswahlmenue () : CARDINAL;
 VAR ItemNr : CARDINAL;

	PROCEDURE MenueItem (inItemText : ARRAY OF CHAR);
	BEGIN
	   WriteCard (ItemNr, 3);
	   WriteString (" --> ");
	   WriteString (inItemText);
	   WriteLn;
           INC (ItemNr);
	END MenueItem;

 BEGIN
   WriteLn;
   WriteString ("======= Testmenue : Lassen Sie es sich schmecken !===============");
   WriteLn;

   ItemNr := 0;
   MenueItem ("Programm beenden");
   MenueItem ("Spezifizierte StringListe ausgeben");
   MenueItem ("Test-         StringListe ausgeben");
   MenueItem ("ID's aller Vertrge listen");
   MenueItem ("ID's aller Vertrge zu einer HK listen");
   MenueItem ("Existiert Vertrag zu einer HK ?");
   MenueItem ("ID's aller Vertrge zu einer HK in Zeitpunkt listen");
   MenueItem ("ID's aller Vertrge zu einer HK in Zeitraum listen");
   MenueItem ("ID's aller Vertrge zu einer Kst listen");
   MenueItem ("ID's aller Vertrge zu einer Kst im Zeitraum listen");
   MenueItem ("ID's Vld. Vertrge listen");
   MenueItem ("ID's Vld. Vertrge ab Datum listen");
   MenueItem ("ID's Vld. Vertrge im Zeitraum listen");
   MenueItem ("ID's Vld. Vertrge zu HK listen");
   MenueItem ("ID's Vld. Vertrge zu HK in Zeitraum listen");
   MenueItem ("ID's Vld. Vertrge zu HK in Zeitpunkt listen");
   MenueItem ("Ordner mit Dummy Vertrgen fllen");
   MenueItem ("Vertrag manuell anlegen");
   MenueItem ("VertrageEnde manuell vorziehen");
   MenueItem ("String -> VtrID pruefen und erzeugen");
   MenueItem ("Vertrag stornieren");
   MenueItem ("Vertrge pruefen");
   MenueItem ("Vertrge vergleichen");
   MenueItem ("Maximale Stundenzahl der HK im Vertragszeitraum");
   MenueItem ("VertrgeOrdner auf Datei sichern");
   MenueItem ("VertrgeOrdner von Datei restaurieren");
   MenueItem ("System       : SystemDatum setzen");
   MenueItem ("HKe          : Hilfskraft einfuegen (IDVerwaltung!)");
   RETURN IhreWahl()
 END Auswahlmenue;


 PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..95] OF CHAR;
 BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
 END StringAusgeben;


 PROCEDURE StringEingeben (inoutStr : String.TString);
 VAR Wert : ARRAY [0..50] OF CHAR;
 BEGIN
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
 END StringEingeben;


 PROCEDURE KompletteListeAusgeben (Testliste : TStringliste);
    VAR AktuellesElement : String.TString;
 BEGIN
    Stringliste.GoStart (Testliste);
    WHILE NOT Stringliste.OffEnd(Testliste) DO
       AktuellesElement := Stringliste.Current(Testliste);
       StringAusgeben (AktuellesElement);
       String.Dispose (AktuellesElement);
       Stringliste.StepNext(Testliste)
    END; (* WHILE *)
    WriteLn;
    WriteString("Aktuelle Position: OffEnd!");
    WriteLn;
 END KompletteListeAusgeben;

BEGIN



  (*                    Programm                                          *)
  (*======================================================================*)

  InitTestProcs;

  REPEAT
    Befehl := Auswahlmenue();
    BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;

  WriteLn; WriteLn;
END VtreTesten.
