(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: vtreIMPORTE.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 16:28:06 $
# $Revision: 1.2 $     

IMPLEMENTATION MODULE VtreIMPORT   TS-Import-Schnittstelle Vertraege

Erstentwurf: Sigrid Preuss
Implementation: Schoenhammer Herbert

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE VtreIMPORTE;
                             (* IMPORT-Schnittstelle des TS Vertraege TS_Vtre *)

(* TS Vertraege *)

IMPORT SysDat;
IMPORT VDat;
IMPORT HKe;
IMPORT Ksten;
IMPORT HIDVerwaltung;

FROM String IMPORT TString;
FROM Datum IMPORT TDatum;


(* TS SysDat; Durchreichungen *)
(*===================================*)

PROCEDURE LiesSystemDatumInSysDat () : TDatum;
BEGIN
  RETURN SysDat.LiesSystemDatumInSysDat ()
END LiesSystemDatumInSysDat;

(* TS Hilfskraefte; Durchreichungen *)
(*===================================*)

PROCEDURE DuplicatePersID (inPersID : TPersID) : TPersID;
BEGIN
  RETURN HKe.DuplicatePersID (inPersID)
END DuplicatePersID;

PROCEDURE DisposePersID (VAR inoutPersID : TPersID);
BEGIN
  HKe.DisposePersID (inoutPersID)
END DisposePersID;

PROCEDURE IsEqualPersID (inPersID1, inPersID2 : TPersID) : BOOLEAN;
BEGIN
  RETURN HKe.IsEqualPersID (inPersID1, inPersID2)
END IsEqualPersID;

PROCEDURE EqualizePersID (inoutPersID1, inPersID2 : TPersID);
BEGIN
  HKe.EqualizePersID (inoutPersID1, inPersID2)
END EqualizePersID;

PROCEDURE PersIDAlsString (inPersID : TPersID) : TString;
BEGIN
   RETURN HKe.PersIDAlsString (inPersID)
END PersIDAlsString;

PROCEDURE StringInPersID (inString : TString) : TPersID;
BEGIN
   RETURN HKe.StringInPersID (inString)
END StringInPersID;

PROCEDURE PruefePersID (inString : TString; VAR outMessage : TString) : BOOLEAN;
BEGIN
   RETURN HKe.PruefePersID (inString, outMessage)
END PruefePersID;


(* TS Kostenstellen; Durchreichungen *)
(*===================================*)

PROCEDURE CreateKstID ( ) : TKstID;
BEGIN
   RETURN Ksten.CreateKstID ();
END CreateKstID;

PROCEDURE DuplicateKstID (inKstID : TKstID) : TKstID;
BEGIN
   RETURN Ksten.DuplicateKstID (inKstID)
END DuplicateKstID;

PROCEDURE DisposeKstID (VAR inoutKstID : TKstID);
BEGIN
   Ksten.DisposeKstID (inoutKstID);
END DisposeKstID;

PROCEDURE IsEqualKstID (inKstID1, inKstID2 : TKstID) : BOOLEAN;
BEGIN
   RETURN Ksten.IsEqualKstID (inKstID1, inKstID2)
END IsEqualKstID;

PROCEDURE EqualizeKstID (inoutKstID1, inKstID2 : TKstID);
BEGIN
   Ksten.EqualizeKstID (inoutKstID1, inKstID2)
END EqualizeKstID;

PROCEDURE KstIDAlsString (inKstID : TKstID) : TString;
BEGIN
   RETURN Ksten.KstIDAlsString (inKstID)
END KstIDAlsString;

PROCEDURE StringInKstID (inString : TString) : TKstID;
BEGIN
   RETURN Ksten.StringInKstID (inString)
END StringInKstID;

PROCEDURE PruefeKstID (inString : TString; VAR outMessage : TString) : BOOLEAN;
BEGIN
   RETURN Ksten.PruefeKstID (inString, outMessage)
END PruefeKstID;


(* Durchreichungen an das TS_VDat                                             *)
(*============================================================================*)


PROCEDURE ReadLineInVDat (inH:THandle; VAR inoutString : TString;
                          VAR inoutMessage : TString) : BOOLEAN;
BEGIN
   RETURN VDat.ReadLineInVDat (inH, inoutString, inoutMessage)
END ReadLineInVDat;


PROCEDURE WriteLineInVDat (inH:THandle; VAR inoutString : TString;
                          VAR inoutMessage : TString) : BOOLEAN;
BEGIN
   RETURN VDat.WriteLineInVDat (inH, inoutString, inoutMessage)
END WriteLineInVDat;


PROCEDURE EofInVDat (inH:THandle) : BOOLEAN;
BEGIN
   RETURN VDat.EofInVDat (inH);
END EofInVDat;


(* TS HIDVerwaltung; Durchreichungen *)
(*===================================*)


PROCEDURE HoleNeueHID () : TVtrID;
BEGIN
   RETURN HIDVerwaltung.HoleNeueID();
END HoleNeueHID;

PROCEDURE UeberlasseHID (inVtrID : TVtrID);
BEGIN
  HIDVerwaltung.UeberlasseAlteID(inVtrID);
END UeberlasseHID;

PROCEDURE DisposeHID (VAR inoutID : TVtrID);
BEGIN
   HIDVerwaltung.DisposeHID(inoutID);
END DisposeHID;

PROCEDURE DuplicateHID (inQuellVtrID : TVtrID) : TVtrID;
BEGIN
   RETURN HIDVerwaltung.DuplicateHID(inQuellVtrID);
END DuplicateHID;

PROCEDURE IsEqualHID (inVtrID1, inVtrID2 : TVtrID) : BOOLEAN;
BEGIN
   RETURN HIDVerwaltung.IsEqualHID(inVtrID1,inVtrID2);
END IsEqualHID;

PROCEDURE EqualizeHID (inoutZielVtrID, inQuellVtrID : TVtrID);
BEGIN
   HIDVerwaltung.EqualizeHID(inoutZielVtrID,inQuellVtrID);
END EqualizeHID;

PROCEDURE PruefeHID (inString : TString; VAR outMessage : TString):BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.PruefeHID (inString, outMessage);
END PruefeHID;

PROCEDURE LiesSeqNrHID (inVtrID : TVtrID) : CARDINAL;
BEGIN
   RETURN HIDVerwaltung.LiesSeqNrHID(inVtrID );
END LiesSeqNrHID;

PROCEDURE SameSeqNrHID (inVtrID1, inVtrID2 : TVtrID) : BOOLEAN;
BEGIN
   RETURN HIDVerwaltung.SameSeqNrHID(inVtrID1, inVtrID2);
END SameSeqNrHID;

PROCEDURE SmallerSeqNrHID (inVtrID1, inVtrID2 : TVtrID) : BOOLEAN;
BEGIN
   RETURN HIDVerwaltung.SmallerSeqNrHID (inVtrID1, inVtrID2);
END SmallerSeqNrHID;

PROCEDURE HID2Str( inID : TVtrID ; IDLaenge: CARDINAL): TString ;
BEGIN
   RETURN HIDVerwaltung.HID2Str(inID,IDLaenge);
END HID2Str;

PROCEDURE Str2HID( inStr: TString ): TVtrID ;
BEGIN
   RETURN HIDVerwaltung.Str2HID(inStr);
END Str2HID;

END VtreIMPORTE.






